{******************************************}
{                                          }
{             FastReport VCL               }
{           Syntax Memo control            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frSynMemo;

interface

{$I frVer.inc}

uses
  Classes, SysUtils, frTypes, frGraphicUtils, frBaseGraphicsTypes, frBaseMemo;

type
  TfrBaseSmartSyntaxMemo = class(TfrBaseSyntaxMemo)
  protected
    FHightlightingType: TfrxHightlightingsTypes;
    FWordWrap: Boolean;
    FUseDefaultCharset: Boolean;
    FExpressionDelimiters: String;
    FDPIScale: Single;
    FHAlign: TfrxHAlign;

    procedure SetWordWrap(val: Boolean); virtual; abstract;
  public
    property HightlightingType: TfrxHightlightingsTypes read FHightlightingType write FHightlightingType;
    property WordWrap: Boolean read FWordWrap write SetWordWrap;
    property UseDefaultCharset: Boolean read FUseDefaultCharset write FUseDefaultCharset;
    property RTLReading: Boolean read FRTLReading write FRTLReading;
    property ExpressionDelimiters: String read FExpressionDelimiters write FExpressionDelimiters;
    property DPIScale: Single read FDPIScale write FDPIScale;
    property HAlign: TfrxHAlign read FHAlign write FHAlign;
  end;

  TfrSyntaxMemoClass = class of TfrBaseSmartSyntaxMemo;

  TfrSyntaxMemoCollection = class
  private
    FList: TList;
    function GetItem(ANumber: Integer): TfrSyntaxMemoClass;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Add(AMemoClass: TfrSyntaxMemoClass);
    procedure Delete(AMemoClass: TfrSyntaxMemoClass);
    function Find(AMemoClass: TfrSyntaxMemoClass): Integer;
    function Count: Integer;
    function GetFirstItem: TfrSyntaxMemoClass;
    function GetLastItem: TfrSyntaxMemoClass;

    property Items[Index: Integer]: TfrSyntaxMemoClass read GetItem;
  end;

  function frSyntaxMemoCollection: TfrSyntaxMemoCollection;

implementation
end.
