unit frTreeViewEditor;

{$I frVer.inc}

interface

uses
{$IFNDEF LINUX}
  Windows,
{$ELSE}
  LCLType, LCLIntf,
{$ENDIF}
  Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls, ActnList,
  frControls, frTreeView, frBaseForm, frAppearance;

type

  { TfmTreeViewEditor }

  TfmTreeViewEditor = class(TfrBaseForm)
    pnlButtons: TPanel;
    gbItemProperties: TGroupBox;
    gbItems: TGroupBox;
    pnlItemButtons: TPanel;
    tvItems: TfrTreeView;
    btnNewItem: TButton;
    btnNewSubItem: TButton;
    btnDelete: TButton;
    btnLoad: TButton;
    btnApply: TButton;
    btnCancel: TButton;
    btnOk: TButton;
    lbText: TLabel;
    lbImageIndex: TLabel;
    lbSelectedIndex: TLabel;
    lbStateIndex: TLabel;
    lbExpandedIndex: TLabel;
    edText: TEdit;
    edImageIndex: TEdit;
    edSelectedIndex: TEdit;
    edStateIndex: TEdit;
    edExpandedIndex: TEdit;
    chbEnabled: TCheckBox;
    ActionList1: TActionList;
    actNewItem: TAction;
    actNewSubItem: TAction;
    actDelete: TAction;
    actLoad: TAction;
    odLoad: TOpenDialog;
    procedure tvItemsCollapsed(Sender: TObject; Node: TfrTreeViewNode);
    procedure tvItemsDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure tvItemsDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure tvItemsEdited(Sender: TObject; Node: TfrTreeViewNode; var S: string);
    procedure tvItemsExpanded(Sender: TObject; Node: TfrTreeViewNode);
    procedure tvItemsChange(Sender: TObject; Node: TfrTreeViewNode);
    procedure tvItemsKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure actNewItemExecute(Sender: TObject);
    procedure actNewSubItemExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actLoadExecute(Sender: TObject);
    procedure edTextChange(Sender: TObject);
    procedure edImageIndexExit(Sender: TObject);
    procedure edSelectedIndexExit(Sender: TObject);
    procedure edStateIndexExit(Sender: TObject);
    procedure edExpandedIndexExit(Sender: TObject);
    procedure chbEnabledClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
  strict private
    FTreeView: TfrCustomTreeView;
    FLastFocusedNode: TfrTreeViewNode;

    procedure DeleteFocusedNode;
    function GetFocusedNode: TfrTreeViewNode;
    procedure SetFocusedNode(AValue: TfrTreeViewNode);
    procedure UpdateStates;
  protected
    procedure Apply;
    procedure Initialize(ATreeView: TfrCustomTreeView);

    property FocusedNode: TfrTreeViewNode read GetFocusedNode write SetFocusedNode;
  end;

  function frEditTreeView(ATreeView: TfrCustomTreeView): Boolean;

implementation
end.
