{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{              Core Library                }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

{$IFNDEF FMX}
unit frCore;
{$ENDIF}

{$I frVer.inc}

interface

uses
{$IFDEF MSWINDOWS} Windows, {$ENDIF}
{$IFNDEF FMX}
  {$IFNDEF FPC} Types,{$ENDIF}
  Classes, SysUtils,
  {$IFDEF FPC} LCLType, {$ENDIF}
  frUnicodeUtils;
{$ELSE FMX}
  System.Classes, System.SysUtils, System.IOUtils,
{$IFDEF MACOS}
  Posix.Stdlib,
{$ENDIF MACOS}
  FMX.frUnicodeUtils;
{$ENDIF FMX}

const
  FR_VERSION = {$I frVersion.inc};
  FR_EPSILON = 1e-4;

type
{$IFDEF DELPHI29}
  TfrListInteger = NativeInt;
{$ELSE}
  TfrListInteger = Integer;
{$ENDIF}
  TfrHandle = THandle;
{$IFDEF DELPHI16}
  frInteger = NativeInt;
  frCardinal = NativeUInt;
{$ELSE}
  frInteger = {$IFDEF FPC}PtrInt{$ELSE}Integer{$ENDIF};
  frCardinal = {$IFDEF FPC}Cardinal{$ELSE}Cardinal{$ENDIF};
{$ENDIF}

const
{$IFNDEF FPC}
  AllFilesMask = '*';
  DirectorySeparator = PathDelim;
{$ENDIF}
  {$EXTERNALSYM SW_SHOWNORMAL}
  SW_SHOWNORMAL = 1;

  frTab = #9;
  frCRLF = #13#10;
  frMaxClipValue = 65535;

function frCapitalizeStr(const AValue: string; AAllWords: Boolean = True): string;
function frStrToAnsi(const AValue: string; ACodePage: Integer = 0): AnsiString;
function frStrToWStr(const AValue: string; ACodePage: Integer = 0): WideString;
function frWStrToStr(const AValue: WideString; ACodePage: Integer = 0): string;
function frAnsiToStr(const AValue: AnsiString; ACodePage: Integer = 0): string;
//
function frCRC32(Stream: TStream): Cardinal;
//
function frGetTempFileName(ATempDir, APrefix: String): String;
function frGetTemporaryFolder: String;
function frGetTempFile: String;
function frGetAppPath: string;
//
function frShellExecute(const AFileName: string; AShowCmd: Integer = SW_SHOWNORMAL): Boolean; overload;
function frShellExecute(const AFileName, ADirectory: string; AShowCmd: Integer = SW_SHOWNORMAL): Boolean; overload;
function frShellExecute(AHandle: TfrHandle; const AFileName: string; AShowCmd: Integer = SW_SHOWNORMAL): Boolean; overload;
function frShellExecute(AHandle: TfrHandle; const AFileName, ADirectory: string; AShowCmd: Integer = SW_SHOWNORMAL): Boolean; overload;
//
function frSeek(AStream: TStream; AOffset: Integer; AOrigin: Word): Int64;
//
procedure frSetCommaText(const Text: String; sl: TStrings; Comma: Char = ';');

implementation
end.
