{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{              Core Library                }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

{$IFNDEF FMX}
unit frCoreReg;
{$ENDIF}

{$I frVer.inc}

interface

uses
  SysUtils,
{$IFNDEF FPC}
  DesignEditors, DesignIntf,
{$ELSE}
  PropEdits, ComponentEditors,
{$ENDIF}
{$IFNDEF FMX}
  Types, Classes,
  frCore,
  frCoreClasses;
{$ELSE}
  System.Types, System.Classes,
  FMX.frCore,
  FMX.frCoreClasses;
{$ENDIF}

const
  frCompanyName = 'Fast Reports, Inc.';
  frCompanyURL = 'www.fast-report.com';
{$IFDEF FMX}
  frDefaultLibraryProductPage = 'FastReport FMX Components';
{$ELSE}
  {$IFDEF FPC}
    frDefaultLibraryProductPage = 'FastReport Components';
  {$ELSE}
    frDefaultLibraryProductPage = 'FastReport VCL Components';
  {$ENDIF}
{$ENDIF}

type
  TfrCustomPropertyEditor = class(TPropertyEditor);
  TfrCustomStringPropertyEditor = class(TStringProperty);

  { TfrChooserStringPropertyEditor }

  TfrChooserStringPropertyEditor = class(TfrCustomStringPropertyEditor)
  protected
    function DoGetValues: TStringDynArray; virtual; abstract;
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  { TfrComponentEditor }

  TfrComponentEditor = class(TComponentEditor)
  protected
    procedure DoExecuteVerb(AIndex: Integer); virtual;
    function DoGetVerb(AIndex: Integer): string; virtual;
    function DoGetVerbCount: Integer; virtual;
  public
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

{$IFNDEF FPC}
  { TfrComponentSelectionEditor }

  TfrComponentSelectionEditor = class(TSelectionEditor)
  public
    procedure RequiresUnits(Proc: TGetStrProc); override;
  end;
{$ENDIF}

procedure Register;

implementation
end.

