{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{              Core Library                }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frDPIAwareControls;

interface

{$I frVer.inc}

uses
  Classes, Controls;

type

  { TfrDPIAwareCustomControl }

  TfrDPIAwareCustomControl = class(TCustomControl)
  protected
    FCurrentPPI: Integer;

    procedure DoPPIChanged(aNewPPI: Integer); virtual;
    procedure PPIChanged(aNewPPI: Integer);

    procedure BeforePPIChange; virtual;
    procedure AfterPPIChange; virtual;
  public
    function GetReleativeScale: Single;
    function GetScale: Single;

    property CurrentPPI: Integer read FCurrentPPI write FCurrentPPI;
  end;

  TfrDPIAwareBaseControl = class(TfrDPIAwareCustomControl)
  protected
{$IFDEF FPC}
    procedure AutoAdjustLayout(AMode: TLayoutAdjustmentPolicy; const AFromPPI,
      AToPPI, AOldFormWidth, ANewFormWidth: Integer); override;
{$ENDIF}
  public
    constructor Create(AOwner: TComponent); override;
{$IFDEF DELPHI24}
    procedure ChangeScale(M: Integer; D: Integer; isDpiChange: Boolean); override;
{$ELSE}
    procedure ChangeScale(M, D: Integer); override;
{$ENDIF}
  end;

implementation
end.
