
{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{              Core Library                }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

{$IFNDEF FMX}
unit frGraphics;
{$ENDIF}

interface

{$I frVer.inc}

uses
{$IFNDEF FMX}
  {$IFNDEF FPC}
    Windows, CommCtrl,
  {$ELSE}
    LResources, LCLProc, LCLType, StdCtrls, LCLIntf,
  {$ENDIF}
  Types, SysUtils, Classes, Controls, Graphics, Buttons, ImgList,
  frCore, frCoreClasses, frDPIAwareUtils;
{$ELSE}
  System.Types, System.UITypes, System.SysUtils, System.Classes, System.Contnrs,
  {$IFDEF DELPHI19}
    FMX.Graphics,
  {$ENDIF}
  FMX.Types, FMX.Controls, FMX.frCore, FMX.frCoreClasses;
{$ENDIF}

const
  DefaultPPI = 96;
  DefaultToolBarImageWidth = 16;
  DefaultToolBarImageHeight = 16;
  DefaultLargeImageWidth = 32;
  DefaultLargeImageHeight = 32;

type
  { TfrBitmap }

  TfrBitmap = class(TBitmap)
  public
    constructor CreateSize(const ASize: TSize); overload;
    constructor CreateSize(AWidth, AHeight: Integer); overload;
  end;

{$IFNDEF FMX}
  procedure frMakeDisabledImage(ABitmap: TBitmap; ATransparentColor: TColor = clFuchsia);

  procedure frAssignImages(Bitmap: TBitmap; dx, dy: Integer;
    ImgList1: TImageList; ImgList2: TImageList = nil);

  procedure ScaleBitmap(aBitmap: TBitmap; aScreenPPI: Integer);

  procedure frImageListScaleDraw(ACanvas: TCanvas; AImageList: TCustomImageList; AImageIndex: Integer; const R: TRect); overload;
  procedure frImageListScaleDraw(ACanvas: TCanvas; AImageList: TCustomImageList; AImageIndex: Integer; P: TPoint; ANewSize: TSize); overload;
  procedure frImageListScaleDraw(ACanvas: TCanvas; AImageList: TCustomImageList; AImageIndex: Integer; P: TPoint; M, D: Integer); overload;

  procedure frLoadHiResImages(AImageList: TImageList; ASize: Integer; const AResName: string; AMaskColor: TColor = clFuchsia;
    ANumAsOne: Integer = 1; PPI: Integer = FR_DefaultPPI);
  procedure frLoadImageList(AImageList: TImageList; const AImageName: string; AMaskColor: TColor = clNone;
    ANumAsOne: Integer = 1; PPI: Integer = FR_DefaultPPI);
  function frLoadBitmap(const AResourceName: string): TBitmap; overload;
  procedure frLoadBitmap(ABitmap: TBitmap; const AResourceName: string); overload;
  function frGetFontMetrics(Font: TFont): TTextMetric;
  function frGetTextHeightByFont(Font: TFont): Integer;
{$ENDIF}
  procedure rePadding(MForm: TComponent);

implementation
end.
