
{******************************************}
{                                          }
{             FastReport VCL               }
{        GUI Thread Synchonization         }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frThreading;

interface

{$I frVer.inc}
uses
{$IFNDEF FPC}
  Windows, Messages,
{$ENDIF}
{$IFDEF FPC}
  LResources, LCLType, LMessages,
{$ENDIF}
  SysUtils, Classes;

{$IFNDEF FPC}
const
  WM_FRX_SYNC_THREAD = WM_USER + 250;
  WM_FRX_SYNC_MESSAGE = WM_USER + 251;

type

  TfrThreadSynchronizeProc = procedure (const AThread: TThread; AMethod: TThreadMethod);
  { TfrThreadSynchronizer }

  TfrThreadSynchronizer = class
  private
    FIsMain: Boolean;
    FWindowHandle: HWND;
    procedure WndProc(var Message: TMessage);
  public
    constructor Create;
    destructor Destroy; override;
    property WindowHandle: HWND read FWindowHandle;
  end;

  { TfrGuiThread }

  TfrGuiThread = class(TThread)
  protected
    procedure Execute; override;
  public
    constructor Create;
    destructor Destroy; override;
  end;

  function frGetThreadSynchronizer: TfrThreadSynchronizer;
  function frIsThreadSynchronizerActive: Boolean;
  function frSynchSendMessage(hWnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT;
{$ENDIF}
procedure frThreadSynchronize(Method: TThreadMethod);

var
{$IFNDEF FPC}
  frDisableThreadSynchronizer: Boolean;
  frThreadSynchronizeProc: TfrThreadSynchronizeProc;
{$ENDIF}
  frGUIThreadID: Cardinal;

implementation
end.
