{*******************************************************}
{    The Delphi Unicode Controls Project                }
{                                                       }
{      http://home.ccci.org/wolbrink                    }
{                                                       }
{         Copyright (c) 1998-2021          }
{                                                       }
{*******************************************************}

{$IFNDEF FMX}
unit frUnicodeUtils;
{$ENDIF}

{$I frVer.inc}
interface

uses
  Types,
  {$IFDEF MSWINDOWS}
    Windows,
  {$ENDIF}
  {$IFNDEF FPC}
    WideStrings,
  {$ENDIF}
  Classes, SysUtils;

{$IF NOT DEFINED(DELPHIVCL) AND NOT DEFINED(MSWINDOWS)}
const
  DEFAULT_CHARSET = 1;
  MAC_CHARSET = 77;
  OEM_CHARSET = 255;
  VIETNAMESE_CHARSET = 163;
  JOHAB_CHARSET = 130;
  CP_MACCP = 2;
  CP_OEMCP = 1;
{$IFEND}

{$IFNDEF FPC}
type
  TfrWideStrings = class(TWideStringList)
  private
    procedure ReadData(Reader: TReader);
    procedure ReadDataWOld(Reader: TReader);
    procedure ReadDataW(Reader: TReader);
    procedure WriteDataW(Writer: TWriter);
  protected
    procedure DefineProperties(Filer: TFiler); override;
    function Get(Index: Integer): WideString; override;
    function GetObject(Index: Integer): TObject; override;
    procedure Put(Index: Integer; const S: WideString); override;
    procedure PutObject(Index: Integer; AObject: TObject); override;
  public
    procedure InsertObject(Index: Integer; const S: WideString;
      AObject: TObject); override;
    procedure LoadFromWStream(Stream: TStream);
  end;
  TfrWideStringList = class(TfrWideStrings);

  function AnsiToUnicode(const s: AnsiString; Charset: LongWord; CodePage: Integer = 0): WideString;
  function _UnicodeToAnsi(const WS: WideString; Charset: LongWord; CodePage: Integer = 0): Ansistring;
{$ELSE}
type
  TWideStrings = class(TStringList);
  TWideStringList = class(TWideStrings);
  TfrWideStrings = class(TWideStringList);
  TfrWideStringList = class(TfrWideStrings);

  function AnsiToUnicode(const s: {$IFDEF FPCUNICODE}string{$ELSE}AnsiString{$ENDIF}; Charset: LongWord; CodePage: Integer = 0): {$IFDEF FPCUNICODE}String{$ELSE}AnsiString{$ENDIF};
  function _UnicodeToAnsi(const WS: {$IFDEF FPCUNICODE}string{$ELSE}WideString{$ENDIF}; Charset: LongWord; CodePage: Integer = 0): {$IFDEF FPCUNICODE}String{$ELSE}AnsiString{$ENDIF};
{$ENDIF}

function CharSetToCodePage(ciCharset: LongWord): Cardinal;

{$IFNDEF FMX}
  function OemToStr(const AnsiStr: {$IFDEF FPCUNICODE}string{$ELSE}AnsiString{$ENDIF}): {$IFDEF FPCUNICODE}string{$ELSE}AnsiString{$ENDIF};
  function GetLocalByCharSet(Charset: LongWord): Cardinal;
{$ENDIF}

implementation
end.
