unit uRichText;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls,
  ExtCtrls, frxClass, frxDesgn, frxDBSet, frxExportRTF, frxExportPDF, dbf, DB,
  frxRichLaz, uDemoMain;

type

  { TfrmRichEditMain }

  TfrmRichEditMain = class(TfrmDemoMain)
    Customers: TDbf;
    CustomersDS: TfrxDBDataset;
    CustomerSource: TDataSource;
    AnimalsSource: TDataSource;
    Animals: TDbf;
    DescriptionM: TMemo;
    DesignB: TButton;
    FileNameL: TLabel;
    AnimalsDS: TfrxDBDataset;
    frxDesigner1: TfrxDesigner;
    frxPDFExport1: TfrxPDFExport;
    frxReport1: TfrxReport;
    frxRichObject1: TfrxRichObject;
    frxRTFExport1: TfrxRTFExport;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ImageList1: TImageList;
    Label1: TLabel;
    PreviewB: TButton;
    Shape1: TShape;
    Tree: TTreeView;
    procedure DesignBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PreviewBClick(Sender: TObject);
    procedure TreeChange(Sender: TObject; Node: TTreeNode);
  private
     WPath: string;
  public

  end;

var
  frmRichEditMain: TfrmRichEditMain;

implementation

{$R *.lfm}

{ TfrmRichEditMain }

procedure TfrmRichEditMain.PreviewBClick(Sender: TObject);
begin
  frxReport1.ShowReport;
end;

procedure TfrmRichEditMain.TreeChange(Sender: TObject; Node: TTreeNode);
begin
  frxReport1.LoadFromFile(WPath + 'Data\' + IntToStr(Node.StateIndex) + '.fr3');
  FileNameL.Caption := ' Report file: ' + IntToStr(Node.StateIndex) + '.fr3';
  DescriptionM.Lines := frxReport1.ReportOptions.Description;
end;

procedure TfrmRichEditMain.DesignBClick(Sender: TObject);
begin
  frxReport1.DesignReport;
end;

procedure TfrmRichEditMain.FormShow(Sender: TObject);
var
  I: Integer;
begin
  {$IFDEF Linux}
  frxReport1.IniFile := 'tmp/fr6.ini';
  {$ELSE}
  frxReport1.IniFile := '\SoftWare\Fast Reports';
  {$ENDIF}
  WPath := ExtractFilePath(Application.ExeName);
  for I:= 0 to Self.ComponentCount - 1 do
  begin
    if Self.Components[I] is TDbf then
      TDbf(Self.Components[I]).FilePath := WPath + 'Data\';
  end;
  Tree.Items.Item[0].Selected := True;
end;

end.

