{*******************************************}
{                                           }
{             FastQueryBuilder              }
{                                           }
{          Copyright (c) 1998-2023          }
{              Fast Reports Inc.            }
{                                           }
{*******************************************}
unit fqbFDEngine;

{$I fqb.inc}

interface

uses
  SysUtils, Windows, Messages, Classes, Dialogs, DB, Variants,
  frFDData,
  fqbClass;

type
  { TfqbFDEngine }

  TfqbFDEngine = class(TfqbEngine)
  private
    FConnection: TfrFDCustomConnection;
    FQuery: TfrFDQuery;
    procedure SetDatabase(Value: TfrFDCustomConnection);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure ReadFieldList(const ATableName: string; var AFieldList: TfqbFieldList); override;
    procedure ReadTableList(ATableList: TStrings); override;
    function ResultDataSet: TDataSet; override;
    procedure SetSQL(const Value: string); override;
  published
    property Database: TfrFDCustomConnection read FConnection write SetDatabase;
  end;

implementation
end.
