{******************************************}
{                                          }
{             FastReport VCL               }
{             LCLGTK2 Mutex                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxMutex_Linux;

interface

uses
  Classes, Unix, pthreads;

var
  SemList: TList;
  GlobMut: pthread_mutex_t;

type

{ TfrxSemafor }

  TfrxSemafor = class
  private
    FMut: pthread_mutex_t;
    FKey: String;
    FCount: Integer;
  public
    constructor Create(skey: String);
    destructor Destroy; override;
    procedure Lock;
    procedure Unlock;

    property Key: String read FKey write FKey;
    property Count: Integer read FCount write FCount;
  end;

  function CreatefrxSemafor(skey: String): TfrxSemafor;
  procedure FreefrxSemafor(var sem: TfrxSemafor);
  function FindInSemList(skey: String): Integer;

implementation
end.
