
{******************************************}
{                                          }
{             FastReport VCL               }
{        HTTP Report Server Statistic      }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxServerStat;

{$I frx.inc}

interface

uses
  SysUtils, Classes;

type
  TfrxServerStatistic = class(TPersistent)
  private
    FStartTime: TDateTime;
    function GetCurrentReportsCount: Integer;
    function GetCurrentSessionsCount: Integer;
    function GetMaxReportsCount: Integer;
    function GetMaxSessionsCount: Integer;
    function GetTotalErrors: Integer;
    function GetTotalReportsCount: Integer;
    function GetTotalSessionsCount: Integer;
    function GetUpTimeDays: Integer;
    function GetUpTimeHours: Integer;
    function GetUpTimeMins: Integer;
    function GetUpTimeSecs: Integer;
    function GetTotalCacheHits: Integer;
    function GetFormatUpTime: String;
    function GetCacheCount: Integer;
  public
    constructor Create;
  published
    property CurrentReportsCount: Integer read GetCurrentReportsCount;
    property CurrentSessionsCount: Integer read GetCurrentSessionsCount;
    property MaxReportsCount: Integer read GetMaxReportsCount;
    property MaxSessionsCount: Integer read GetMaxSessionsCount;
    property TotalErrors: Integer read GetTotalErrors;
    property TotalReportsCount: Integer read GetTotalReportsCount;
    property TotalSessionsCount: Integer read GetTotalSessionsCount;
    property UpTimeDays: Integer read GetUpTimeDays;
    property UpTimeHours: Integer read GetUpTimeHours;
    property UpTimeMins: Integer read GetUpTimeMins;
    property UpTimeSecs: Integer read GetUpTimeSecs;
    property TotalCacheHits: Integer read GetTotalCacheHits;
    property CurrentCacheCount: Integer read GetCacheCount;
    property FormatUpTime: String read GetFormatUpTime;
  end;

var
   ServerStatistic: TfrxServerStatistic;

implementation
end.
