unit frxCmapTableClass;

interface

{$I frx.inc}

uses SysUtils, TTFHelpers, frxTrueTypeTable;

    type // Nested Types
        EncodingFormats = (ByteEncoding=0, HighByteMapping=2, SegmentMapping=4, TrimmedTable=6);
        TSmallintArray = array of Smallint;
        TWordArray = array of Word;

        TSegmentMapping = packed record
            segCountX2: Word;
            searchRange: Word;
            entrySelector: Word;
            rangeShift: Word;
        end;

        Table_CMAP = packed record
            TableVersion: Word;
            NumSubTables: Word;
        end;

        Table_Encode = packed record
            Format: Word;
            Length: Word;
            Version: Word;
        end;

        Table_SUBMAP = packed record
            Platform: Word;
            EncodingID: Word;
            TableOffset: Cardinal;
        end;


    CmapTableClass = class(TrueTypeTable)
    // Fields
    private endCount: TWordArray;
    private GlyphIndexArray: TWordArray;
    private idDelta: TSmallintArray;
    private idRangeOffset: TWordArray;
    private startCount: TWordArray;
    private segment_count: Integer;

    // Methods
    public constructor Create(src: TrueTypeTable);
    public function GetGlyphIndex(ch: Word): Word;
    private function LoadCmapSegment(segment_ptr: Pointer; segment_count: Integer): TWordArray;
    public procedure LoadCmapTable(font: Pointer);
    private function LoadSignedCmapSegment(segment_ptr: Pointer; segment_count: Integer): TSmallintArray;
end;

implementation
end.
