{******************************************}
{                                          }
{             FastReport VCL               }
{           Base export dialog             }
{                                          }
{         Copyright (c) 1998-2021          }
{                                          }
{******************************************}

unit frxExportBaseDialog;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  SysUtils, Graphics, Controls, Classes, Forms, Dialogs,
  StdCtrls, ExtCtrls, {ComObj,} frxClass, frxBaseForm,
  ComCtrls, Variants;

type
  TfrxBaseExportDialog = class;

  TfrxBaseExportDialogClass = class of TfrxBaseExportDialog;

  TfrxBaseDialogExportFilter = class(TfrxCustomExportFilter)
  private
    FCustomExportDialogClass: TfrxBaseExportDialogClass;
  protected
    procedure AfterFinish; override;
  public
    function ShowModal: TModalResult; override;
    class function ExportDialogClass: TfrxBaseExportDialogClass; virtual;
    property CustomExportDialogClass: TfrxBaseExportDialogClass read FCustomExportDialogClass write FCustomExportDialogClass;
  end;

  TfrxBaseExportDialog = class(TfrxBaseForm)
    PageControl1: TPageControl;
    ExportPage: TTabSheet;
    OkB: TButton;
    CancelB: TButton;
    OpenCB: TCheckBox;
    GroupQuality: TGroupBox;
    GroupPageRange: TGroupBox;
    DescrL: TLabel;
    AllRB: TRadioButton;
    CurPageRB: TRadioButton;
    PageNumbersRB: TRadioButton;
    PageNumbersE: TEdit;
    FiltersNameCB: TComboBox;
    GroupBox1: TGroupBox;
    procedure FormCreate(Sender: TObject);
    procedure PageNumbersEChange(Sender: TObject);
    procedure PageNumbersEKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OkBClick(Sender: TObject);
  protected
    procedure InitDialog; virtual;
    procedure InitControlsFromFilter(ExportFilter: TfrxBaseDialogExportFilter); virtual;
    procedure InitFilterFromDialog(ExportFilter: TfrxBaseDialogExportFilter); virtual;
  end;

implementation
end.
