
{******************************************}
{                                          }
{             FastReport VCL               }
{               PPTX export                }
{                                          }
{         Copyright (c) 1998-2021          }
{                                          }
{******************************************}

unit frxExportPPTX;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages, ShellAPI,
{$ELSE}
  LCLType, LCLIntf, LazHelper,
{$ENDIF}
  SysUtils, Classes, Graphics,
  frxClass, ComCtrls, frZip, frxImageConverter,
  frxExportBaseDialog, frxStorage
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF}
;

type
  TWriteRelationship = procedure(IntertNum: Integer; Rid, Path: String) of object;

{$IFDEF DELPHI16}
[ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxPPTXExport = class(TfrxBaseDialogExportFilter)
  private
    FDocFolder: string;
    FContentTypes: TStream; // [Content_Types].xml
    FPresentation: TStream; // ppt/presentation.xml
    FPresentationRels: TStream; // ppt/_rels/presentation.xml.rels
    FRels: TStream; // _rels/.rels
    FSlide: TStream; // ppt/slides/slideNNN.xml
    FSlideRels: TStream; // ppt/slides/_rels/slideNNN.xml.rels
    FSlideId: Integer;
    FObjectId: Integer;
    FPage: TfrxReportPage;
    FWidth, FHeight: Integer;
    FPictureType: TfrxPictureType;
    FWriteRelationship: TWriteRelationship;
    NumPictListPage: TListHashTable;
    function SubPath(const s: string): string;
    procedure AddTextBox(Obj: TfrxCustomMemoView);
    procedure AddLine(Line: TfrxFrameLine; x, y, dx, dy: Integer);
    procedure AddPicture(Obj: TfrxView);
    function GetObjRect(Obj: TfrxView): TRect;
    procedure HashRelationship(IntertNum: Integer; Rid, Path: String);
    procedure NonHashRelationship(IntertNum: Integer; Rid, Path: String);
  protected
    function EnableCalculateHash: Boolean; override;
  public
    constructor Create(Owner: TComponent); override;
    class function GetDescription: string; override;
    class function ExportDialogClass: TfrxBaseExportDialogClass; override;
    function Start: Boolean; override;
    procedure Finish; override;
    procedure StartPage(Page: TfrxReportPage; Index: Integer); override;
    procedure FinishPage(Page: TfrxReportPage; Index: Integer); override;
    procedure ExportObject(Obj: TfrxComponent); override;
  published
    property OpenAfterExport;
    property OverwritePrompt;
    property PictureType: TfrxPictureType read FPictureType write FPictureType;
  end;

implementation
end.
