unit frxExportPS;

interface

{$I frx.inc}

uses
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  Messages, frxExportBaseDialog, SysUtils, Classes, Graphics, frxClass, frxExportMatrix, Math, frxBarcod, frxBarcode, frxBarcode2D,
  frxBarcodeMaxiCode, frxTableObject, frxRes, frxExportPSDialog, frxImageConverter, frxExportPSDocument,  frxExportPSHelper;

type

{$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxPSExport = class(TfrxBaseDialogExportFilter)
  protected
    FPath, fileNameWOext, extension, pageFileName: String;
    FIndent: Double;
    FPictures, FHasMultipleFiles, FIncludeImages: Boolean;
    FPSImageFormat :PSImageFormat;
    ps: PSDocument;
  protected
    function EnableCalculateHash: Boolean; override;
    function GetImageFormat(): String;
    {$IFNDEF FPC}
    function RadGetImageFormat(): TfrxPictureType;
    {$ENDIF}
    function GetBlendColor(c: TColor; Blend: Double): TColor;
    procedure DrawArrow(AWidth, AHeight, lineWidth, x1, y1, x2, y2: Double; var x3, y3, x4, y4: Double);
    procedure NormalizeBackgroundColor(obj: TfrxView; var Background: String);
    procedure NormalizeColor(obj: TfrxShapeView; var BorderBrush: String; var Background: String);

    procedure AddPictureObject(ps: PSDocument; obj: TfrxPictureView);
    procedure AddLine(ps: PSDocument; line: TfrxLineView);
    procedure AddShape(ps: PSDocument; shape: TfrxShapeView);
    procedure AddTextObject(ps: PSDocument; text: TfrxCustomMemoView; Band: Boolean);

  public
    function Start: Boolean; override;
    procedure StartPage(Page: TfrxReportPage; Index: Integer); override;
    procedure ExportObject(Obj: TfrxComponent); override;
    procedure FinishPage(Page: TfrxReportPage; Index: Integer); override;
    procedure Finish; override;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    class function GetDescription: String; override;
    class function ExportDialogClass: TfrxBaseExportDialogClass; override;

  published
    property Indent: Double read FIndent write FIndent;
    property Pictures: Boolean read FPictures write FPictures;
    property IncludeImages: Boolean read FIncludeImages write FIncludeImages;
    property ImageFormat :PSImageFormat read FPSImageFormat write FPSImageFormat;
    property HasMultipleFiles: Boolean read FHasMultipleFiles write FHasMultipleFiles;
end;


implementation
end.
