unit frxExportPSDocument;

interface

{$I frx.inc}

uses
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  Messages, frxExportBaseDialog, SysUtils, Classes, Graphics, frxClass, frxExportMatrix, Math, frxBarcod, frxBarcode, frxBarcode2D,
  frxBarcodeMaxiCode, frxTableObject, frxRes, frxImageConverter, frxExportPSHelper,
  frBaseGraphicsTypes;

type
  PSDocument = class
  protected
    psData: String;
    windowWidth, windowHeight: Double;

  protected
    procedure CreateWindow(name: String; Width, Height: Double); virtual;

    procedure createText(x, y: Double; HorizontalAlignment: TfrxHAlign; VerticalAlignment: TfrxVAlign; Width, Height: Double; font: TFont; textstr: String;
                PaddingLeft, PaddingRight, PaddingTop, PaddingBottom, BorderThickness: Double; Foreground, Background: String; Angle, Indent: Double);
    function TextAlignments(x: Double; var y: Double; HorizontalAlignment: TfrxHAlign; VerticalAlignment: TfrxVAlign; Width, Height: Double; font: TFont; txt_lns: TStringList;
               PaddingLeft, PaddingRight, PaddingTop, PaddingBottom, BorderThikness: Double): AOF;

    procedure MoveTo(x, y: Double);

    //procedure AppendBezier(x, y: Double;p1, p2, p3: TPoint);
    procedure AppendLine(x2, y2: Double);
    procedure StartFig(StrokeThickness: Double);
    function PSFont(font: String): String;
    //procedure EndFig(stroke, fill: String); overload;
    procedure EndFig(stroke: String);// overload;
    function ColorToPsRgb(htmlcolor: String): String;
    function FloatToString(flt: Double): String;
    //procedure ClosePath();
  public
    procedure AddPage(); virtual;
    procedure PSWrite(s: String);
    procedure PSWriteLn(s: String);

    procedure Convert(var left, top, width, height: Double);

    procedure AddTextLine(t_x: AOF; t_y: Double; Foreground: String; font: TFont; Width, Height: Double; txt_lns: TStringList; Angle, Indent: Double);

    procedure AddRectangle(x, y, Width, Height: Double; Stroke: String; StrokeThickness: Double; Fill: String; Rounded: Boolean);
    procedure AddEllipse(x, y, Width, Height: Double; Stroke: String; StrokeThickness: Double; Fill: String);
    procedure AddTriangle(x, y, Width, Height: Double; Stroke: String; StrokeThickness: Double; Fill: String);
    procedure AddDiamond(x, y, Width, Height: Double; Stroke: String; StrokeThickness: Double; Fill: String);
    procedure AddLine(x, y, x2, y2: Double; Stroke: String; StrokeThickness: Double; dash: TfrxFrameStyle); overload;
    procedure AddLine(x, y, x2, y2: Double; Stroke: String; StrokeThickness: Double); overload;
    procedure AddBezier(x, y: Double; p0, p1, p2, p3: TPoint; Stroke: String; StrokeThickness: Double);
    procedure AddImage(data: String;left, top, width, height: Double; pwidth, pheight: Integer; Involve: Boolean = True);

    procedure AddTextObject(x, y, Width, Height: Double;
       HorizontalAlignment: TfrxHAlign; VerticalAlignment: TfrxVAlign; BorderBrush: String;
       BorderThickness, LeftLine, TopLine, RightLine, BottomLine: Double;
       LeftLineDashStile, TopLineDashStile, RightLineDashStile, BottomLineDashStile: TfrxFrameStyle;
       colorLeftLine, colorTopLine, colorRightLine, colorBottomLine: String; Shadow: Boolean;
       ShadowColor: String; ShadowWidth: Double; Background: String; Typ: TfrxFrameTypes;Text, Foreground: String;
       PaddingLeft, PaddingTop, PaddingRight, PaddingBottom: Double;
       WordWrap: Boolean; Angle: Double; Glass: Boolean; colorTop: String; font: TFont; FIndent: Double);

    constructor Create(); overload;
    constructor Create(name: String; Width, Height: Double); overload;
    procedure Save(stream: TStream); overload; virtual;
    procedure Save(fn: String); overload; virtual;
    procedure Finish(); virtual;
end;


implementation
end.

