unit frxFontHeaderClass;

interface

{$I frx.inc}

uses TTFHelpers, frxTrueTypeTable;

type // Nested Types
  FontHeader = packed record
      version: Cardinal;
      revision: Cardinal;
      checkSumAdjustment: Cardinal;
      magicNumber: Cardinal;
      flags: Word;
      unitsPerEm: Word;
      CreatedDateTime: UInt64;
      ModifiedDateTime: UInt64;
      xMin: Smallint;
      yMin: Smallint;
      xMax: Smallint;
      yMax: Smallint;
      macStyle: Word;
      lowestRecPPEM: Word;
      fontDirectionHint: Smallint;
      indexToLocFormat: Smallint;
      glyphDataFormat: Smallint;
  end;

  IndexToLoc = (IndexToLoc_LongType=1, IndexToLoc_ShortType=0);

  FontType = (FontType_TrueTypeCollection=$66637474, FontType_TrueTypeFontType=0, FontType_OpenTypeFontType);

  FontHeaderClass = class(TrueTypeTable)
    public font_header: FontHeader;

    private function get_indexToLocFormat: IndexToLoc;

    // Properties
//    private property checkSumAdjustment: Cardinal write font_header.checkSumAdjustment;
//    private property Flags: Word read font_header.flags;
//    public property FontBox: FontRect read font_header.FontBox;
    public property indexToLocFormat: IndexToLoc read get_indexToLocFormat;
    public property unitsPerEm: Word read font_header.unitsPerEm;


    // Methods
    public constructor Create(src: TrueTypeTable);
    private procedure ChangeEndian;
    public procedure Load(font: Pointer); override;
    public procedure SaveFontHeader(header_ptr: Pointer; CheckSum: Cardinal);

end;

implementation
end.
