unit frxGlyphSubstitutionClass;

interface

{$I frx.inc}

uses TTFHelpers, frxTrueTypeTable;

    type // Nested Types
        FeatureRecord = packed record
            Feature: Word;
            FeatureTag: Cardinal;
        end;

        GSUB_Header = record
            Version: Cardinal;
            ScriptList: Word;
            FeatureList: Word;
            LookupList: Word;
        end;

        LangSysRecord = packed record
            LangSysTag: Cardinal;
            LangSys: Word;
        end;

        LangSysTable = packed record
            LookupOrder: Word;
            ReqFeatureIndex: Word;
            FeatureCount: Word;
        end;

        ScriptListRecord = packed record
            ScriptTag: Cardinal;
            ScriptOffset: Word;
        end;

        ScriptListTable = packed record
            CountScripts: Word;
        end;

        ScriptTable = packed record
            DefaultLangSys: Word;
            LangSysCount: Word;
        end;


    GlyphSubstitutionClass = class(TrueTypeTable)
      // Fields
//      strict private gsub_ptr: Pointer;
      private header: GSUB_Header;

      // Methods
      public constructor Create(src: TrueTypeTable);
      private procedure ChangeEndian;
      public procedure Load(font: Pointer); override;
//      strict private procedure LoadFeatureList(feature_idx: Cardinal);
//      strict private procedure LoadScriptList;
      public function Save(font: Pointer; offset: Cardinal): Cardinal; override;
    end;

implementation
end.
