unit frxGlyphTableClass;

interface

{$I frx.inc}

uses TTFHelpers, Classes, frxTrueTypeTable;

    type // Nested Types
        TIntegerList = TList;
        CompositeFlags = (ARG_1_AND_2_ARE_WORDS=1, ARGS_ARE_XY_VALUES=2, MORE_COMPONENTS=$20, OVERLAP_COMPOUND=$400, RESERVED=$10, ROUND_XY_TO_GRID=4, SCALED_COMPONENT_OFFSET=$800, UNSCALED_COMPONENT_OFFSET=$10000, USE_MY_METRICS=$200, WE_HAVE_A_SCALE=8, WE_HAVE_A_TWO_BY_TWO=$80, WE_HAVE_AN_X_AND_Y_SCALE=$40, WE_HAVE_INSTRUCTIONS=$100);
        GlyphFlags = (ON_CURVE=1, REP=8, X_POSITIVE=$10, X_SAME=$10, X_SHORT=2, Y_POSITIVE=$20, Y_SAME=$20, Y_SHORT=4);

        CompositeGlyphHeader = packed record
            flags: Word;
            glyphIndex: Word;
        end;
        GlyphHeader = packed record
            numberOfContours: Smallint;
            xMin: Smallint;
            yMin: Smallint;
            xMax: Smallint;
            yMax: Smallint;
        end;
        GlyphTableClass = class(TrueTypeTable)
          private glyph_table_ptr: Pointer;

          // Methods
          public constructor Create(src: TrueTypeTable);
          destructor Destroy; override;
          {
          strict private procedure AddSpline(path: GraphicsPath; pntStart: PointF; pntB: PointF; pntEnd: PointF; position: Point);
          private function GetGlyph(glyph_offset: Integer; glyph_data_size: Integer; font_rsize: Single; position: Point; [Out] var gheader: GlyphHeader): GraphicsPath;
          }
          public function CheckGlyph(glyph_offset: Integer; glyph_size: Integer): TIntegerList;
          private function GetGlyphHeader(glyph_offset: Integer): GlyphHeader;
          public procedure Load(font: Pointer); override;
//          strict private function ReadRawByte(ptr: Pointer; var val: Byte): Pointer;
        end;

        GlyphPoint = class
            // Properties
//            public property Point: TPointF read get_Point;

            // Fields
            public end_of_contour: boolean;
            public on_curve: boolean;
            public x: Single;
            public y: Single;
        end;

implementation
end.
