unit frxHashStreebog; // http://oid-info.com/get/1.0.10118.3.0

{$I frx.inc}

interface

uses
  frxHash;

const
  BlockSize = 64;

type
  TBlockArray = array[0 .. BlockSize - 1] of Byte;

  TfrxCustomStreebogHash = class(TfrxHash)
  private
    Buffer: TBlockArray;
    BufferSize: Cardinal;
    Hash: TBlockArray;
    h: TBlockArray;
    N: TBlockArray;
    Sigma: TBlockArray;
    v_0: TBlockArray;
    v_512: TBlockArray;
  protected
    procedure FillBlock(var X; Value: Byte);
    procedure ClearBlock(var X);
    procedure MoveBlock(const Source; var Dest);

    procedure Stage_2(const data: TBlockArray);
    procedure GetKey(var K: TBlockArray; i: Integer);
    procedure X(const a, b: TBlockArray;  var c: TBlockArray);
    procedure SPL(var state: TBlockArray);
    procedure G(var N_: TBlockArray; const m: TBlockArray);
    procedure E(var K: TBlockArray; const m: TBlockArray; var state: TBlockArray);
    procedure Add512(const a, b: TBlockArray; var c: TBlockArray);
    procedure Stage_3;
    procedure Padding;
  public
    procedure Initialize; override;
    procedure Update(const Buf; Len: Cardinal); override;
    procedure Finalize; override;
  end;

  TfrxStreebog256Hash = class(TfrxCustomStreebogHash)
  public
    procedure Initialize; override;
    class function DigestSize: Cardinal; override;
  end;

  TfrxStreebog512Hash = class(TfrxCustomStreebogHash)
  public
    procedure Initialize; override;
    class function DigestSize: Cardinal; override;
  end;

implementation
end.
