unit frxHorizontalHeaderClass;

interface

{$I frx.inc}

uses TTFHelpers, frxTrueTypeTable;


type
    HorizontalHeader = packed record
        Version: Cardinal;
        Ascender: Smallint;
        Descender: Smallint;
        LineGap: Smallint;
        advanceWidthMax: Word;
        minLeftSideBearing: Smallint;
        minRightSideBearing: Smallint;
        xMaxExtent: Smallint;
        caretSlopeRise: Smallint;
        caretSlopeRun: Smallint;
        reserved1: Smallint;
        reserved2: Smallint;
        reserved3: Smallint;
        reserved4: Smallint;
        reserved5: Smallint;
        metricDataFormat: Smallint;
        numberOfHMetrics: Word;
    end;

    HorizontalHeaderClass = class(TrueTypeTable)
      // Fields
      private horizontal_header: HorizontalHeader;

      // Methods
      public constructor Create(src: TrueTypeTable);
      private procedure ChangeEndian;
      public procedure Load(font: Pointer); override;
      public function Save(font: Pointer; offset: Cardinal): Cardinal; override;

      // Properties
      public property Ascender: Smallint read horizontal_header.Ascender;
      public property Descender: Smallint read horizontal_header.Descender;
      public property LineGap: Smallint read horizontal_header.LineGap;
      public property MaxWidth: Word read horizontal_header.advanceWidthMax;
      public property NumberOfHMetrics: Word read horizontal_header.NumberOfHMetrics;
    end;

implementation
end.

