unit frxKerningTableClass;

interface

{$I frx.inc}

uses Classes, TTFHelpers, frxFontHeaderClass, frxTrueTypeTable;

type // Nested Types

    CommonKerningHeader = packed record
        Coverage: Word;
        Length: Word;
        Version: Word;
    end;

    FormatZero = packed record
        entrySelector: Word;
        nPairs: Word;
        rangeShift: Word;
        searchRange: Word;
    end;

    FormatZeroPair = packed record
        key_value: Cardinal;
        value: Smallint;
    end;

    KerningTableHeader = packed record
        Version: Word;
        nTables: Word;
    end;

    KerningSubtableClass = class(TTF_Helpers)
        // Fields
        private common_header: CommonKerningHeader;
        private zero_pairs: TStringList;
        private format_zero: FormatZero;
        // Methods
        public constructor Create(kerning_table_ptr: Pointer);
        destructor Destroy; override;
        private function get_Item(inx: Cardinal): Smallint;
        // Properties
        public property Item[hash_value: Cardinal]: Smallint read get_Item;
        public property Length: Word read common_header.Length;
    end;

    KerningTableClass = class(TrueTypeTable)
        // Fields
        private kerning_table_header: KerningTableHeader;
        private kerning_subtables_collection: TList;
        // Methods
        public constructor Create(src: TrueTypeTable);
        destructor Destroy; override;
        private procedure ChangeEndian;
        public procedure Load(font: Pointer); override;

        private function get_Item(idx: Cardinal): Smallint;
        // Properties
        public property Item[hash_value: Cardinal]: Smallint read get_Item;
    end;

implementation
end.
