unit frxMaximumProfileClass;

interface

{$I frx.inc}

uses TTFHelpers, frxTrueTypeTable;

    type // Nested Types
        MaximumProfile = packed record
            maxComponentDepth: Word;
            maxComponentElements: Word;
            maxCompositeContours: Word;
            maxCompositePoints: Word;
            maxContours: Word;
            maxFunctionDefs: Word;
            maxInstructionDefs: Word;
            maxPoints: Word;
            maxSizeOfInstructions: Word;
            maxStackElements: Word;
            maxStorage: Word;
            maxTwilightPoints: Word;
            maxZones: Word;
            numGlyphs: Word;
            Version: Cardinal;
        end;

    MaximumProfileClass = class(TrueTypeTable)
      private max_profile: MaximumProfile;

      public constructor Create(src: TrueTypeTable);
      private procedure ChangeEndian;
      public procedure Load(font: Pointer); override;
      public function Save(font: Pointer; offset: Cardinal): Cardinal; override;
end;

implementation
end.
