unit frxNameTableClass;

interface

{$I frx.inc}

uses
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  TTFHelpers, frxFontHeaderClass, frxTrueTypeTable;

type
  NameID = (NameID_CompatibleFull=$12, NameID_CopyrightNotice=0, NameID_Description=10, NameID_Designer=9,
  NameID_FamilyName=1, NameID_FullName=4, NameID_LicenseDescription=13, NameID_LicenseInfoURL=14,
  NameID_Manufacturer=8, NameID_PostscriptCID=20, NameID_PostscriptName=6, NameID_PreferredFamily=$10,
  NameID_PreferredSubFamily=$11, NameID_SampleText=$13, NameID_SubFamilyName=2, NameID_Trademark=7,
  NameID_UniqueID=3, NameID_URL_Designer=12, NameID_URL_Vendor=11, NameID_Version=5, NameID_WWS_Family_Name=$15,
  NameID_WWS_SubFamily_Name=$16);

  NamingTableHeader = packed record
      TableVersion: Word;
      Count: Word;
      stringOffset: Word;
  end;

  NamingRecord = packed record
      PlatformID: Word;
      EncodingID: Word;
      LanguageID: Word;
      NameID: Word;
      Length: Word;
      Offset: Word;
  end;

  NameTableClass = class(TrueTypeTable)
    // Fields
    private
      name_header: NamingTableHeader;
      namerecord_ptr: Pointer;
      string_storage_ptr: Pointer;
      FPlatform: Word;

    // Methods
    public constructor Create(src: TrueTypeTable);
    destructor Destroy; override;
    private procedure ChangeEndian;
    public procedure Load(font: Pointer); override;
    private function  get_Item(Index: NameID): WideString;

    // Properties
    public
      function IsHasFontName(Index: NameID; const FontName: WideString): WideString;
      property Item[Index: NameID]: WideString read get_Item;
      property Platform: Word read FPlatform write FPlatform;

  end;

implementation
end.
