unit frxOS2WindowsMetricsClass;

interface

{$I frx.inc}

uses SysUtils, TTFHelpers, frxTrueTypeTable;

type
  TVendorID = packed array[0..3] of Byte;
  TPanose   = packed array[0..9] of Byte;
  OS2WindowsMetrics = packed record
    Version: Word;         // version number 0x0004
    xAvgCharWidth: Smallint;
    usWeightClass: Word;
    usWidthClass: Word;
    fsType: Word;
    ySubscriptXSize: Smallint;
    ySubscriptYSize: Smallint;
    ySubscriptXOffset: Smallint;
    ySubscriptYOffset: Smallint;
    ySuperscriptXSize: Smallint;
    ySuperscriptYSize: Smallint;
    ySuperscriptXOffset: Smallint;
    ySuperscriptYOffset: Smallint;
    yStrikeoutSize: Smallint;
    yStrikeoutPosition: Smallint;
    sFamilyClass: Smallint;
    panose: TPanose;
    ulUnicodeRange1: Cardinal;
    ulUnicodeRange2: Cardinal;
    ulUnicodeRange3: Cardinal;
    ulUnicodeRange4: Cardinal;
    achVendID: TVendorID;
    fsSelection: Word;
    usFirstCharIndex: Word;
    usLastCharIndex: Word;
    sTypoAscender: Smallint;
    sTypoDescender: Smallint;
    sTypoLineGap: Smallint;
    usWinAscent: Word;
    usWinDescent: Word;
    ulCodePageRange1: Cardinal;
    ulCodePageRange2: Cardinal;
    sxHeight: Smallint;
    sCapHeight: Smallint;
    usDefaultChar: Word;
    usBreakChar: Word;
    usMaxContext: Word;
  end;

    POS2WindowsMetrics = ^OS2WindowsMetrics;

    OS2WindowsMetricsClass = class(TrueTypeTable)
        // Fields
      private win_metrix: POS2WindowsMetrics;
      // Methods
      public constructor Create(src: TrueTypeTable);
      public destructor  Destroy; override;

      public procedure Load(font: Pointer); override;
      public function Save(font: Pointer; offset: Cardinal): Cardinal; override;
      private function Get_AvgCharWidth: Smallint;
      private function Get_Ascent: Word;
      private function Get_BreakChar: Word;
      private function Get_DefaultChar: Word;
      private function Get_Descent: Word;
      private function Get_FirstCharIndex: Word;
      private function Get_LastCharIndex: Word;

      // Properties
      public property AvgCharWidth: Smallint read Get_AvgCharWidth;
      public property Ascent: Word read Get_Ascent;
      public property BreakChar: Word read Get_BreakChar;
      public property DefaultChar: Word read Get_DefaultChar;
      public property Descent: Word read Get_Descent;
      public property FirstCharIndex: Word read Get_FirstCharIndex;
      public property LastCharIndex: Word read Get_LastCharIndex;
    end;

implementation
end.
