
{ Prints contents of a OTF font in a readable form }

unit frxOTFPrinter;

interface

uses
  SysUtils,
  frxStorage,
  Classes,
  frxOTF;

type

  { Printing visitor }

  TPrintVisitor = class(TVisitor)
  private
    FOut: TFmtStream;
    FIndent: Integer;

    procedure PrintProp(Key: string; Value: string); overload;
    procedure PrintProp(Key: string; Value: Int64); overload;
    procedure PrintPropHex(Key: string; Value: Int64);
    procedure PrintPropBits(Key: string; Value: Int64);
  public
    constructor Create(Stream: TFmtStream);

    procedure Visit(Obj: TFontView);              override;
    procedure Visit(Obj: TCharmapTableView);      override;
    procedure Visit(Obj: TSegCharmapTableView);   override;
    procedure Visit(Obj: TFontCollectionView);    override;
    procedure Visit(Obj: TStringTableView);       override;
    procedure Visit(Obj: TAsciiCharmapTableView); override;
    procedure Visit(Obj: THeadTableView);         override;
    procedure Visit(Obj: TWinMetrics1TableView);   override;

    property Indent: Integer read FIndent write FIndent;
  end;

procedure PrintFontInfo(Font: TView; Stream: TStream); overload;
procedure PrintFontInfo(Font: TStream; Stream: TStream); overload;
procedure PrintFontInfo(Font: TStream; ResFile: string); overload;
procedure PrintFontInfo(Font: TView; ResFile: string); overload;
procedure PrintFontInfo(FontFile: string; Stream: TStream); overload;
procedure PrintFontInfo(FontFile: string; ResFile: string); overload;

implementation
end.

