
{******************************************}
{                                          }
{             FastReport VCL               }
{    Utilities for Office Open exports     }
{                                          }
{         Copyright (c) 1998-2021          }
{                                          }
{******************************************}

unit frxOfficeOpen;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows,
{$ELSE}
  Types, LCLType, LCLIntf, LCLProc, LazHelper, DateUtils,
  LazFileUtils, FileUtil,
{$ENDIF}
  Classes, SysUtils, Graphics, frxClass;

type
  TfrxStrList = class(TStringList)
  public
    function AddObject(const s: string; Obj: TObject): Integer; override;
  end;

  TfrxWriter = class
  private
    FStream: TStream;
    FOwn: Boolean;
  public
    constructor Create(Stream: TStream; Own: Boolean = False);
    destructor Destroy; override;
    procedure Write(s: string; UCS: Boolean = False); overload;
    procedure Write(const a: array of string; UCS: Boolean = False); overload;
    procedure Write(const Section: string; StrList: TStrings); overload;
    procedure Write(const Fmt: string; const f: array of const); overload;
  end;

  TfrxFileWriter = class(TfrxWriter)
  public
    constructor Create(FileName: string); overload;
  end;

  TfrxMap = record
    FirstRow: Integer;
    LastRow: Integer;
    Margins: TfrxRect;
    PaperSize: Integer;
    PageOrientation: Integer;
    Index: Integer;
    Name: String;
  end;

procedure WriteStr(Stream: TStream; const s: string; UCS: Boolean = False);
procedure WriteStrList(Stream: TStream; const Section: string; StrList: TStrings);
procedure CreateDirs(aSaveFilter: TfrxCustomIOTransport; const SubDirs: array of string);
function Escape(s: WideString): WideString;
function Distance(c1, c2: Integer): Integer; // 0..1024
function CleanTrash(const s: WideString): WideString;
procedure Exchange(var a, b: Integer);

implementation
end.
