
{******************************************}
{                                          }
{             FastReport VCL               }
{             PDF Signature                }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxPDFSignature;

interface

{$I frx.inc}

uses
  Types, Classes,
  frxClass, frxSignatureEngine, frxSignature, frxCertificateList;

type
  TfrxPDFSignature = class(TfrxSignature)
  protected
    function GetCertificateCommonName: WideString;
    function GetCertificateDistinguishedName: WideString;

    function GetMessageData(Stream: TStream;
      ContentPosition, ContentEndPosition: Int64): TByteDynArray;
  public
    constructor Create(SD: TfrxSignatureData; Certificate: TfrxCertificate);

    function CalcPDFSign(Stream: TStream;
      ContentPosition, ContentEndPosition: Int64): Ansistring;

    property CertificateCommonName: WideString read GetCertificateCommonName;
    property CertificateDistinguishedName: WideString read GetCertificateDistinguishedName;
  end;

implementation
end.
