unit frxTrueTypeCollection;

interface

{$I frx.inc}

uses
  Classes, SysUtils, Graphics,
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  TTFHelpers, frxTrueTypeFont, frxFontHeaderClass, frxNameTableClass
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF};


type // Nested Types

  TFontCollection = TList;
  TTCollectionHeader = packed record
      TTCTag: Cardinal;
      Version: Cardinal;
      numFonts: Cardinal;
  end;

  TrueTypeCollection = class(TTF_Helpers)
    // Fields
    private fonts_collection: TFontCollection;

    private function get_FontCollection: TFontCollection;
    private function get_Item(FamilyName: string): TrueTypeFont;

    // Methods
    public constructor Create;
    destructor Destroy; override;
    public procedure Initialize(FD: PAnsiChar; FontDataSize: Longint);
    function LoadFont( font: Tfont) : TrueTypeFont;
//    public function PackFont( font: Tfont; UsedAlphabet: TList) : TByteArray;
    public function PackFont( ttf: TrueTypeFont; UsedAlphabet: TList) : TByteArray;

    // Properties
    public property FontCollection: TFontCollection read get_FontCollection;
    public property Item[FamilyName: string]: TrueTypeFont read get_Item;
  end;

procedure AddFontNameSubstitution(Name, Value: WideString); // See initialization

implementation
end.
