unit frxTrueTypeTable;

interface

{$I frx.inc}
uses TTFHelpers;

type // Nested Types

  TableEntry = packed record
      tag: Cardinal;
      checkSum: Cardinal;
      offset: Cardinal;
      length: Cardinal;
  end;

  TrueTypeTable = class(TTF_Helpers)
    // Fields
    protected entry: TableEntry;

    // Methods
    public constructor Create(parent: TrueTypeTable); overload;
    public constructor Create(entry_ptr: Pointer); overload;
    private procedure ChangeEndian;
    protected procedure Load(font: Pointer); virtual;
    public function Save(font: Pointer; offset: Cardinal): Cardinal; virtual;
    public function StoreDescriptor(descriptor_ptr: Pointer): Pointer;
    private function StoreTable(source_ptr: Pointer; destination_ptr: Pointer; output_offset: Cardinal): Cardinal;
    private function get_TAGLINE: string;
    private procedure set_length(length: Cardinal);
    private procedure set_offset(offset: Cardinal);

    // Properties
    public property length: Cardinal read entry.length write set_length;
    public property offset: Cardinal read entry.offset write set_offset;
    public property checkSum: Cardinal read entry.checkSum write entry.checkSum;
    public property tag: Cardinal read entry.tag write entry.tag;
    public property TAGLINE: string read get_TAGLINE;
    { to do
    public property descriptor_size: Integer read get_descriptor_size;
    }

end;

implementation
end.
