
{ ****************************************** }
{                                            }
{             FastReport VCL                 }
{          Barcode Add-in object             }
{                                            }
{         Copyright (c) 1998-2021            }
{            by Fast Reports Inc.            }
{                                            }
{ ****************************************** }

unit frx2DBarcodesPresets;

interface

{$I frx.inc}

uses
  Types, SysUtils, Classes, frxClass, Graphics;

type
  TfrxObjectDataPreset = class(TInterfacedPersistent, IStringClassNameContainer)
  private
    FOwner: TfrxComponent;
    FDataObject: TfrxCustomObjectPreset;
    procedure SetPresetClass(const Value: TfrxStringClassName);
    function GetPresetClass: TfrxStringClassName;
    function GetDataObject: TfrxCustomObjectPreset;
    procedure ClearPreset;
    function GetSupportedClasses: TList;
  public
    constructor Create(AOwner: TfrxComponent);
    destructor Destroy; override;
    procedure BeginDraw(Canvas: TCanvas; ScaleX, ScaleY: Extended; Area: TRect); virtual;
    procedure EndDraw(Canvas: TCanvas; ScaleX, ScaleY: Extended; Area: TRect); virtual;
    function GetData(aReport: TfrxReport): String; virtual;
    function IsHasPresetData: Boolean; virtual;

  published
    property PresetClass: TfrxStringClassName read GetPresetClass write SetPresetClass;
    property DataObject: TfrxCustomObjectPreset read GetDataObject;
  end;

  function frxBarcode2DPresetList: TList;

implementation
end.
