unit frxBarcodOneCode;
{$I frx.inc}
interface

type
  TLongIntArray = array of LongInt;

  TOneCode = class
  private
    function PadLeft(str: AnsiString; TotalWidth: Integer;
      PaddingChar: AnsiChar): AnsiString;
    function TrimStart(str: AnsiString; TrimChar: AnsiChar): AnsiString;
    function TrimOff(source, bad: AnsiString): AnsiString;
    function Substring(str: AnsiString; startIndex: Integer;
      len: Integer = -1): AnsiString;
    function AnsiToInt(str: AnsiString): Integer;
  protected
    entries2Of13: Int64;
    entries5Of13: Int64;
    table2Of13: TLongIntArray;
    table5Of13: TLongIntArray;
    codewordArray: array[0..9, 0..1] of Int64;

    function OneCodeInfo(topic: LongInt): TLongIntArray;
    function OneCodeInitializeNof13Table(ai: TLongIntArray; i, j: LongInt): Boolean;
    function OneCodeMathReverse(i: LongInt): LongInt;
    function OneCodeMathAdd(bytearray: TLongIntArray; i, j: LongInt): Boolean;
    function OneCodeMathDivide(v: AnsiString): Boolean;
    function OneCodeMathFcs(bytearray: TLongIntArray): LongInt;
    function OneCodeMathMultiply(bytearray: TLongIntArray; i, j: LongInt): Boolean;
  public
    constructor Create;
    function Bars(source: AnsiString): AnsiString;
  end;

implementation
end.
