
{******************************************}
{                                          }
{             FastReport VCL               }
{          Barcode2D design editor         }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxBarcode2DEditor;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}Windows, Messages,{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, Buttons, frxClass, frxBarcode2D , frxCustomEditors,
  frxCtrls, ComCtrls, frxBaseForm,TypInfo, Grids, ValEdit
{$IFDEF FPC}
  ,LCLType
{$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};


type
  TfrxBarcode2DEditor = class(TfrxViewEditor)
  public
    function Edit: Boolean; override;
    function HasEditor: Boolean; override;
    procedure GetMenuItems; override;
    function Execute(Tag: Integer; Checked: Boolean): Boolean; override;
  end;

  TfrxBarcode2DEditorForm = class(TfrxBaseForm)
    CancelB: TButton;
    OkB: TButton;
    CodeE: TfrxComboEdit;
    CodeLbl: TLabel;
    TypeCB: TComboBox;
    TypeLbl: TLabel;
    ExampleBvl: TBevel;
    ExamplePB: {$IFNDEF FPC}TPaintBox{$ELSE}TImage{$ENDIF};
    OptionsLbl: TGroupBox;
    ZoomLbl: TLabel;
    AutoSizeCB: TCheckBox;
    ViewTextCB: TCheckBox;
    ZoomE: TEdit;
    UpDown1: TUpDown;
    RotationLbl: TGroupBox;
    Rotation0RB: TRadioButton;
    Rotation90RB: TRadioButton;
    Rotation180RB: TRadioButton;
    Rotation270RB: TRadioButton;
    EditText: TEdit;
    BarPropertiesLb1: TGroupBox;
    BarVList: TValueListEditor;
    BarPageControl: TPageControl;
    TabGeneral: TTabSheet;
    TabAdditional: TTabSheet;
    procedure ExprBtnClick(Sender: TObject);
    procedure UpBClick(Sender: TObject);
    procedure DownBClick(Sender: TObject);
    procedure ExamplePBPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GetBarProperties(PBarcode:TfrxBarcode2DView);
    procedure SetBarProperties(PBarcode:TfrxBarcode2DView; NameProp: String);
    procedure TypeCBChange(Sender: TObject);
    procedure BarVListSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure EditTextKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EditTextClick(Sender: TObject);
  private
    { Private declarations }
    FBarcode: TfrxBarcode2DView;
  public
    { Public declarations }
    procedure UpdateResouces; override;
    property Barcode: TfrxBarcode2DView read FBarcode write FBarcode;
  end;


implementation
end.
