{******************************************}
{                                          }
{             FastReport VCL               }
{               Aztec code                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxBarcodeAztec;

interface

{$I frx.inc}

uses
{$IFDEF FPC}
  LCLType, LMessages, LazHelper, LCLIntf,
{$ELSE}
  Windows, Messages,
{$ENDIF}
  SysUtils, Types, StrUtils, Classes, Graphics, Controls, Forms, Dialogs,
  frxBarcode2DBase, frxDelphiZXIngAztecCode;

type
  TfrxBarcodeAztec = class(TfrxBarcode2DBaseWithUnion)
  private
    function GetPixelSize: integer;
    procedure SetPixelSize(const Value: integer);
    function GetMinECCPercent: integer;
    procedure SetMinECCPercent(const Value: integer);
  protected
    FAztecEncoder: TAztecEncoder;

    procedure Generate;
    procedure SetText(v: string); override;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Assign(src: TfrxBarcode2DBase); override;
  published
    property PixelSize: integer read GetPixelSize write SetPixelSize;
    property MinECCPercent: integer read GetMinECCPercent
      write SetMinECCPercent;
  end;

implementation
end.

