
{******************************************}
{                                          }
{             FastReport VCL               }
{              Tool controls               }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxBaseFormEditorDataTree;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}Windows, {$ENDIF}
  Messages, Classes, Controls, IniFiles, frxBaseForm,
  frxDataTree, ExtCtrls, StdCtrls, frSynMemo
{$IFDEF FPC}
  , LCLType, LCLIntf, LCLProc
{$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};

type
  TDataClick = procedure(str: string);

  TfrxBaseFormEditorDataTree = class(TfrxBaseLoadSavePrefForm)
  protected
    FDataTree: TfrxDataTreeForm;
    FRPanel, FLPanel: TPanel;
    FSplitter: TSplitter;

    procedure OnDataTreeDblClick(Sender: TObject); virtual; abstract;
    procedure LoadFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;
    procedure SaveFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;
    procedure ExprMemoDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Resize; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure SplitterMoved(Sender: TObject);
  end;

procedure MemoDragDrop(AMemo: TObject; DataTree: TfrxDataTreeForm; X, Y: Integer; const ExpressionDelimiters: String);
function GetExpText(const Expr: String; const Line, Delim: String; StopAt: Integer): String;

implementation
end.
