{******************************************}
{                                          }
{             FastReport VCL               }
{         Break Points toolwindow          }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxBreakPointsForm;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages, StdCtrls, ToolWin,
  {$ELSE}
  LCLType, StdCtrls,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, fs_iinterpreter, CheckLst, Variants, Grids,
  frxSimpleMemo, frxBaseForm, frxDock;

type
  TfrxBreakPointsForm = class({$IFDEF FPC}TfrxBaseForm{$ELSE}TfrxDockForm{$ENDIF})
    ToolBar1: TToolBar;
    DeleteB: TToolButton;
    EditB: TToolButton;
    ToggleEnableB: TToolButton;
    BreakPGR: TStringGrid;
    EditBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AddBClick(Sender: TObject);
    procedure DeleteBClick(Sender: TObject);
    procedure EditBClick(Sender: TObject);
    procedure ToggleEnableBClick(Sender: TObject);
    procedure BreakPGRDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure BreakPGRDblClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FScript: TfsScript;
    FScriptRunning: Boolean;
    FSynMemo: TfrxSyntaxMemo;
    procedure SetSynMemo(const Value: TfrxSyntaxMemo);
    procedure BPListUpdated(Sender: TObject);
{$IFNDEF FPC}
  protected
    function GetCaptionFromResources: string; override;
{$ENDIF}
  public
    destructor Destroy; override;
    procedure SetColor(const Value: TColor);
    procedure UpdateList;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property Script: TfsScript read FScript write FScript;
    property ScriptRunning: Boolean read FScriptRunning write FScriptRunning;
    property SynMemo: TfrxSyntaxMemo read FSynMemo write SetSynMemo;
  end;


implementation
end.
