{******************************************}
{                                          }
{             FastReport VCL               }
{           Module for using               }
{       TEdgeBrowser as a browser          }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{                                          }
{******************************************}
unit frxBrowserEdge;

interface

{$I frx.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frxBrowser,
  Math,
  Vcl.Edge,WebView2;
type

  TfrxBrowserEdge = class(TEdgeBrowser,IfrxWebBrowser)
  private
    FURL: String;
    FNavigateHistory: TStringList;
    FOnTestURL: TTestURLEvent;
    FOnDocumentComplet: TNotifyEvent;
    FOnNavComplete: TNavComplete;
    function GetNavigateHistory : TStringList; stdcall;
    function GetOnDocumentComplet : TNotifyEvent; stdcall;
    function GetOnTestURL : TTestURLEvent; stdcall;
    function GetURL : String; stdcall;
    function GetDocument: IDispatch; stdcall;
    procedure SetNavigateHistory(const Value: TStringList); stdcall;
    procedure SetOnDocumentComplet(const Value: TNotifyEvent); stdcall;
    procedure SetOnTestURL(const Value: TTestURLEvent); stdcall;
    procedure SetURL(const Value: String); stdcall;
    procedure SetOnNavComplete(const Value: TNavComplete); stdcall;
    procedure BrowserConfiguration; stdcall;
    procedure CloseQuery(var CanClose: Boolean); stdcall;
    procedure EdgeBrowserNavigationCompleted(Sender: TCustomEdgeBrowser; IsSuccess: Boolean; WebErrorStatus: COREWEBVIEW2_WEB_ERROR_STATUS);
    protected
      procedure   NavigateURL(aURL : String); stdcall;
    public
      constructor Create(AOwner: TComponent); override;
  end;
implementation
end.
