{******************************************}
{                                          }
{             FastReport VCL               }
{           Module for using               }
{       TWebBrowser as a browser           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{                                          }
{******************************************}
unit frxBrowserWeb;

interface

{$I frx.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, frxBrowser,
  OleCtrls,
  frxFPUMask {save Exception mask SHDocVw changes it },
  SHDocVw, Math;
type

  TfrxBrowserWeb = class(TWebBrowser,IfrxWebBrowser)
  {$IfDef DELPHI16}
    procedure WebBrowserNavigateComplete2(ASender: TObject;
      const pDisp: IDispatch; const URL: OleVariant);
  {$Else}
    procedure WebBrowserNavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
  {$EndIf}
  private
    FURL: String;
    FNavigateHistory: TStringList;
    FOnTestURL: TTestURLEvent;
    FOnDocumentComplet: TNotifyEvent;
    FOnNavComplete: TNavComplete;
    function GetNavigateHistory : TStringList; stdcall;
    function GetOnDocumentComplet : TNotifyEvent; stdcall;
    function GetOnTestURL : TTestURLEvent; stdcall;
    function GetURL : String; stdcall;
    function GetDocument: IDispatch; stdcall;
    procedure SetNavigateHistory(const Value: TStringList); stdcall;
    procedure SetOnDocumentComplet(const Value: TNotifyEvent); stdcall;
    procedure SetOnTestURL(const Value: TTestURLEvent); stdcall;
    procedure SetOnNavComplete(const Value: TNavComplete); stdcall;
    procedure SetURL(const Value: String); stdcall;
    procedure BrowserConfiguration; stdcall;
    procedure CloseQuery(var CanClose: Boolean); stdcall;
    procedure SetListenerPort(const Value: Integer); stdcall;
    procedure SetRedirectURL(const Value: String); stdcall;
{$IfDef DELPHI16}
    procedure NavigateError(ASender: TObject; const pDisp: IDispatch; const URL,
      Frame, StatusCode: OleVariant; var Cancel: WordBool);
    procedure DocumentComplet(ASender: TObject; const pDisp: IDispatch; const URL: OleVariant);
{$Else}
    procedure DocumentComplet(ASender: TObject; const pDisp: IDispatch; var URL: OleVariant);
{$EndIf}
  protected
    procedure NavigateURL(aURL : String); stdcall;
  public
    constructor Create(AOwner: TComponent); override;
  end;

implementation
end.
