unit frxCades;

interface

{$I frx.inc}

uses
{$IFNDEF NONWINFPC}
  Windows,
{$ELSE}
  LCLType,
{$ENDIF}
  Types, frxWinCrypt;

type
  LPCWSTR = PWideChar;
  LPCSTR = PAnsiChar;

const
  CADES_DEFAULT       = $00000000;
  CADES_BES           = $00000001;
  CADES_T             = $00000005;
  CADES_X_LONG_TYPE_1 = $0000005D;
  PKCS7_TYPE          = $0000ffff;

type
  _CADES_AUTH_PARA = record
    dwSize: DWORD;
    dwAuthType: DWORD;
    wszUsername: LPCWSTR;
    wszPassword: LPCWSTR;
    pClientCertificate: PCCERT_CONTEXT;
  end;
  CADES_AUTH_PARA = _CADES_AUTH_PARA;
  PCADES_AUTH_PARA = ^_CADES_AUTH_PARA;

  _CADES_SERVICE_CONNECTION_PARA = record
    dwSize: DWORD;
    wszUri: LPCWSTR;
    pAuthPara: PCADES_AUTH_PARA;
  end;
  CADES_SERVICE_CONNECTION_PARA = _CADES_SERVICE_CONNECTION_PARA;
  PCADES_SERVICE_CONNECTION_PARA = ^_CADES_SERVICE_CONNECTION_PARA;

  _CADES_PROXY_PARA = record
    dwSize: DWORD;
    wszProxyUri: LPCWSTR;
    pProxyAuthPara: PCADES_AUTH_PARA;
  end;
  CADES_PROXY_PARA = _CADES_PROXY_PARA;
  PCADES_PROXY_PARA = ^_CADES_PROXY_PARA;

  _CADES_SIGN_PARA = record
    dwSize: DWORD;
    dwCadesType: DWORD;
    pSignerCert: PCCERT_CONTEXT;
    szHashAlgorithm: LPCSTR;
    hAdditionalStore: HCERTSTORE;
    pTspConnectionPara: PCADES_SERVICE_CONNECTION_PARA;
    pProxyPara: PCADES_PROXY_PARA;
    pCadesExtraPara: LPVOID;
    cAdditionalOCSPServices: DWORD;
    rgAdditionalOCSPServices: ^LPCWSTR;
  end;
  CADES_SIGN_PARA = _CADES_SIGN_PARA;
  PCADES_SIGN_PARA = ^_CADES_SIGN_PARA;

  _CADES_SIGN_MESSAGE_PARA = record
    dwSize: DWORD;
    pSignMessagePara: PCRYPT_SIGN_MESSAGE_PARA;
    pCadesSignPara: PCADES_SIGN_PARA;
  end;
  CADES_SIGN_MESSAGE_PARA = _CADES_SIGN_MESSAGE_PARA;
  PCADES_SIGN_MESSAGE_PARA = ^_CADES_SIGN_MESSAGE_PARA;

  _CADES_ENHANCE_MESSAGE_PARA = record
    dwSize: DWORD;
    dwMsgEncodingType: DWORD;
    pCadesSignPara: PCADES_SIGN_PARA;
  end;
  CADES_ENHANCE_MESSAGE_PARA = _CADES_ENHANCE_MESSAGE_PARA;
  PCADES_ENHANCE_MESSAGE_PARA = ^_CADES_ENHANCE_MESSAGE_PARA;

type
  TCadesSignMessage = function(
    pSignPara: PCADES_SIGN_MESSAGE_PARA;
    fDetachedSignature: BOOL;
    cToBeSigned: DWORD;
    rgpbToBeSigned: PPByte;
    rgcbToBeSigned: PDWORD;
    ppSignedBlob: PCRYPT_DATA_BLOB
  ): LongBool; stdcall;

  TCadesEnhanceMessage = function(
    pEnhancePara: PCADES_ENHANCE_MESSAGE_PARA;
    dwSignerIndex: DWORD;
    pbSignedBlob: PByte;
    cbSignedBlob: DWORD;
    ppEnhancedBlob: PPCRYPT_DATA_BLOB
  ): LongBool; stdcall;

  TCadesFreeBlob = function(
    pBlob: PCRYPT_DATA_BLOB
  ): LongBool; stdcall;

implementation
end.
