unit frxCellularTextEdit;

{$I frx.inc}

//debug define
//{$DEFINE DEBUGCLR}
//testdefine
{$DEFINE DOUBLEWORK}

interface

uses
{$IFNDEF FPC}
  Windows, WideStrings,
{$ELSE}
  LCLType, LMessages, LazHelper, LCLIntf,
{$ENDIF}
  Classes, Types, SysUtils, Forms, Controls, Messages, StdCtrls, Graphics, Dialogs, 
  frCoreClasses, frUnicodeUtils, frxCellularTextObject, frxTableObject, frxClass, frTypes;

type

  TfrxCellTag = class;

{ Table Helper }

  TfrxCellularTableObject = class(TfrxTableObject)
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    class function CreateTableRow: TfrxCustomTableRow; override;
  end;

  TfrxCellularTableRow = class(TfrxTableRow)
  public
    function CreateTableCell(Index: Integer; bSetUniqueName: Boolean = False): TObject; override;
  end;

  TfrxCellularTableCell = class(TfrxTableCell)
  protected
    procedure SetIsSelected(const Value: Boolean); override;
    function GetPoint: TPoint;
  public
    frxCelluralTag: TfrxCellTag;

    destructor Destroy; override;
    procedure CreateCellTag(Ln, LinesCount, sTextCount, IDX, I: Integer); override;
  end;

{ Tag Class }
  TfrxCellType = (ctBottom, ctLeft, ctRight, ctString);

  TfrxCellTag = class
  public
    Value: Integer;
    sType: TfrxCellType;
    constructor Create(vsType: TfrxCellType); overload;
    constructor Create(vsType: TfrxCellType; vValue: Integer); overload;
  end;

{ Hack CellView }

  THackfrxCellularText = class(TfrxCellularText)
  public
    //procedure BuildTable(aTable: TfrxTableObject); override;
  end;

{ Cell Editor }

  TfrxCellularTextControl = class(TCustomControl)
  private
    FCellularText: TfrxCellularText;
    FTable: TfrxTableObject;
    FZoom: Extended;
    FSelStart: TPoint;
    FSelEnd: TPoint;
    FIsMouseDown: Boolean;
    FFakeList: TWideStrings;
    FMemo: TMemo;

    procedure SetZoom(zm: Extended);
    procedure SetCellularText(const Value: TfrxCellularText);
    procedure SetSelStart(vSelStart: TPoint);
    procedure SetSelEnd(vSelEnd: TPoint);
    procedure SetModified(const Value: Boolean);
    function GetModified: Boolean;

    procedure MemoSelToSelfSel;
    procedure SelfSelToMemo;

    function ListToFakeToPoint(val: Integer): TPoint;
    function PointToFakeToList(vPoint: TPoint): Integer;

    procedure ClearSelection;
    procedure RebuildTable;
    procedure ValidatePoint(var vPoint: TPoint);

    procedure SendMassageToMemo(var Message: TMessage);
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;

    property Zoom: Extended read FZoom write SetZoom;
    property CellularText: TfrxCellularText read FCellularText write SetCellularText;
    property Modified: Boolean read GetModified write SetModified;
    property SelStart: TPoint read FSelStart write SetSelStart;
    property SelEnd: TPoint read FSelEnd write SetSelEnd;
    property FakeLines: TWideStrings read FFakeList;

    property OnKeyPress;
    property OnKeyDown;
    property Color;
   {$IFNDEF FPC}
    property Ctl3D;
   {$ENDIF}
  end;

{ Point Helpers }
  function ComparePoint(a, b: TPoint): Boolean;
  procedure CheckBufSwap(var vSelStart, vSelEnd: TPoint);

implementation
end.

