
{******************************************}
{                                          }
{             FastReport VCL               }
{           Certificate Dialog             }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxCertificateDialog;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
{$ELSE}
  LCLType, LCLIntf, LCLProc, LazHelper, ColorBox, Forms,
{$ENDIF}
  Classes, Controls, StdCtrls, ExtCtrls, Buttons, Dialogs, SysUtils,
  frxBaseForm, frxCertificateList, frxHelpers
{$IFDEF FPC}
  , EditBtn
{$ENDIF};

type
  TfrxCertificateDialog = class(TfrxBaseForm)
    CertificateStoreRadioGroup: TRadioGroup;
    PFXFileGroupBox: TGroupBox;
    PFXFileSpeedButton: TSpeedButton;
    PasswordLabel: TLabel;
    PFXFileEdit: TEdit;
    PasswordEdit: TEdit;
    PFXFileOpenDialog: TOpenDialog;
    FoundLabel: TLabel;
    CertificateComboBox: TComboBox;
    CertificatePropertiesMemo: TMemo;
    CancelB: TButton;
    OkB: TButton;
    AllowExpiredCheckBox: TCheckBox;
    SubjectContainEdit: TEdit;
    IgnoreCaseCheckBox: TCheckBox;
    IssuerContainEdit: TEdit;
    IssuerLabel: TLabel;
    SubjectLabel: TLabel;
    OnkyGOSTCheckBox: TCheckBox;

    procedure PFXFileSpeedButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DataChanged(Sender: TObject);
    procedure CertificateComboBoxChange(Sender: TObject);
  private
    function Kind: TfrxCertificateStoreKind;
    function PFXFile: TFileName;
    function Password: AnsiString;
    function IgnoreCase: Boolean;
    function SubjectSubStr: string;
    function IssuerSubStr: string;
    function AllowExpired: Boolean;
    function OnlyGOST: Boolean;
  private
    function GetIsEmpty: Boolean;
    function GetSelected: Integer;
    function GetCertificateData: TfrxCertificateData;
    procedure SetCertificateData(const Value: TfrxCertificateData);

    property IsEmpty: Boolean read GetIsEmpty;
    property Selected: Integer read GetSelected;
  protected
    FCertificateList: TfrxCertificateList;
    FUpdateEnabled: Boolean;

    procedure UpdateControls;
    procedure UpdateCertificateProperties;
  public
    procedure UpdateResouces; override;

    property CertificateData: TfrxCertificateData read GetCertificateData write SetCertificateData;
  end;

  function CertificateDialog(var Certificate: TfrxCertificate): TModalResult; overload;
  function CertificateDialog(var Certificate: TfrxCertificate; var CD: TfrxCertificateData): TModalResult; overload;

implementation
end.
