
{******************************************}
{                                          }
{             FastReport VCL               }
{           Chart design editor            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxChartEditor;

interface
{$I frx.inc}
{$I frTeeChartVer.inc}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Variants,
  StdCtrls, Menus, ExtCtrls, Buttons,
{$IFDEF DELPHI16}
  VCLTee.TeeProcs, VCLTee.TeEngine, VCLTee.Chart, VCLTee.Series,
  {$IFDEF DELPHI11}
    VCLTee.TeeGalleryAlternate,
  {$ELSE}
    TeeGally,
  {$ENDIF}
{$ELSE}
  TeeProcs, TeEngine, Chart, Series,
  {$IFDEF DELPHI11}
    TeeGalleryAlternate,
  {$ELSE}
    TeeGally,
  {$ENDIF}
{$ENDIF}
  frGraphics, frAppearance, frControls, frTreeView,
  frxClass, frxChart, frxCustomEditors, frxCtrls, frxInsp, frxDock, ComCtrls, frxBaseForm, ImgList;

type
  TfrxChartEditor = class(TfrxViewEditor)
  public
    function Edit: Boolean; override;
    function HasEditor: Boolean; override;
    procedure GetMenuItems; override;
    function Execute(Tag: Integer; Checked: Boolean): Boolean; override;
  end;

  TfrxHackReport = class(TfrxReport);

  TfrxChartEditorForm = class(TfrxBaseForm)
    OkB: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    ChartImages: TImageList;
    CancelB: TButton;
    SourcePanel: TPanel;
    DataSourceGB: TGroupBox;
    DBSourceRB: TRadioButton;
    BandSourceRB: TRadioButton;
    FixedDataRB: TRadioButton;
    DatasetsCB: TComboBox;
    DatabandsCB: TComboBox;
    OptionsGB: TGroupBox;
    ShowTopLbl: TLabel;
    CaptionLbl: TLabel;
    SortLbl: TLabel;
    XLbl: TLabel;
    TopNE: TEdit;
    TopNCaptionE: TEdit;
    SortCB: TComboBox;
    UpDown1: TUpDown;
    XTypeCB: TComboBox;
    InspSite: TPanel;
    HintL: TLabel;
    Panel3: TPanel;
    ChartTree: TfrTreeView;
    TreePanel: TPanel;
    AddB: TSpeedButton;
    DeleteB: TSpeedButton;
    EditB: TSpeedButton;
    UPB: TSpeedButton;
    DownB: TSpeedButton;
    ValuesGB: TGroupBox;
    Values1L: TLabel;
    Values2L: TLabel;
    Values3L: TLabel;
    Values4L: TLabel;
    Values5L: TLabel;
    Values6L: TLabel;
    Values7L: TLabel;
    Values8L: TLabel;
    Values9L: TLabel;
    Values10L: TLabel;
    Values1CB: TComboBox;
    Values2CB: TComboBox;
    Values3CB: TComboBox;
    Values4CB: TComboBox;
    Values5CB: TComboBox;
    Values6CB: TComboBox;
    Values7CB: TComboBox;
    Values8CB: TComboBox;
    Values9CB: TComboBox;
    Values10CB: TComboBox;
    procedure FormShow(Sender: TObject);
    procedure ChartTreeClick(Sender: TObject);
    procedure AddBClick(Sender: TObject);
    procedure DeleteBClick(Sender: TObject);
    procedure DoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DatasetsCBClick(Sender: TObject);
    procedure DatabandsCBClick(Sender: TObject);
    procedure DBSourceRBClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);
    procedure EditBClick(Sender: TObject);
    procedure ChartTreeEdited(Sender: TObject; Node: TfrTreeViewNode; var S: String);
    procedure ChartTreeEditing(Sender: TObject; Node: TfrTreeViewNode; var AllowEdit: Boolean);
    procedure UPBClick(Sender: TObject);
    procedure DownBClick(Sender: TObject);
    procedure ChartTreeChange(Sender: TObject; Node: TfrTreeViewNode);
  private
    { Private declarations }
    FChart: TfrxChartView;
    FCurSeries: TfrxSeriesItem;
    FInspector: TfrxObjectInspector;
    FModified: Boolean;
    FReport: TfrxReport;
    FUpdating: Boolean;
    FValuesGBHeight: Integer;
    FDesigner: TfrxCustomDesigner;
    FAddBitmap: TBitmap;
    FDeleteBitmap: TBitmap;
    FEditBitmap: TBitmap;
    FUPBitmap: TBitmap;
    FDownBitmap: TBitmap;
    procedure FillDropDownLists(ds: TfrxDataset);
    procedure SetCurSeries(const Value: TfrxSeriesItem);
    procedure SetModified(const Value: Boolean);
    procedure ShowSeriesData;
    procedure UpdateSeriesData;
    property Modified: Boolean read FModified write SetModified;
    property CurSeries: TfrxSeriesItem read FCurSeries write SetCurSeries;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property Chart: TfrxChartView read FChart write FChart;
  end;


implementation
end.
