
{******************************************}
{                                          }
{             FastReport VCL               }
{         TeeChart InPlace Editor          }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxChartInPlaceEditor;

interface

{$I frx.inc}
{$I frTeeChartVer.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  frxClass, frxChart, frxInPlaceEditors,
{$IFDEF DELPHI16}
  VCLTee.TeeProcs, VCLTee.TeEngine, VCLTee.Chart, VCLTee.Series, VCLTee.TeCanvas
{$ELSE}
  TeeProcs, TeEngine, Chart, Series, TeCanvas
{$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};

type
  TfrxInPlaceChartEditor = class(TfrxInPlaceBasePanelEditor)
  protected
    FDrawButton: Boolean;
    F3DMode: Boolean;
    function GetItem(Index: Integer): Boolean; override;
    procedure SetItem(Index: Integer; const Value: Boolean); override;
    function Count: Integer; override;
    function GetName(Index: Integer): String; override;
    function GetColor(Index: Integer): TColor; override;
  public
    function DoMouseUp(X, Y: Integer; Button: TMouseButton;
      Shift: TShiftState; var EventParams: TfrxInteractiveEventsParams): Boolean; override;
    procedure DrawCustomEditor(aCanvas: TCanvas; aRect: TRect); override;
    procedure InitializeUI(var EventParams: TfrxInteractiveEventsParams); override;
    procedure FinalizeUI(var EventParams: TfrxInteractiveEventsParams); override;
  end;

implementation
end.
