
{******************************************}
{                                          }
{             FastReport VCL               }
{          Connection list editor          }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxConnEditor;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, frxClass, frxConnItemEdit, frxBaseForm
  {$IFDEF FPC}
  , LCLType
  {$ENDIF}
{$IFDEF FR_FIB}
  , ADODB, frxConnType, frxFIBConnItemEdit, frxFIBComponents
{$ENDIF}
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF}
;

type
  TfrxConnEditorForm = class(TfrxBaseForm)
    NewB: TButton;
    DeleteB: TButton;
    ConnLV: TListView;
    OKB: TButton;
    EditB: TButton;
    TestB: TButton;
    procedure NewBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DeleteBClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure OKBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditBClick(Sender: TObject);
    procedure TestBClick(Sender: TObject);
  private
    { Private declarations }
    {$IFNDEF FPC}
    procedure ReadADOConnections;
    procedure SaveADOConnections;
    {$ENDIF}
{$IFDEF FR_FIB}
    procedure ReadFIBConnections;
    procedure SaveFIBConnections;
{$ENDIF}
  public
    { Public declarations }
    Report: TfrxReport;
    procedure UpdateResouces; override;
  end;


implementation
end.
