(*
 * Copyright 2013 ZXing authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org.ext.zawq.ru/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *)
{$I frx.inc}

unit frxDelphiZXIngAztecCode;

interface

uses frxBarcode2DBase;

const
  DEFAULT_EC_PERCENT = 33; // default minimal percentage of error check words

type
  TAztecEncoder = class
  private
    FData: WideString;
    FMatrixSize: integer;
    FMinECCPercent: integer;

    function GetIsBlack(Row, Column: integer): Boolean;
    procedure SetData(const Value: WideString);
    procedure SetMinECCPercent(const Value: integer);
  protected
    procedure Update;

  public
    FElements: T2DBooleanArray;

    constructor Create;

    property IsBlack[Row, Column: integer]: Boolean read GetIsBlack;
    property Data: WideString read FData write SetData;
    property MatrixSize: integer read FMatrixSize;
    property MinECCPercent: integer read FMinECCPercent write SetMinECCPercent;
  end;

implementation
end.

