
{******************************************}
{                                          }
{             FastReport VCL               }
{               Dialog form                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxDialogForm;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, frxBaseForm,
{$IFDEF FPC}
  LResources, LCLType, LazHelper, LMessages,
{$ENDIF}
{$IFDEF DELPHI6}
  Variants,
{$ENDIF}
  frTypes;

type

  { TfrxDialogForm }

  TfrxDialogForm = class(TfrxBaseForm)
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DoCreateWnd;
    procedure DoDestroyWnd;
    procedure DoCreateHandle;
    procedure DoDestroyHandle;
{$IFNDEF FPC}
    procedure DoDestroyWindowHandle;
{$ENDIF}
  protected
    procedure SetParent(AParent: TWinControl); override;
    procedure ReadState(Reader: TReader); override;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure CreateHandle; override;
{$IFDEF DELPHI9}
    procedure DestroyHandle; override;
{$ENDIF}
{$IFNDEF FPC}
    procedure DestroyWindowHandle; override;
{$ENDIF}
  private
    FOnModify: TNotifyEvent;
    FThreadSafe: Boolean;
    FDialogPageControl: TComponent;
    {$IFNDEF FPC}
    procedure WMExitSizeMove(var Msg: TMessage); message WM_EXITSIZEMOVE;
    {$ELSE}
    FIsLMSizeMove: Boolean;
    procedure LMSizeMove(var Msg: TMessage); message LM_WINDOWPOSCHANGED;
    procedure LMSize(var Msg: TMessage); message LM_SIZE;
    procedure LMMOVE(var Msg: TMessage); message LM_MOVE;
    {$ENDIF}
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
  public
    constructor Create(AOwner: TComponent); override;
    {$IFDEF FPC}
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: integer); override;
    {$ENDIF}
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property OnModify: TNotifyEvent read FOnModify write FOnModify;
    property ThreadSafe: Boolean read FThreadSafe write FThreadSafe;
  end;

implementation
end.
