
{******************************************}
{                                          }
{             FastReport VCL               }
{              Aliases editor              }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditFieldDefs;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, frxInsp,
  StdCtrls, ComCtrls, frxClass, frxBaseForm, frxDock
  {$IFDEF FPC}
  , LResources, LCLType
  {$ENDIF}
{$IFDEF Delphi6}
, Variants, ToolWin, CheckLst, ExtCtrls
{$ENDIF};
  

type
  TfrxCustomDBDataSetHack = class(TfrxCustomDBDataSet);
  TfrxFieldDefsEditorForm = class(TfrxBaseForm)
    AlignPanel: TPanel;
    Splitter: TSplitter;
    InspectorPanel: TPanel;
    ToolBar: TToolBar;
    UpdateBtn: TToolButton;
    ResetBtn: TToolButton;
    OkBtn: TToolButton;
    CancelBtn: TToolButton;
    AddFieldDef: TToolButton;
    RemoveFieldDef: TToolButton;
    FieldsLB: TCheckListBox;
    frxTBPanel: TfrxTBPanel;
    DSAliasL: TLabel;
    DSAliasE: TEdit;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    procedure FieldsLBClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ResetBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpdateBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DoUpdateDefsList;
    procedure CancelBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure FieldsLBClickCheck(Sender: TObject);
    procedure AddFieldDefClick(Sender: TObject);
    procedure RemoveFieldDefClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FDataSet: TfrxCustomDBDataset;
    FInspector: TfrxObjectInspector;
    FFieldDefs: TfrxFieldDefs;
    procedure DoModify(Sender: TObject);
    procedure FillDefsList;
    procedure InpectProps;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property DataSet: TfrxCustomDBDataset read FDataSet write FDataSet;
  end;


implementation
end.
