
{******************************************}
{                                          }
{             FastReport VCL               }
{               Fill editor                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditFill;

interface

{$I frx.inc}

uses
{$IFDEF FPC}
  LCLType, LMessages, LazHelper, LCLIntf,
{$ELSE}
  Windows, Messages,
{$ENDIF}  
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, frxClass, frxDesgnCtrls, frxBaseForm
{$IFDEF DELPHI6}
, Variants
{$ENDIF}
;

type
  TfrxFillEditorForm = class(TfrxBaseForm)
    PageControl: TPageControl;
    BrushTS: TTabSheet;
    GradientTS: TTabSheet;
    GlassTS: TTabSheet;
    BrushBackColorL: TLabel;
    BrushForeColorL: TLabel;
    BrushStyleL: TLabel;
    BrushStyleCB: TComboBox;
    GradientStyleL: TLabel;
    GradientStyleCB: TComboBox;
    GradientStartColorL: TLabel;
    GradientEndColorL: TLabel;
    GlassOrientationL: TLabel;
    GlassOrientationCB: TComboBox;
    GlassColorL: TLabel;
    GlassBlendL: TLabel;
    GlassHatchCB: TCheckBox;
    OKB: TButton;
    CancelB: TButton;
    SampleP: TPanel;
    GlassBlendE: TEdit;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BrushStyleCBDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure PageControlChange(Sender: TObject);
    procedure BrushStyleCBChange(Sender: TObject);
    procedure GradientStyleCBChange(Sender: TObject);
    procedure GlassOrientationCBChange(Sender: TObject);
    procedure GlassHatchCBClick(Sender: TObject);
    procedure GlassBlendEExit(Sender: TObject);
  private
    { Private declarations }
    FBrushFill: TfrxBrushFill;
    FGradientFill: TfrxGradientFill;
    FGlassFill: TfrxGlassFill;
    FIsSimpleFill: Boolean;
    BrushBackColorCB: TfrxColorComboBox;
    BrushForeColorCB: TfrxColorComboBox;
    GradientStartColorCB: TfrxColorComboBox;
    GradientEndColorCB: TfrxColorComboBox;
    GlassColorCB: TfrxColorComboBox;
    function GetFill: TfrxCustomFill;
    procedure SetFill(Value: TfrxCustomFill);
    procedure SetIsSimpleFill(Value: Boolean);
    procedure UpdateControls;
    procedure Change;
    procedure BrushBackColorChanged(Sender: TObject);
    procedure BrushForeColorChanged(Sender: TObject);
    procedure GradientStartColorChanged(Sender: TObject);
    procedure GradientEndColorChanged(Sender: TObject);
    procedure GlassColorChanged(Sender: TObject);
  public
    { Public declarations }
    procedure UpdateResouces; override;
    property Fill: TfrxCustomFill read GetFill write SetFill;
    property IsSimpleFill: Boolean read FIsSimpleFill write SetIsSimpleFill;
  end;


implementation
end.
