
{******************************************}
{                                          }
{             FastReport VCL               }
{           DisplayFormat editor           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditFormat;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, frxClass, frxBaseForm
  {$IFDEF FPC}
  , LResources, LCLType
  {$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};


type
  TfrxFormatEditorForm = class(TfrxBaseForm)
    OkB: TButton;
    CancelB: TButton;
    CategoryLB: TListBox;
    FormatLB: TListBox;
    GroupBox1: TGroupBox;
    FormatStrL: TLabel;
    SeparatorL: TLabel;
    FormatE: TEdit;
    SeparatorE: TEdit;
    ComboBox1: TComboBox;
    ExpressionL: TLabel;
    CategoryL: TLabel;
    FormatL: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure CategoryLBClick(Sender: TObject);
    procedure FormatLBDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure FormatLBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    FMemo: TfrxCustomMemoView;
    FMemoText: WideString;
    FFormats: TfrxFormatCollection;
    FCurFormat: TfrxFormat;
    procedure FillFormats;
    procedure SetMemo(Value: TfrxCustomMemoView);
    procedure UpdateCurFormat;
    procedure UpdateControls;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    property Memo: TfrxCustomMemoView read FMemo write SetMemo;
    property MemoText: WideString read FMemoText write FMemoText;
  end;


implementation
end.
