
{******************************************}
{                                          }
{             FastReport VCL               }
{              Frame editor                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditFrame;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ExtCtrls, StdCtrls, ComCtrls, ToolWin, Buttons, frxCtrls, frxDock,
  frxClass, frxDesgnCtrls, frxBaseForm
  {$IFDEF FPC}
  , LResources, LCLType
  {$ENDIF}
  ;

type
  TfrxFrameEditorForm = class(TfrxBaseForm)
    OkB: TButton;
    CancelB: TButton;
    FrameGB: TGroupBox;
    FrameAllB: TSpeedButton;
    FrameNoB: TSpeedButton;
    FrameTopB: TSpeedButton;
    FrameBottomB: TSpeedButton;
    FrameLeftB: TSpeedButton;
    FrameRightB: TSpeedButton;
    ShadowCB: TCheckBox;
    ShadowWidthL: TLabel;
    ShadowWidthCB: TComboBox;
    ShadowColorL: TLabel;
    LineGB: TGroupBox;
    LineStyleL: TLabel;
    LineWidthL: TLabel;
    LineWidthCB: TComboBox;
    LineColorL: TLabel;
    HintL: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FrameAllBClick(Sender: TObject);
    procedure FrameNoBClick(Sender: TObject);
    procedure FrameLineClick(Sender: TObject);
    procedure ShadowCBClick(Sender: TObject);
    procedure ShadowWidthCBChange(Sender: TObject);
  private
    FFrame: TfrxFrame;
    SampleC: TfrxFrameSampleControl;
    LineStyleC: TfrxLineStyleControl;
    ShadowColorCB: TfrxColorComboBox;
    LineColorCB: TfrxColorComboBox;
    procedure SetFrame(const Value: TfrxFrame);
    procedure FrameLineClicked(Line: TfrxFrameType; state: Boolean);
    procedure ShadowColorChanged(Sender: TObject);
    function LineStyle: TfrxFrameStyle;
    function LineWidth: Extended;
    function LineColor: TColor;
    procedure UpdateControls;
    procedure Change;
  public
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property Frame: TfrxFrame read FFrame write SetFrame;
  end;


implementation
end.
