
{******************************************}
{                                          }
{             FastReport VCL               }
{            Highlight editor              }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditHighlight;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, frxClass, ExtCtrls, Buttons, frxCtrls, frxBaseForm
  {$IFDEF FPC}
  , LResources, LCLType
  {$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};
  

type
  TfrxHighlightEditorForm = class(TfrxBaseForm)
    OKB: TButton;
    CancelB: TButton;
    ConditionsGB: TGroupBox;
    HighlightsLB: TListBox;
    AddB: TButton;
    DeleteB: TButton;
    EditB: TButton;
    StyleGB: TGroupBox;
    FrameB: TSpeedButton;
    FrameCB: TCheckBox;
    FillCB: TCheckBox;
    FillB: TSpeedButton;
    FontCB: TCheckBox;
    FontB: TSpeedButton;
    VisibleCB: TCheckBox;
    UpB: TSpeedButton;
    DownB: TSpeedButton;
    FontDialog1: TFontDialog;
    PaintBox1: TPaintBox;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AddBClick(Sender: TObject);
    procedure EditBClick(Sender: TObject);
    procedure DeleteBClick(Sender: TObject);
    procedure HighlightsLBClick(Sender: TObject);
    procedure FrameCBClick(Sender: TObject);
    procedure FillCBClick(Sender: TObject);
    procedure FontCBClick(Sender: TObject);
    procedure VisibleCBClick(Sender: TObject);
    procedure FrameBClick(Sender: TObject);
    procedure FillBClick(Sender: TObject);
    procedure FontBClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure UpBClick(Sender: TObject);
    procedure DownBClick(Sender: TObject);
  private
    FMemoView: TfrxCustomMemoView;
    FHighlights: TfrxHighlightCollection;
    FCurHighlight: TfrxHighlight;
    procedure UpdateHighlights;
    procedure UpdateControls;
    procedure Change;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property MemoView: TfrxCustomMemoView read FMemoView write FMemoView;
  end;


implementation
end.

