
{******************************************}
{                                          }
{             FastReport VCL               }
{            Designer options              }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditOptions;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, frxBaseForm
  {$IFDEF FPC}
  , LCLType
  {$ELSE}
  , frxCtrls
  {$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};
  

type
  TfrxOptionsEditor = class(TfrxBaseForm)
    OkB: TButton;
    CancelB: TButton;
    ColorDialog: TColorDialog;
    RestoreDefaultsB: TButton;
    Label1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    CMRB: TRadioButton;
    InchesRB: TRadioButton;
    PixelsRB: TRadioButton;
    CME: TEdit;
    InchesE: TEdit;
    PixelsE: TEdit;
    DialogFormE: TEdit;
    ShowGridCB: TCheckBox;
    AlignGridCB: TCheckBox;
    Label6: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CodeWindowFontCB: TComboBox;
    CodeWindowSizeCB: TComboBox;
    MemoEditorFontCB: TComboBox;
    MemoEditorSizeCB: TComboBox;
    ObjectFontCB: TCheckBox;
    Label11: TGroupBox;
    WorkspacePB: TPaintBox;
    ToolPB: TPaintBox;
    WorkspaceB: TButton;
    ToolB: TButton;
    LCDCB: TCheckBox;
    Label5: TGroupBox;
    Label12: TLabel;
    Label17: TLabel;
    EditAfterInsCB: TCheckBox;
    FreeBandsCB: TCheckBox;
    GapE: TEdit;
    BandsCaptionsCB: TCheckBox;
    StartupCB: TCheckBox;
    GuidesStickCB: TCheckBox;
    GuidesAsAnchorCB: TCheckBox;
    CCGB: TGroupBox;
    ShowScriptVARCB: TCheckBox;
    ShowADDVARCB: TCheckBox;
    ShowRttiVARCB: TCheckBox;
    TBE: TEdit;
    Label18: TLabel;
    MultiBCB: TCheckBox;
    LGuidAcc: TLabel;
    EGuidAcc: TEdit;
    Label20: TLabel;
    IntersectionsPB: TPaintBox;
    IntersectionsB: TButton;
    EnableCodeWindowHint: TCheckBox;
    EnableWorkspaceHints: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure WorkspacePBPaint(Sender: TObject);
    procedure ToolPBPaint(Sender: TObject);
    procedure IntersectionsPBPaint(Sender: TObject);
    procedure WorkspaceBClick(Sender: TObject);
    procedure ToolBClick(Sender: TObject);
    procedure IntersectionsBClick(Sender: TObject);
    procedure RestoreDefaultsBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    FWColor: TColor;
    FTColor: TColor;
    FIColor: TColor;
    FPBHeight: integer;
    FPBWidth: integer;
  public
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    procedure UpdateResouces; override;
    { Public declarations }
  end;


implementation
end.
