
{******************************************}
{                                          }
{             FastReport VCL               }
{         Report datasets selector         }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditReportData;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, frxClass, CheckLst, frxBaseForm, frxComCtrls, Menus, ExtCtrls
  {$IFDEF FPC}
  , LCLType
  {$ENDIF}
{$IFDEF Delphi6}
, Variants
{$ENDIF}
{$IFDEF Delphi16}
, System.Types
{$ENDIF}
;



type
  TfrxDataSetsActions = ( dsaSortSelectedData = 59, dsaSortData = 60,
    dsaUnsorted = 127, dsaAscending = 125, dsaDescending = 126,
    dsaUnselected = 113, dsaAll = 128, dsaSelected = 129);

  TfrxDataSetsSortType = (dssUnsorted, dssAscending, dssDescending);
  TfrxDataSetsSortSelectedType = (dsssAll, dsssSelected, dsssUnselected);

  TfrxDataSetItemState = (disUnchecked, disChecked, disMissing);

  TfrxDataSetListItem = class(TCollectionItem)
  private
    FDataSet: TfrxDataSet;
    FDataSetName: String;
    FState: TfrxDataSetItemState;
  public
    property DataSet: TfrxDataSet read FDataSet write FDataSet;
    property DataSetName: String read FDataSetName write FDataSetName;
    property State: TfrxDataSetItemState read FState write FState;
  end;

  TfrxEditorDataSetsList = class(TCollection)
  private
    function GetItem(Index: Integer): TfrxDataSetListItem;
  public
    constructor Create;
    procedure Add(const Name: String; ADataSet: TfrxDataSet; AState: TfrxDataSetItemState);
    property Items[Index: Integer]: TfrxDataSetListItem read GetItem; default;
  end;

  TfrxReportDataForm = class(TfrxBaseForm)
    OKB: TButton;
    CancelB: TButton;
    DatasetsLB: TCheckListBox;
    SelAllCB: TCheckBox;
    DSPanel: TPanel;
    FooterPanel: TPanel;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DatasetsLBClickCheck(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SelAllCBClick(Sender: TObject);
  private
    FStandalone: Boolean;
    FToolWithFilterPanel: TfrxToolWithFilterPanel;
    FSortButton: TfrxToolPanelButton;
    FSortSelectedButton: TfrxToolPanelButton;
    FDataSetsSortType: TfrxDataSetsSortType;
    FDataSetsSortSelectedType: TfrxDataSetsSortSelectedType;
    FSortPopUp: TPopupMenu;
    FSortSelectedPopUp: TPopupMenu;
    FFilter: String;
    FDataSetsList: TfrxEditorDataSetsList;
    procedure BuildConnectionList;
    procedure BuildDatasetList;
    procedure UpdateDataSetLB;
    procedure UpdateCBState;
    procedure UpdateSelectedDS;
    procedure ToolOnClick(Sender: TObject);
    procedure CreatefrxToolWithFilterPanel(var ToolWithFilterPanel: TfrxToolWithFilterPanel);
    procedure CreateSortPopup;
    procedure CreateSortSelectedPopup;
    procedure EditChange(Sender: TObject);
    procedure UpdateControls;
  public
    Report: TfrxReport;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
  end;

implementation
end.
