
{******************************************}
{                                          }
{             FastReport VCL               }
{               SQL editor                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditSQLDialect;

interface

{$I frx.inc}

uses
  SysUtils,
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ToolWin, frxSimpleMemo,
  frxBaseForm, frxInsp, frDialectHelper, frAppearance, frControls, frTreeView
  {$IFDEF FPC}
  , LResources, LCLType
  {$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};


type
  TfrxSQLDialectForm = class(TfrxBaseLoadSavePrefForm)
    PnTree: TPanel;
    TVStyles: TfrTreeView;
    ToolBar: TToolBar;
    TBNewDialect: TToolButton;
    TBNewStyle: TToolButton;
    Splitter1: TSplitter;
    TBDelete: TToolButton;
    PnInsp: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure MemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure TBNewDialectClick(Sender: TObject);
    procedure TBNewStyleClick(Sender: TObject);
    procedure TVStylesChange(Sender: TObject; Node: TfrTreeViewNode);
    procedure TVStylesEdited(Sender: TObject; Node: TfrTreeViewNode; var S: string);
    procedure TBDeleteClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    FInspector: TfrxObjectInspector;
    FSynDialectStyles: TfrSynDialectStyles;
    procedure FillDialects;
    { Private declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property SynDialectStyles: TfrSynDialectStyles read FSynDialectStyles write FSynDialectStyles;
  end;


implementation
end.

