
{******************************************}
{                                          }
{             FastReport VCL               }
{              Style editor                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxEditStyle;

interface

{$I frx.inc}

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, frxBaseForm, frAppearance, frControls, frTreeView,
  {$IFDEF FPC}
  LCLType,
  {$ELSE}
  ToolWin, ImgList,
  {$ENDIF}
  frxClass, frxDesgnCtrls, frxCtrls, frxDock, Menus;

type
  TfrxStyleEditorForm = class(TfrxBaseForm)
    ToolBar: TToolBar;
    AddB: TToolButton;
    DeleteB: TToolButton;
    Sep1: TToolButton;
    LoadB: TToolButton;
    SaveB: TToolButton;
    Sep2: TToolButton;
    CancelB: TToolButton;
    OkB: TToolButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    StylesTV: TfrTreeView;
    EditB: TToolButton;
    PaintBox: TPaintBox;
    ColorB: TButton;
    FontB: TButton;
    FrameB: TButton;
    DefCB: TCheckBox;
    ApplyFillCB: TCheckBox;
    ApplyFontCB: TCheckBox;
    ApplyFrameCB: TCheckBox;
    AddSheetTB: TToolButton;
    StyleSheetPan: TfrxTBPanel;
    StyleSheetCB: TfrxComboBox;
    DeleteSheetTB: TToolButton;
    StyleBookModeTB: TToolButton;
    StyleModePopup: TPopupMenu;
    StyleBookDesignMI: TMenuItem;
    StyleBookPreviewMI: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelBClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure AddBClick(Sender: TObject);
    procedure DeleteBClick(Sender: TObject);
    procedure LoadBClick(Sender: TObject);
    procedure SaveBClick(Sender: TObject);
    procedure BClick(Sender: TObject);
    procedure StylesTVClick(Sender: TObject);
    procedure StylesTVEdited(Sender: TObject; Node: TfrTreeViewNode; var S: String);
    procedure EditBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DefCBClick(Sender: TObject);
    procedure ApplyFillCBClick(Sender: TObject);
    procedure AddSheetTBClick(Sender: TObject);
    procedure StyleSheetCBChange(Sender: TObject);
    procedure DeleteSheetTBClick(Sender: TObject);
    procedure StyleBookDesignMIClick(Sender: TObject);
  private
    FImageList: TImageList;
    FReport: TfrxReport;
    FStyles: TfrxStyles;
    FIsLocked: Boolean;
    FontColorCB: TfrxColorComboBox;
    procedure FontColorCBChanged(Sender: TObject);
    procedure UpdateStyles(Focus: Integer = 0);
    procedure UpdateControls;
    procedure UpdateStyleSheetControls;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(ANewPPI: Integer); override;
  end;


implementation
end.
