
{******************************************}
{                                          }
{             FastReport VCL               }
{             File Signature               }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxFileSignature;

interface

{$I frx.inc}

uses
  SysUtils, Types,
  frxSignature, frxSignatureEngine, frxCertificateList, frxSignatureEngineCrypto;

type
  TfrxFileSignature = class(TfrxSignature)
  private
    FMessageFileName: TFileName;
    FSignatureFileName: TFileName;
  protected
    function IsReadMessageData(out BDA: TByteDynArray): Boolean;
    function IsSaveSignature(const SignedMessage: TByteDynArray): Boolean;
  public
    constructor Create(
      MessageFileName: TFileName;
      SignatureFileName: TFileName;
      SD: TfrxSignatureData;
      Certificate: TfrxCertificate); overload;
    /// <summary>
    ///   Deprecated
    /// </summary>
    constructor Create(
      Lookup: TCertificateStoreLookup;
      MessageFileName: TFileName;
      SignatureFileName: TFileName;
      CertificatePassword: AnsiString;
      Options: LongWord;
      SignatureType: WORD; // CADES_BES, CADES_T, CADES_X_LONG_TYPE_1
      TSAURL: string = ''); overload;

    procedure SignFile;

    /// <summary>
    ///   Deprecated
    /// </summary>
    procedure SignByCryptoAPI;
    /// <summary>
    ///   Deprecated
    /// </summary>
    procedure SignByCryptoProSDK;
    /// <summary>
    ///   Deprecated
    /// </summary>
    procedure SignByCryptoAPIStampByCryptoProSDK;
  end;

function FileSignatureOptions(Detached, Chain, OnlyGOST, DebugLog, PFXFile: Boolean): Integer;

implementation
end.
