unit frxGaugeEditor;

interface

{$I frx.inc}

uses
  Forms, StdCtrls, ExtCtrls, Classes, Controls, Graphics, Buttons, ComCtrls,
  Dialogs,
{$IFDEF FPC}
  ColorBox,
{$ENDIF}
  frxClass, frxGaugeView, frxBaseForm;

type
  TfrxGaugeEditorForm = class(TfrxBaseForm)
    CancelButton: TButton;
    OkButton: TButton;
    SamplePaintBox: TPaintBox;
    FillButton: TButton;
    FrameButton: TButton;
    GaugeOptionsPageControl: TPageControl;
    GeneralTabSheet: TTabSheet;
    MajorScaleTabSheet: TTabSheet;
    MajorScaleVisibleCheckBox: TCheckBox;
    MinorScaleTabSheet: TTabSheet;
    MinorScaleVisibleCheckBox: TCheckBox;
    PointerTabSheet: TTabSheet;
    GaugeKindComboBox: TComboBox;
    GaugeKindLabel: TLabel;
    PointerKindComboBox: TComboBox;
    PointerKindLabel: TLabel;
    MinimumLabel: TLabel;
    MaximumLabel: TLabel;
    MinimumEdit: TEdit;
    MaximumEdit: TEdit;
    MajorStepLabel: TLabel;
    MajorStepEdit: TEdit;
    CurrentValueEdit: TEdit;
    CurrentValueLabel: TLabel;
    MinorStepEdit: TEdit;
    MinorStepLabel: TLabel;
    MarginsGroupBox: TGroupBox;
    TopLabel: TLabel;
    LeftLabel: TLabel;
    BottomLabel: TLabel;
    RightLabel: TLabel;
    BorderWidthLabel: TLabel;
    BorderColorColorBox: TColorBox;
    BorderColorLabel: TLabel;
    ColorLabel: TLabel;
    ColorColorBox: TColorBox;
    WidthLabel: TLabel;
    HeightLabel: TLabel;
    MajorScaleVisibleDigitsCheckBox: TCheckBox;
    MinorScaleVisibleDigitsCheckBox: TCheckBox;
    MajorScaleBilateralCheckBox: TCheckBox;
    MinorScaleBilateralCheckBox: TCheckBox;
    MinorScaleFormatEdit: TEdit;
    MinorScaleFormatLabel: TLabel;
    MajorScaleFormatLabel: TLabel;
    MajorScaleFormatEdit: TEdit;
    MajorScaleFontButton: TButton;
    MajorScaleFontLabel: TLabel;
    FontDialog: TFontDialog;
    MinorScaleFontButton: TButton;
    MinorScaleFontLabel: TLabel;
    MajorScaleTicksGroupBox: TGroupBox;
    MajorScaleTicksWidthLabel: TLabel;
    MajorScaleTicksLengthLabel: TLabel;
    MajorScaleTicksColorLabel: TLabel;
    MajorScaleTicksColorColorBox: TColorBox;
    MinorScaleTicksGroupBox: TGroupBox;
    MinorScaleTicksWidthLabel: TLabel;
    MinorScaleTicksLengthLabel: TLabel;
    MinorScaleTicksColorLabel: TLabel;
    MinorScaleTicksColorColorBox: TColorBox;
    LeftEdit: TEdit;
    LeftUpDown: TUpDown;
    TopEdit: TEdit;
    TopUpDown: TUpDown;
    RightEdit: TEdit;
    RightUpDown: TUpDown;
    BottomEdit: TEdit;
    BottomUpDown: TUpDown;
    MajorScaleTicksWidthEdit: TEdit;
    MajorScaleTicksWidthUpDown: TUpDown;
    MajorScaleTicksLengthUpDown: TUpDown;
    MajorScaleTicksLengthEdit: TEdit;
    MinorScaleTicksLengthEdit: TEdit;
    MinorScaleTicksLengthUpDown: TUpDown;
    MinorScaleTicksWidthUpDown: TUpDown;
    MinorScaleTicksWidthEdit: TEdit;
    WidthEdit: TEdit;
    WidthUpDown: TUpDown;
    HeightUpDown: TUpDown;
    HeightEdit: TEdit;
    BorderWidthEdit: TEdit;
    BorderWidthUpDown: TUpDown;
    StartValueLabel: TLabel;
    StartValueEdit: TEdit;
    EndValueLabel: TLabel;
    EndValueEdit: TEdit;
    AngleLabel: TLabel;
    AngleUpDown: TUpDown;
    AngleEdit: TEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SamplePaintBoxPaint(Sender: TObject);
    procedure EditFloatKeyPress(Sender: TObject; var Key: Char);
    procedure EditIntKeyPress(Sender: TObject; var Key: Char);
    procedure FillButtonClick(Sender: TObject);
    procedure FrameButtonClick(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);

    procedure ComboBoxChange(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure ColorBoxChange(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
  private
    FBaseGaugeView: TfrxBaseGaugeView;
    FGaugeView, FOriginalGaugeView: TfrxGaugeView;
    FIntervalGaugeView, FOriginalIntervalGaugeView: TfrxIntervalGaugeView;
    FReportDesigner: TfrxCustomDesigner;

    procedure Change;
    procedure SetBaseGaugeView(const Value: TfrxBaseGaugeView);
    procedure FontToLabel(Font: TFont; Lbl: TLabel);
    procedure FontDialogToLabel(Font: TFont; Lbl: TLabel);
  public
    procedure UpdateResouces; override;
    property BaseGaugeView: TfrxBaseGaugeView read FBaseGaugeView write SetBaseGaugeView;
    property ReportDesigner: TfrxCustomDesigner read FReportDesigner write FReportDesigner;
  end;

var
  frxGaugeEditorForm: TfrxGaugeEditorForm;

implementation
end.
