
{******************************************}
{                                          }
{             FastReport VCL               }
{        Gauge Panel VCL Component         }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxGaugePanel;

interface

{$I frx.inc}

uses
  Classes, ExtCtrls, Types, Controls, Messages,
  frxGauge;

type
  TfrxBaseGaugePanel = class(TPanel)
  private
  protected
    FBaseGauge: TfrxBaseGauge;

    procedure CreateGauge; virtual; abstract;
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); override;
    function DoMouseWheel(Shift: TShiftState; WheelDelta: Integer;
      MousePos: TPoint): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

  {$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$ENDIF}
  TfrxGaugePanel = class(TfrxBaseGaugePanel)
  private
    FGauge: TfrxGauge;
    procedure SetGauge(const Value: TfrxGauge);
  protected
    procedure CreateGauge; override;
  public
  published
    property Gauge: TfrxGauge read FGauge write SetGauge;
  end;

  {$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$ENDIF}
  TfrxIntervalGaugePanel = class(TfrxBaseGaugePanel)
  private
    FIntervalGauge: TfrxIntervalGauge;
    procedure SetGauge(const Value: TfrxIntervalGauge);
  protected
    procedure CreateGauge; override;
  public
  published
    property Gauge: TfrxIntervalGauge read FIntervalGauge write SetGauge;
  end;

implementation
end.
