{
Version   12
Copyright (c) 1995-2008 by L. David Baldwin,
Copyright (c) 2008-2010 by HtmlViewer Team
Copyright (c) 2011-2012 by Bernd Gabriel

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Note that the source modules HTMLGIF1.PAS and DITHERUNIT.PAS
are covered by separate copyright notices located in those modules.
}

{$I frxHTMLCons.inc}

unit frxHTMLCaches;

interface

uses
  SysUtils, Classes,
  frxHTMLGlobals;

type

  //BG, 30.04.2011:
  ThtCachable = class(TObject);

//------------------------------------------------------------------------------
// ThtCache is the cache, that holds the above cacheable items.
//------------------------------------------------------------------------------

  ThtCache = class(ThtStringList)
  private
    function GetObject(Index: Integer): ThtCachable; reintroduce;
  protected
    function GetCachable(I: Integer): ThtCachable; {$ifdef UseInline} inline; {$endif}
    property Objects[Index: Integer]: ThtCachable read GetObject;
  public
    constructor Create;
    destructor Destroy; override;
    function AddObject(const S: ThtString; AObject: ThtCachable): Integer; reintroduce;
    procedure Clear; override;
    procedure ClearUnused; virtual;
    function IsFound(const S: ThtString; out Index: Integer): Boolean;
  end;

  ThtCSSCache = class(ThtCache)
  public
    function GetStream(i: Integer): TStream;
    function AddStream(const S: ThtString; AStream: TStream): Integer;

    procedure WriteToStream(Stream: TStream);
    procedure ReadFromStream(Stream: TStream);
  end;

implementation
end.
