
{******************************************}
{                                          }
{             FastReport v5.0              }
{              Picture editor              }
{                                          }
{         Copyright (c) 1998-2020          }
{         by Alexander Tzyganenko,         }
{            Fast Reports Inc.             }
{                                          }
{******************************************}

unit frxHTMLEditor;

interface

{$I frx.inc}

{$IfNDef FPC}
  {$Define UseMetaFile }
{$EndIf}

uses
  SysUtils,
  {$IFNDEF FPC}
  Windows, Messages,
  {$ENDIF}
  Classes, Graphics, Controls, Forms, Dialogs, Buttons, ExtCtrls, ComCtrls,
  frxClass, frxBaseFormEditorDataTree, frxHTML, frxHtmlViewer

  {$IFDEF FPC}
  , LCLType, LazHelper, StdCtrls, ColorBox, frxCtrls
  {$ELSE}
  , StdCtrls , ToolWin, frxCtrls, frxDock
  {$ENDIF}
  ;

type
  TfrxHTMLEditorForm = class(TfrxBaseFormEditorDataTree)
    MainToolBar: TToolBar;
    LoadB: TToolButton;
    OkB: TToolButton;
    ToolButton1: TToolButton;
    CancelB: TToolButton;
    PageControl1: TPageControl;
    SourceTabSheet: TTabSheet;
    HTMLTabSheet: TTabSheet;
    SourceToolBar: TToolBar;
    ExprB: TToolButton;
    AggregateB: TToolButton;
    WordWrapB: TToolButton;
    HTMLPaintBox: TPaintBox;
    HTMLToolBar: TToolBar;
    WidthToolButton: TToolButton;
    ControlSizeToolButton: TToolButton;
    DefaultTabSheet: TTabSheet;
    DefBackgroundColorBox: TColorBox;
    DefBackgroundLabel: TLabel;
    DefFontColorColorBox: TColorBox;
    DefFontColorLabel: TLabel;
    DefFontNameLabel: TLabel;
    DefFontNameComboBox: TfrxFontComboBox;
    DefFontSizeLabel: TLabel;
    DefFontSizeComboBox: TfrxComboBox;
    DefHotSpotColorColorBox: TColorBox;
    DefHotSpotColorLabel: TLabel;
    DefPreFontNameComboBox: TfrxFontComboBox;
    DefPreFontNameLabel: TLabel;
    MarginWidthLabel: TLabel;
    MarginWidthEdit: TEdit;
    MarginWidthUpDown: TUpDown;
    MarginHeightEdit: TEdit;
    MarginHeightUpDown: TUpDown;
    MarginHeightLabel: TLabel;
    OpenDialog: TOpenDialog;
    procedure CancelBClick(Sender: TObject);
    procedure LoadBClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure MemoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure WordWrapBClick(Sender: TObject);
    procedure AggregateBClick(Sender: TObject);
    procedure ExprBClick(Sender: TObject);
    procedure HTMLPaintBoxPaint(Sender: TObject);
    procedure WidthToolButtonClick(Sender: TObject);
    procedure DefFontSizeComboBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ExprMemoDragDrop(Sender, Source: TObject; X, Y: Integer);

    procedure SetViewerByForm;
    procedure SetFormByViewer;
  private
    FHtmlView: TfrxHtmlView;
    FViewer: TfrxHtmlViewer;
    FMemo: TMemo;
    FGraphic: TGraphic;
    FFileName: String;

    procedure SetHtmlView(const AHtmlView: TfrxHtmlView);
  protected
    procedure OnDataTreeDblClick(Sender: TObject); override;
  public
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;

    property HtmlView: TfrxHtmlView write SetHtmlView;
  end;

implementation
end.

