
{******************************************}
{                                          }
{             FastReport VCL               }
{                Helpers                   }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxHelpers;

{$I frx.inc}

interface

uses
  Classes, SysUtils, frXML, frxVariables;

type
  TValueDlm = (vdUnknown, vdApostrophe, vdQuote);

  ESignException = class(Exception);

  TLogList = class(TStringList)
  public
    procedure SafeAdd(const S: string);
    procedure SafeAddStrings(Strings: TStrings);
    procedure Save(FileName: TFileName);
    procedure SaveAppend(FileName: TFileName);
  end;

function IncPointer(P: Pointer; Offset: Cardinal): Pointer;
function IntToAnsiStr(Value: Integer): AnsiString;
function ROL(const Value: LongWord; const Bits: Byte): LongWord;
function ROL16(const Value: Word; const Bits: Byte): Word;
function ROR16(const Value: Word; const Bits: Byte): Word;
function AnsiToHex(st: AnsiString; UpCase: Boolean = True): AnsiString;
function BufferToHex(Buffer: Pointer; Len: Cardinal; UpCase: Boolean = True): AnsiString;

function ByteSwap(Value: Cardinal): Cardinal; overload;
function ByteSwap(Value: Integer): Cardinal; overload;
function ByteSwap(Value: Int64): Int64; overload;

function AnsiStringOfChar(ACh: AnsiChar; Count: Integer): AnsiString;

function ReadExtended8(Stream: TStream): Extended;
function ReadExtended10(Stream: TStream): Extended;
function ReadExtended16(Stream: TStream): Extended;

function ReadWideStringFromStream(Stream: TStream): WideString;
procedure WriteWideStringToStream(Stream: TStream; const ws: WideString);

implementation
end.

