{******************************************}
{                                          }
{             FastReport VCL               }
{              Support Hint                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxHint;

interface

{$I frx.inc}

uses
{$IFDEF FPC}
  LCLIntf, LazHelper,
{$ELSE}
  Messages,
{$ENDIF}
  Forms, Types, Classes, Graphics, Controls, frUnicodeUtils, frGraphicUtils;

const
  HINT_TEXT_SIZE_HEADER = 12;
  HINT_HEADER_PREFIX_COLOR = clMoneyGreen;
  HINT_HEADER_COLOR = $A36215;
  HINT_TEXT_SIZE = 9;
  HINT_PADDING = 10;

type

  TfrxHintShowEvent = procedure(var Msg: TCMHintShow) of object;

  TBaseHintData = class
  private
    FHeaderPrefix: String;
    FHeaderText: String;
    FMultiPaint: Boolean;
    function GetFullText: String;
  public
    constructor Create(vHeaderPrefix, vHeaderText: String; vMultiPaint: Boolean);
    property FullText: String read GetFullText;
    property HeaderPrefix: String read FHeaderPrefix;
    property HeaderText: String read FHeaderText;
    property MultiPaint: Boolean read FMultiPaint;
  end;

  TBaseHintWindow = class(THintWindow)
  protected
    FBaseHintData: TBaseHintData;
    FDrawTextHeader: TfrxDrawText;
    FDrawTextPlain: TfrxDrawText;
    FHeaderHeight: Integer;
    FHintS: String;
    procedure PaintHeader;
    procedure PaintText;
    procedure SetPlainTextOptions; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure ActivateHint(vRect: TRect; const AHint: string); override;
    procedure ResetText;
    procedure SetupDrawText(FDrawText: TfrxDrawText; Color: TColor; FontSize: Integer; TopPos: Integer);
    {$IFNDEF FPC}
    procedure ActivateHintData(vRect: TRect; const AHint: string; AData: Pointer); override;
    {$ELSE}
    function CalcHintRect(MaxWidth: Integer; const AHint: string;
      AData: Pointer): TRect; override;
    {$ENDIF}
    procedure Paint; override;
  end;

implementation
end.
