
{******************************************}
{                                          }
{              FastReport v6.0             }
{            BoxCom Save Filter            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportBoxComBase;

interface

{$I frx.inc}

uses
  Classes, Forms, Controls, StdCtrls, ComCtrls,
  frxIOTransportHelpers, frxBaseTransportConnection, frxIOTransportOAuthDialog;

const
  frx_BoxCom_CreateDir_URL = 'https://api.box.com/2.0/folders';
  frx_BoxCom_DelFile_URL = 'https://api.box.com/2.0/files/%s';
  frx_BoxCom_DelDir_URL = 'https://api.box.com/2.0/folders/%s?recursive=true';
  frx_BoxCom_GetToken_URL = 'https://api.box.com/oauth2/token';
  frx_BoxCom_ListDir_URL = 'https://api.box.com/2.0/folders/%s/items?fields=type,name';
  frx_BoxCom_ListDirContinue_URL = 'https://api.box.com/2.0/folders/%s/items?fields=type,name&offset=%u';
  frx_BoxCom_Upload_URL = 'https://upload.box.com/api/2.0/files/content';
  frx_BoxCom_Download_URL = 'https://api.box.com/2.0/files/%s/content';

type
  TfrxBoxComIOTransportForm = class(TfrxOAuthTransportDialog)
  protected
    function GetHelpLink: String; override;
  public
    procedure UpdateResouces; override;
  end;

{$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxBaseBoxComIOTransport = class(TfrxHTTPIOTransport)
  protected
    function FilterSection: String; override;
    procedure DialogDirChange(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirCreate(Name: String; DirItems: TStrings); override;
    procedure DialogFileDelete(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirDelete(Name, Id: String; DirItems: TStrings); override;

    function GetListFolder: String; virtual; abstract;
    function GetListFolderContinue(Offset: Integer): String; virtual; abstract;
    procedure CreateFolder(Dir: String); virtual; abstract;
    procedure DeleteFile(Id: String); virtual; abstract;
    procedure DeleteFolder(Id: String); virtual; abstract;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    class function GetDescription: String; override;
    class function TransportDialogClass: TfrxBaseTransportDialogClass; override;
    procedure GetDirItems(DirItems: TStrings; aFilter: String = ''); override;
    function GetOAuthURI: String; override;
  end;

implementation
end.
