{******************************************}
{                                          }
{             FastReport VCL               }
{         Default open/save dialog         }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportDialog;

interface

{$I frx.inc}

uses
  SysUtils, Classes, frxClass, Dialogs
{$IFDEF FPC}
    , LCLType, LazHelper, LCLProc
{$ENDIF}
{$IFDEF DELPHI6}
    , Variants
{$ENDIF};

type
  TfrxIOTransportFileDialog = class(TfrxIOTransportFile)
  private
    FSaveDialog: TOpenDialog;
    FFilter: TfrxCustomIOTransport;
  protected
    procedure SetVisibility(const Value: TfrxFilterVisibility); override;
  public
    function OpenFilter: Boolean; override;
    procedure CloseFilter; override;
    function GetStream(aFileName: String = ''): TStream; override;
    procedure FreeStream(aStream: TStream; const aFileName: String = ''); override;
    class function GetDescription: String; override;
    function DoFilterProcessStream(aStream: TStream; ProcesssingObject: TObject): Boolean; override;
  end;

implementation
end.
