
{******************************************}
{                                          }
{              FastReport v6.0             }
{            Dropbox Save Filter           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportDropboxBase;

interface

{$I frx.inc}

uses
  Classes, Forms, Controls, StdCtrls, ComCtrls,
  frxClass, frxIOTransportHelpers, frxBaseTransportConnection, frxIOTransportOAuthDialog;

  const FRX_DBOX_DL_URL = 'https://content.dropboxapi.com/2/files/download';
  const FRX_DBOX_UL_URL = 'https://content.dropboxapi.com/2/files/upload';

type
  TfrxDropboxIOTransportForm = class(TfrxOAuthTransportDialog)
  protected
    function GetHelpLink: String; override;
  public
    procedure UpdateResouces; override;
  end;

{$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxBaseDropboxIOTransport = class(TfrxHTTPIOTransport)
  private
  protected
    function FilterSection: String; override;
    procedure SetRemoteDir(const Value: String); override;
    function GetRemoteDir: String; override;
    procedure TestRemoteDir; override;
    procedure DialogDirChange(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirCreate(Name: String; DirItems: TStrings); override;
    procedure DialogFileDelete(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirDelete(Name, Id: String; DirItems: TStrings); override;

    function FolderAPI(const URL, Source: String): String; virtual; abstract;
    function GetListFolder: String;
    function GetListFolderContinue(Cursor: String): String;
    procedure CreateFolder(Dir: String);
    procedure CreateRemoteDir(DirName: String; ChangeDir: Boolean = True); override;
    procedure DeleteFileOrFolder(Name: String);
    function IsDeleteSupported: Boolean; override;
  public
    class function GetDescription: String; override;
    class function TransportDialogClass: TfrxBaseTransportDialogClass; override;
    procedure GetDirItems(DirItems: TStrings; aFilter: String = ''); override;
    function GetOAuthURI: String; override;
  published
    property RemoteDir;
  end;

implementation
end.
