
{******************************************}
{                                          }
{             FastReport VCL               }
{            Save Filter Dialog            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportIntDialog;

interface

{$I frx.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, frxBaseForm, frxBaseTransportDialogForm;

type
  TfrxIOTransportDialogIntForm = class(TfrxBaseTransportDialogForm)
    CancelB: TButton;
    OkB: TButton;
    FileNameEdit: TEdit;
    FileNameLabel: TLabel;
    CreateDirectoryButton: TButton;
    DeleteButton: TButton;
    DirectoryLV: TListView;
    ListSB: TSpeedButton;
    IconsSB: TSpeedButton;
    FillTimer: TTimer;
    UpdateP: TPanel;
    UpdateL: TLabel;
    RefreshSB: TSpeedButton;
    procedure DirectoryListBoxDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CreateDirectoryButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure IconsSBClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FillTimerTimer(Sender: TObject);
    procedure DirectoryLVClick(Sender: TObject);
  private
    FItemsList: TStrings;

    function GetItems: TStrings;
    procedure UpdateListView;
    function IsConfirm(const Text: String): boolean;
    procedure ListChanged(Sender: TObject);
    procedure StartUpdate;
    procedure EndUpdate;
  protected
    function GetFileName: String; override;
    procedure SetDialogMode(const Value: TfrxIOInternetDialogMode); overload; override;
    procedure SetFileName(const Value: String); override;
    function IsDirectory(Index: Integer): Boolean;
    function IsFile(Index: Integer): Boolean;
    function StripDir(Index: Integer): String;
    function IdOf(Index: Integer): String;
  public
    class function AsFile(fName: String): String;
    class function AsDirectory(fName: String): String;
    procedure DisableDelete; overload; override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property DirItems: TStrings read GetItems;
  end;

implementation
end.
