
{******************************************}
{                                          }
{             FastReport VCL               }
{             Design interface             }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportIntf;

interface

{$I frx.inc}

uses
  SysUtils, Classes, frxClass
{$IFDEF FPC}
  ,LCLType, LazHelper, LCLProc
{$ENDIF}
{$IFDEF DELPHI6}
, Variants
{$ENDIF};


type
  TfrxIOTransportItem = class(TCollectionItem)
  public
    IOTransport: TfrxCustomIOTransport;
  end;

  TfrxIOTransportsCollection = class(TCollection)
  private
    function GetIOTransportItem(Index: Integer): TfrxIOTransportItem;
  public
    constructor Create;
    procedure Register(Filter: TfrxCustomIOTransport);
    procedure Unregister(Filter: TfrxCustomIOTransport);
    property Items[Index: Integer]: TfrxIOTransportItem
      read GetIOTransportItem; default;
  end;

function frxIOTransports: TfrxIOTransportsCollection;
procedure FillItemsList(Items: TStrings; VisibleAt: TfrxFilterVisibleState);
function GetFilterDialogVisibility(CreatedFrom: TfrxFilterVisibleState): TfrxFilterVisibleState;

implementation
end.
