
{******************************************}
{                                          }
{             FastReport VCL               }
{          NextCloud Save Filter           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportNextCloudBase;

interface

{$I frx.inc}

uses
  Classes, IniFiles,
  frxIOTransportHelpers, frxBaseTransportConnection, frxIOTransportOAuthDialog;

type
  TfrxNextCloudIOTransportForm = class(TfrxOAuthTransportDialog)
  protected
    function IsNeedHost: Boolean; override;
    function GetHelpLink: String; override;
  public
    procedure UpdateResouces; override;
  end;

{$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxBaseNextCloudIOTransport = class(TfrxHTTPIOTransport)
  protected
    function GetPrefix: String; override;
    procedure SetPrefix(const APrefix: String); override;

    function FilterSection: String; override;
    procedure DialogDirChange(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirCreate(Name: String; DirItems: TStrings); override;
    procedure DialogFileDelete(Name, Id: String; DirItems: TStrings); override;
    procedure DialogDirDelete(Name, Id: String; DirItems: TStrings); override;

    procedure CreateRemoteDir(DirName: String; ChangeDir: Boolean = True); override;
    procedure ChangeDirUP; override;
    function GetListFolder: String; virtual; abstract;
    procedure CreateFolder(const ADir: String); virtual; abstract;
    procedure DeleteFileOrFolder(const AId: String); virtual; abstract;
    procedure AddToDirItems(DirItems: TStrings; IsFolder, IsFile: Boolean;
      Name: String; Id: String = ''); override;
    function AlwaysUseIniFile: Boolean; override;

    function frx_NextCloud_GetToken_URL: String;
    function frx_NextCloud_Base_URL: String;
    function GetListFolderSource: String;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    class function TransportDialogClass: TfrxBaseTransportDialogClass; override;
    class function GetDescription: String; override;
    procedure GetDirItems(DirItems: TStrings; aFilter: String = ''); override;
    function GetOAuthURI: String; override;
  published
    property Host;
    property Prefix;
  end;

implementation
end.
