
{******************************************}
{                                          }
{             FastReport VCL               }
{          NextCloud Save Filter           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxIOTransportNextCloudIndy;

interface

{$I frx.inc}

uses
  Classes, IdHTTP,
  frxIOTransportNextCloudBase, frxBaseTransportConnection, frxTransportIndyConnectorHTTP;

type
{$IFDEF DELPHI16}
  [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxNextCloudIOTransportIndy = class(TfrxBaseNextCloudIOTransport)
  protected
    function GetListFolder: String; override;
    procedure CreateFolder(const ADir: String); override;
    procedure DeleteFileOrFolder(const Id: String); override;
    procedure Upload(const Source: TStream; DestFileName: String = ''); override;
    procedure Download(const SourceFileName: String; const Source: TStream); override;
    function DoRefreshToken: Boolean; override;
  public
    function GetAccessToken(const AuthorizationCode: String; var ErrorMsg: String): String; override;
    function GetConnectorInstance: TfrxBaseTransportConnectionClass; override;
    class function GetDescription: String; override;
    procedure TestToken; override;
  end;

implementation
end.
