
{******************************************}
{                                          }
{             FastReport VCL               }
{            JSON Manipulation             }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxJSON;

{$I frx.inc}

//{$UnDEF DELPHI20} // todo : !FORCE LkJSON

interface

uses
  {$IfDEF DELPHI20} System.JSON, {$ELSE} frxLkJSON, {$ENDIF}
  {$IFNDEF FPC}
    Windows
  {$ELSE}
    LCLType, LCLIntf, LCLProc
  {$ENDIF};

type
  TfrxJSON = class
  private
    JSONObject: {$IfDef DELPHI20} TJSONObject;
                {$Else}           TlkJSONobject;
                {$EndIf}
    Weak: boolean;
  protected
    ItSelf: TfrxJSON;
  public
    constructor Create(const JSONString: string);
    constructor CreateWeek(const SingleObject: TObject);
    destructor Destroy; override;
    function This: TfrxJSON;
    function IsValid: Boolean;
    function IsNameExists(const Name: string): boolean;
    function IsNameValueExists(const Name, Value: string): boolean;
    function ValueByName(const Name: string): string;
    function ObjectByName(const Name: string): TObject;
    function Count: Integer;
    function IsGetNameValueAsString(Index: Integer; out Name, Value: string): Boolean;
    function ObjectByIndex(Index: Integer): TObject;
  end;

  TfrxJSONArray = class
  private
    JSONArray: {$IfDef DELPHI20} TJSONArray;
               {$Else}           TlkJSONList;
               {$EndIf}
    FIsNULLObj: Boolean;
  public
    constructor Create(const ArrayObject: TObject);
    destructor Destroy; override;
    function This: TfrxJSONArray;
    function Count: integer;
    function Get(Index: Integer): TfrxJSON;
    function GetArray(Index: Integer): TfrxJSONArray;
    function GetInteger(Index: Integer): Integer;
    function GetString(Index: Integer): string;
  end;

implementation
end.
