
{******************************************}
{                                          }
{             FastReport VCL               }
{             ListBox editor               }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxListControlEditor;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages, WideStrings,
{$ELSE}
  LResources, LCLType, LMessages, LazHelper,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ToolWin,
  frCoreClasses, frxClass,
  frxEditFormat, frxEditHighlight, frxBaseFormEditorDataTree, frxListControl;

type
  TfrxListControlEditorForm = class(TfrxBaseFormEditorDataTree)
    MainToolBar: TToolBar;
    LoadB: TToolButton;
    ToolButton1: TToolButton;
    CancelB: TToolButton;
    OkB: TToolButton;
    PageControl1: TPageControl;
    TextTS: TTabSheet;
    ToolBar: TToolBar;
    ExprB: TToolButton;
    AggregateB: TToolButton;
    OpenDialog: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure MemoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ExprBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AggregateBClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ExprMemoDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure LoadBClick(Sender: TObject);
    procedure CancelBClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);
  private
    FMemo: TMemo;
    FListControlView: TfrxCustomListControlView;

    procedure SetListControlView(const Value: TfrxCustomListControlView);
  protected
    procedure OnDataTreeDblClick(Sender: TObject); override;
  public
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;

    property ListControlView: TfrxCustomListControlView read FListControlView write SetListControlView;
  end;

implementation
end.

