
{******************************************}
{                                          }
{             FastReport VCL               }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxLoopBackAutorize;

interface

{$I frx.inc}

uses
  SysUtils, Classes, SyncObjs, ScktComp, Windows, frxBrowser, ExtCtrls
{$IFDEF DELPHI12}, AnsiStrings{$ENDIF};

type
  TfrxServerListenerThread = class(TThread)
  protected
    FServer: TServerSocket;
    FPort: Integer;
    FAnswer: String;
    FLocation: AnsiString;
    procedure DoRead(Sender: TObject; Socket: TCustomWinSocket);
  public
    destructor Destroy; override;
    procedure SetPort(const Value: Integer);
    procedure SetLocation(const Value: AnsiString);
    procedure Execute; override;
  end;

  TfrxLoopBackListener = class(TObject)
  private
    FPort: Integer;
    FAnswer: String;
    FErrors: String;
    FURL: String;
    FTimer: TTimer;
    FLocationURL: AnsiString;
    procedure DoTimer(Sender: TObject);
    function GetWaitInterval: Integer;
    procedure SetWaitInterval(const Value: Integer);
  protected
    FServerThread: TfrxServerListenerThread;
    FOnTestURL: TTestURLEvent;
  public
    constructor Create;
    destructor Destroy; override;
    procedure WaitFor;
    procedure Stop;
    property Port: Integer read FPort write FPort;
    property URL: String read FURL write FURL;
    property LocationURL: AnsiString read FLocationURL write FLocationURL;
    property OnTestURL: TTestURLEvent read FOnTestURL write FOnTestURL;
    property Answer: String read FAnswer write FAnswer;
    property Errors: String read FErrors write FErrors;
    property WaitInterval: Integer read GetWaitInterval write SetWaitInterval;
  end;

implementation
end.

