unit frxMapEditor;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages,
{$ELSE}
  LCLType, LCLIntf, LCLProc, LazHelper, ColorBox,
{$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, StdCtrls, frxCtrls, frxDesgnCtrls,
  frxClass, frxDsgnIntf, frxMap, frxMapLayer, frxMapRanges, frxMapHelpers,
  ExtCtrls,
  frAppearance, frControls, frTreeView,
  frxMapGeodataLayer, frxBaseForm
{$IFDEF FPC}
  ,EditBtn
{$ENDIF};

type
  TfrxMapEditorForm = class(TfrxBaseForm)
    MapGroupBox: TGroupBox;
    OkButton: TButton;
    CancelButton: TButton;
    MapTreeView: TfrTreeView;
    UpButton: TSpeedButton;
    DownButton: TSpeedButton;
    AddButton: TButton;
    DeleteButton: TButton;
    MapOptionsPageControl: TPageControl;
    GeneralTabSheet: TTabSheet;
    MercatorCheckBox: TCheckBox;
    ColorScaleTabSheet: TTabSheet;
    ColorScaleTitleGroupBox: TGroupBox;
    ColorScaleValuesGroupBox: TGroupBox;
    ColorScaleTitleTextLabel: TLabel;
    ColorScaleTitleTextEdit: TEdit;
    ColorScaleValuesFormatLabel: TLabel;
    ColorScaleValuesFormatEdit: TEdit;
    LayerOptionsPageControl: TPageControl;
    DataTabSheet: TTabSheet;
    AppearanceTabSheet: TTabSheet;
    ColorRangesTabSheet: TTabSheet;
    SizeRangesTabSheet: TTabSheet;
    LabelsTabSheet: TTabSheet;
    DataSetLabel: TLabel;
    FilterLabel: TLabel;
    DatasetComboBox: TComboBox;
    FilterComboEdit: TfrxComboEdit;
    SpatialDataMapLayerGroupBox: TGroupBox;
    ColumnLabel: TLabel;
    SpatialValueLabel: TLabel;
    SpatialValueComboEdit: TfrxComboEdit;
    SpatialColumnComboBox: TComboBox;
    AnalyticalDataGroupBox: TGroupBox;
    AnalyticalValueLabel: TLabel;
    FunctionLabel: TLabel;
    AnalyticalValueComboEdit: TfrxComboEdit;
    FunctionComboBox: TComboBox;
    SpatialDataAppLayerGroupBox: TGroupBox;
    LatitudeLabel: TLabel;
    LatitudeComboEdit: TfrxComboEdit;
    LongitudeLabel: TLabel;
    LongitudeComboEdit: TfrxComboEdit;
    LabelLabel: TLabel;
    LabelComboEdit: TfrxComboEdit;
    ZoomPolygonLabel: TLabel;
    ZoomPolygonComboEdit: TfrxComboEdit;
    LayerVisibleCheckBox: TCheckBox;
    LayerBorderColorLabel: TLabel;
    LayerBorderStyleLabel: TLabel;
    LayerBorderStyleComboBox: TComboBox;
    LayerBorderWidthLabel: TLabel;
    LayerFillColorLabel: TLabel;
    LayerPaletteLabel: TLabel;
    LayerPaletteComboBox: TComboBox;
    ColorRangeVisibleCheckBox: TCheckBox;
    StartColorLabel: TLabel;
    MiddleColorLabel: TLabel;
    EndColorLabel: TLabel;
    NumColorRangesLabel: TLabel;
    StartSizeLabel: TLabel;
    EndSizeLabel: TLabel;
    NumSizeRangesLabel: TLabel;
    LabelColumnLabel: TLabel;
    LabelColumnComboBox: TComboBox;
    LabelFormatLabel: TLabel;
    LabelFormatEdit: TEdit;
    FontDialog: TFontDialog;
    ColorScaleTitleFontButton: TButton;
    ColorScaleTitleFontSampleLabel: TLabel;
    ColorScaleValuesFontSampleLabel: TLabel;
    ColorScaleValuesFontButton: TButton;
    MapSamplePaintBox: TPaintBox;
    KeepAspectCheckBox: TCheckBox;
    ColorScaleVisibleCheckBox: TCheckBox;
    ColorBorderColorBox: TColorBox;
    ColorBorderWidthLabel: TLabel;
    ColorBorderColorLabel: TLabel;
    ColorTopLeftSpeedButton: TSpeedButton;
    ColorMiddleCenterSpeedButton: TSpeedButton;
    ColorBottomRightSpeedButton: TSpeedButton;
    ColorBottomCenterSpeedButton: TSpeedButton;
    ColorBottomLeftSpeedButton: TSpeedButton;
    ColorMiddleRightSpeedButton: TSpeedButton;
    ColorMiddleLeftSpeedButton: TSpeedButton;
    ColorTopRightSpeedButton: TSpeedButton;
    ColorTopCenterSpeedButton: TSpeedButton;
    ColorScaleDockLabel: TLabel;
    SizeScaleTabSheet: TTabSheet;
    SizeScaleVisibleCheckBox: TCheckBox;
    SizeBorderColorBox: TColorBox;
    SizeScaleValuesGroupBox: TGroupBox;
    SizeScaleValuesFormatLabel: TLabel;
    SizeScaleValuesFontSampleLabel: TLabel;
    SizeScaleValuesFormatEdit: TEdit;
    SizeScaleValuesFontButton: TButton;
    SizeScaleTitleGroupBox: TGroupBox;
    SizeScaleTitleTextLabel: TLabel;
    SizeScaleTitleFontSampleLabel: TLabel;
    SizeScaleTitleTextEdit: TEdit;
    SizeScaleTitleFontButton: TButton;
    SizeScaleDockLabel: TLabel;
    SizeTopCenterSpeedButton: TSpeedButton;
    SizeTopRightSpeedButton: TSpeedButton;
    SizeMiddleLeftSpeedButton: TSpeedButton;
    SizeMiddleRightSpeedButton: TSpeedButton;
    SizeBottomLeftSpeedButton: TSpeedButton;
    SizeBottomCenterSpeedButton: TSpeedButton;
    SizeBottomRightSpeedButton: TSpeedButton;
    SizeMiddleCenterSpeedButton: TSpeedButton;
    SizeTopLeftSpeedButton: TSpeedButton;
    SizeBorderColorLabel: TLabel;
    SizeBorderWidthLabel: TLabel;
    LayerBorderColorColorBox: TColorBox;
    LayerFillColorColorBox: TColorBox;
    LayerPointSizeLabel: TLabel;
    ColorRangeFactorComboBox: TComboBox;
    ColorRangeFactorLabel: TLabel;
    StartColorColorBox: TColorBox;
    MiddleColorColorBox: TColorBox;
    EndColorColorBox: TColorBox;
    SizeRangeVisibleCheckBox: TCheckBox;
    SizeRangeFactorComboBox: TComboBox;
    SizeRangeFactorLabel: TLabel;
    LabelKindLabel: TLabel;
    LabelKindComboBox: TComboBox;
    LabelFontButton: TButton;
    LabelFontLabel: TLabel;
    FillButton: TButton;
    FrameButton: TButton;
    LayerHighlightColorLabel: TLabel;
    LayerHighlightColorColorBox: TColorBox;
    ColorBorderWidthEdit: TEdit;
    ColorBorderWidthUpDown: TUpDown;
    SizeBorderWidthEdit: TEdit;
    SizeBorderWidthUpDown: TUpDown;
    LayerBorderWidthEdit: TEdit;
    LayerBorderWidthUpDown: TUpDown;
    LayerPointSizeEdit: TEdit;
    LayerPointSizeUpDown: TUpDown;
    NumColorRangesEdit: TEdit;
    NumColorRangesUpDown: TUpDown;
    NumSizeRangesEdit: TEdit;
    NumSizeRangesUpDown: TUpDown;
    StartSizeEdit: TEdit;
    StartSizeUpDown: TUpDown;
    EndSizeEdit: TEdit;
    EndSizeUpDown: TUpDown;
    CREditBtn: TButton;
    SREditBtn: TButton;
    GeodataLayerGroupBox: TGroupBox;
    DataColumnComboBox: TComboBox;
    DataColumnLabel: TLabel;
    BorderColorLabel: TLabel;
    FillColorLabel: TLabel;
    BorderColorColumnComboBox: TComboBox;
    FillColorColumnComboBox: TComboBox;
    MapDataSetComboBox: TComboBox;
    MapDataSetLabel: TLabel;
    GeoDataKindComboBox: TComboBox;
    GeoDataKindLabel: TLabel;
    procedure AddButtonClick(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure UpButtonClick(Sender: TObject);
    procedure DownButtonClick(Sender: TObject);
    procedure MapTreeViewChange(Sender: TObject; Node: TfrTreeViewNode);
    procedure FormShow(Sender: TObject);
    procedure MapSamplePaintBoxPaint(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure ComboEditButtonClick(Sender: TObject);
    procedure ComboEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ColorBoxChange(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure EditIntKeyPress(Sender: TObject; var Key: Char);
    procedure DockSpeedButtonClick(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);
    procedure FillButtonClick(Sender: TObject);
    procedure FrameButtonClick(Sender: TObject);
    procedure CREditBtnClick(Sender: TObject);
    procedure SREditBtnClick(Sender: TObject);
  private
    FMap: TfrxMapView;
    FLayerName: String;
    FOriginalMap: TfrxMapView;
    FReport: TfrxReport;
    FReportDesigner: TfrxCustomDesigner;
    FRefreshEnabled: Boolean;
    procedure SetMap(AMap: TfrxMapView);
    procedure PopulateMapTree(SelectedIndex: Integer = -1);
    procedure PopulateMapOptions;
    procedure PopulateLayerOptions;
    function SelectedLayer: TfrxCustomLayer;
    function SelectedLayerType: TLayerType;
    function SelectedMapFileLayer: TfrxMapFileLayer;
    function SelectedApplicationLayer: TfrxApplicationLayer;
    function SelectedGeodataLayer: TfrxMapGeodataLayer;
    function IsGetSelectedLayerIndex(out Index: Integer): boolean;
    procedure Change;
    procedure FontToLabel(Font: TFont; Lbl: TLabel);
    procedure FontDialogToLabel(Font: TFont; Lbl: TLabel);
  protected
    procedure SelectLayer(LayerName: String);
  public
    constructor Create(AOwner: TComponent); override;
    procedure UpdateResouces; override;
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    property Map: TfrxMapView read FMap write SetMap;
    property ReportDesigner: TfrxCustomDesigner read FReportDesigner write FReportDesigner;
  end;

implementation
end.
