
{******************************************}
{                                          }
{              FastReport v6.0             }
{            Map Geo Data Layer            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxMapGeodataLayer;

interface

{$I frx.inc}

uses
  Classes, Graphics,
  frxMapLayer, frxMapHelpers, frxClass, frxMapShape;

type
  TGeoDataKind = (gdWKT, gdWKB);

  TfrxMapGeodataLayer = class (TfrxCustomLayer)
  private
    FBorderColorColumn: String;
    FFillColorColumn: String;
    FDataColumn: String;
    FGeoDataKind: TGeoDataKind;
    FMapDataSet: TfrxDataSet;
  protected
    function GetSelectedShapeName: String; override; // Similarly TfrxMapFileLayer
    function GetSelectedShapeValue: String; override; // Similarly TfrxMapFileLayer
    procedure InitialiseData; override;
    procedure LoadShapes;
    function IsCanGetData: Boolean; override;
    function IsWideText: Boolean;
    procedure LoadGeoData(MemoryStream: TMemoryStream; Tags: TStringList);

    procedure AddValueList(vaAnalyticalValue: Variant); override; // Similarly TfrxMapFileLayer
    function IsSpecialBorderColor(iRecord: Integer; out SpecialColor: TColor): Boolean; override;
    function IsSpecialFillColor(iRecord: Integer; out SpecialColor: TColor): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure GetColumnList(List: TStrings); override;
    procedure CopyDatasets(CustomLayer: TfrxCustomLayer); override;
  published
    property ShowLines;
    property ShowPoints;
    property ShowPolygons;
    property LabelColumn;
    property SpatialColumn;
    property MapAccuracy;
    property PixelAccuracy;

    property MapDataSet: TfrxDataSet read FMapDataSet write FMapDataSet;
    property BorderColorColumn: String read FBorderColorColumn write FBorderColorColumn;
    property FillColorColumn: String read FFillColorColumn write FFillColorColumn;
    property DataColumn: String read FDataColumn write FDataColumn;
    property GeoDataKind: TGeoDataKind read FGeoDataKind write FGeoDataKind;
    property SpatialValue;
  end;

implementation
end.
