
{******************************************}
{                                          }
{             FastReport VCL               }
{          Map Interactive Layer           }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxMapInteractiveLayer;

interface

{$I frx.inc}

uses
  Classes,
  frxMapLayer, frxMapHelpers, frxClass, frxMapShape;

type
  TfrxMapInteractiveLayer = class (TfrxCustomLayer)
  private
    FEditedShape: TShape;
  protected
    procedure AddValueList(vaAnalyticalValue: Variant); override; // Empty
  public
    constructor Create(AOwner: TComponent); override;

    procedure AddShape(const ShapeData: TShapeData);
    procedure ReplaceShape(const ShapeData: TShapeData);

    function IsSelectEditedShape(P: TfrxPoint; Threshold: Extended): Boolean;
    function IsHighlightSelectedShape: boolean; override;
    function IsHiddenShape(iRecord: Integer): Boolean; override;
    function IsEditing: Boolean;
    procedure CancelEditedShape(NeedRebuild: Boolean = True);
    procedure RemoveEditedShape;

    property EditedShape: TShape read FEditedShape;
  published
    property LabelColumn;
  end;

implementation
end.
