
{******************************************}
{                                          }
{             FastReport VCL               }
{             Map Layer Tags               }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxMapLayerTags;

{$I frx.inc}

interface

uses
  {$IFNDEF FPC}
  Windows, Messages,
  {$ELSE}
  LCLType, LCLIntf, LCLProc,
  {$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, frxMapHelpers, frxBaseForm;

type
  TMapLayerTagsForm = class(TfrxBaseForm)
    CancelB: TButton;
    OkB: TButton;
    FileTagsLabel: TLabel;
    LayerTagsListBox: TListBox;
    LayerTagsLabel: TLabel;
    FilterLabel: TLabel;
    FilterEdit: TEdit;
    LayerAddButton: TButton;
    LayerDeleteButton: TButton;
    FileTagsListView: TListView;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FileTagsListViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure LayerAddButtonClick(Sender: TObject);
    procedure LayerDeleteButtonClick(Sender: TObject);
    procedure FilterEditKeyPress(Sender: TObject; var Key: Char);
    procedure FilterEditChange(Sender: TObject);
  protected
    FSumTags: TfrxSumStringList;
    FTagId: Integer;

    procedure FillFileTags;
    function IsInLayerTags(st: String): Boolean;
    function IsEditFilter(st: String): Boolean;
  public
    { Public declarations }
  end;

function EditLayerTags(FileTags: TfrxSumStringList; LayerTags: TStringList;
                       Owner: TComponent = nil): boolean;

implementation
end.
