
{******************************************}
{                                          }
{             FastReport VCL               }
{            OpenSSL IO handler            }
{                                          }
{         Copyright (c) 1998-2021          }
{            Fast Reports Inc.             }
{                                          }
{******************************************}

unit frxOpenSSL;

{$I frx.inc}
interface

uses
  Windows, SysUtils, Classes, ScktComp, frxBaseSocketIOHandler,
  WinSock;

type
  TfrxSSLIOHandler = Class(TfrxCustomIOHandler)
  private
    FSSL: Pointer;
    FCtx: pointer;
    FMethod: Pointer;
    FHandshakeDone: Boolean;
    function SelectMethod(SProtocol: TfrxSecurityProtocol): Pointer;
    function InitSSL: Boolean;
    function LowerDownProtocol: Boolean;
  protected
    function DoRead(var Buffer; Count: Longint): Integer; override;
    function DoWrite(var Buffer; Count: Longint): Integer; override;
    function GetErrorCode(ErrCode: Integer): Integer; override;
  public
    constructor Create; override;
    function GetLastError: String; override;
    function InitializeHandler: Boolean; override;
    procedure BindSocket(Socket: TCustomWinSocket; const Host: AnsiString); override;
    procedure DoHandshake;
    procedure Connect;
    function TryConnect: Boolean; override;
    procedure Disconnect; override;
//    function Read(Stream: TStream): Boolean; override;
//    function Write(Stream: TStream): Boolean; override;
    function ProcessIO: Boolean; override;
  end;

implementation
end.
