
{******************************************}
{                                          }
{             FastReport VCL               }
{               Report Tree                }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxReportTree;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages,
{$ELSE}
  LCLType,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, frxClass, frxBaseForm, Types, Variants,
  frCoreClasses, frTreeView, frxComCtrls, frxDock;

type

  { TfrxReportTreeForm }

  TfrxReportTreeForm = class(TfrxDockForm)
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TreeChange(Sender: TObject; Node: TfrTreeViewNode);
    procedure TreeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TreeDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure TreeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure TreeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  strict private
    FComponents: TfrList;
    FDesigner: TfrxCustomDesigner;
    FNodes: TfrList;
    FReport: TfrxReport;
    FTree: TfrxTreeView;
    FTreePanel: TfrxTreePanel;
    FUpdating: Boolean;

    FOnSelectionChanged: TNotifyEvent;

    function CanNodeTarget(ANode: TfrTreeViewNode): Boolean;
    procedure CreateTree;
    procedure CreateTreePanel;
  protected
    function GetCaptionFromResources: string; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure LoadFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;
    procedure SaveFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;
    procedure SetColor_(Value: TColor);
    procedure UpdateFormPPI(aNewPPI: Integer); override;
    procedure UpdateItems;
    procedure UpdateSelection;

    property OnSelectionChanged: TNotifyEvent read FOnSelectionChanged write FOnSelectionChanged;
  end;


implementation
end.
