
{******************************************}
{                                          }
{             FastReport VCL               }
{      Language resources management       }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxRes;

interface

{$I frx.inc}

uses
  SysUtils, Classes, TypInfo,
  {$IFDEF FR_COM}
  ComObj, FastReport_TLB, DispatchablePersistent,
  {$ENDIF}
  Controls, Buttons, Graphics,
  frResources, frCore, frGraphics;

type
  { TfrxImageResources }

  TfrxImageResources = class(TfrImageResources)
  private
    FDisabledButtonImages: TImageList;
    FMainButtonImages: TImageList;
    FPreviewButtonImages: TImageList;
    FObjectImages: TImageList;
    FWizardImages: TImageList;
    function GetDisabledButtonImages: TImageList;
    function GetMainButtonImages: TImageList;
    function GetPreviewButtonImages: TImageList;
    function GetObjectImages: TImageList;
    function GetWizardImages: TImageList;
  protected
    procedure ClearFields; override;
  public
    procedure SetButtonImages(Images: TBitmap; Clear: Boolean = False);
    procedure SetObjectImages(Images: TBitmap; Clear: Boolean = False);
    procedure SetPreviewButtonImages(Images: TBitmap; Clear: Boolean = False);
    procedure SetSpeedButtonGlyph(AButton: TSpeedButton; AIndex: Integer);  //delete fix for Transperent when WinLaz fix it.
    procedure SetWizardImages(Images: TBitmap; Clear: Boolean = False);

    property DisabledButtonImages: TImageList read GetDisabledButtonImages;
    property MainButtonImages: TImageList read GetMainButtonImages;
    property PreviewButtonImages: TImageList read GetPreviewButtonImages;
    property ObjectImages: TImageList read GetObjectImages;
    property WizardImages: TImageList read GetWizardImages;
    property ImagesPPI;
  end;


function frxImages: TfrxImageresources;
function frxGet(ID: Integer): String;
function frxResources: TfrStringResources;

implementation
end.
