unit frxSaveFilterBrowser;

interface

{$I frx.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, Math, Registry, frxBrowser, frxBrowserStub {frxBrowserWeb};
const
        // Quelle: https://msdn.microsoft.com/library/ee330730.aspx,
        // Stand: 2015-03-10
        IE11_default   = 11000;
        IE11_Quirks    = 11001;
        IE10_force     = 10001;
        IE10_default   = 10000;
        IE9_Quirks     = 9999;
        IE9_default    = 9000;
        /// <summary>
        /// Webpages containing standards-based
        /// !DOCTYPE directives are displayed in IE7
        /// Standards mode. Default value for
        /// applications hosting the WebBrowser Control.
        /// </summary>
        IE7_embedded   = 7000;
  function GetExeName(): String;
  procedure SetBrowserEmulationDWORD(const value: DWORD);
type

  TBrowserForm = class(TForm)
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    WebBrowserWinControl: TWinControl;
    WebBrowser: IfrxWebBrowser;
    function GetNavigateHistory : TStringList;
    function GetOnDocumentComplet : TNotifyEvent;
    function GetOnTestURL : TTestURLEvent;
    function GetURL : String;
    procedure SetNavigateHistory(const Value: TStringList);
    procedure SetOnDocumentComplet(const Value: TNotifyEvent);
    procedure SetOnTestURL(const Value: TTestURLEvent);
    procedure SetURL(const Value: String);

    procedure NavComplete(const aURL: OleVariant);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetListenerPort(const Value: Integer);
    procedure SetRedirect(const Value: String);
    property URL: String read GetURL write SetURL;
    property NavigateHistory: TStringList read GetNavigateHistory write SetNavigateHistory;
    property OnTestURL: TTestURLEvent read GetOnTestURL write SetOnTestURL;
    property OnDocumentComplet: TNotifyEvent read GetOnDocumentComplet write SetOnDocumentComplet;
    property GetWebBrowser: IfrxWebBrowser read WebBrowser  write WebBrowser;
    function GetDocument: IDispatch;
  end;

implementation
end.
