
{******************************************}
{                                          }
{             FastReport VCL               }
{             Convert to .FRX              }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxSaveFilterFRX;

interface

{$I frx.inc}

uses
  Windows, Classes, Graphics, Printers, SysUtils, Controls, Forms, StdCtrls,
  ComCtrls, frxClass, frXML, frUnicodeUtils, frxVariables, frxUtils, frxEngine,
  Variants, frxBarcode, frxChBox, frxRich, frxNetUtils, frxDesgn, frxDCtrl,
{$IFDEF DELPHI16}
  System.UITypes,
{$ENDIF}
  frHashUtils;

type
  TfrxSaveFRX = class(TfrxIOTransportFile)
  private
    procedure ConvertReport(root: TfrXmlItem);
    procedure ConvertVariables(root: TfrXmlItem);
    procedure ConvertReportPage(Page: TfrxReportPage; root: TfrXmlItem);
    function ConvertBand(Band: TfrxBand; root: TfrXmlItem): TfrXmlItem;
    procedure ConvertReportObject(Obj: TfrxView; root: TfrXmlItem);
    procedure ConvertMemo(Memo: TfrxCustomMemoView; root: TfrXmlItem);
    procedure ConvertPicture(Picture: TfrxPictureView; root: TfrXmlItem);
    procedure ConvertLine(Line: TfrxLineView; root: TfrXmlItem);
    procedure ConvertShape(Shape: TfrxShapeView; root: TfrXmlItem);
    procedure ConvertSubreport(Subreport: TfrxSubreport; root: TfrXmlItem);
    procedure ConvertBarcode(Barcode: TfrxBarcodeView; root: TfrXmlItem);
    procedure ConvertRich(Rich: TfrxRichView; root: TfrXmlItem);
    procedure ConvertCheckBox(CheckBox: TfrxCheckBoxView; root: TfrXmlItem);

    procedure ConvertDialogPage(Page: TfrxDialogPage; root: TfrXmlItem);
    procedure ConvertDialogControl(Control: TfrxDialogControl; root: TfrXmlItem);
    procedure ConvertDialogButton(Button: TfrxButtonControl; root: TfrXmlItem);
    procedure ConvertDialogLabel(Lbl: TfrxLabelControl; root: TfrXmlItem);
    procedure ConvertDialogEdit(Edit: TfrxCustomEditControl; root: TfrXmlItem);
    procedure ConvertDialogCheckBox(CheckBox: TfrxCheckBoxControl; root: TfrXmlItem);
    procedure ConvertDialogRadioButton(RadioButton: TfrxRadioButtonControl; root: TfrXmlItem);
    procedure ConvertDialogListBox(ListBox: TfrxListBoxControl; root: TfrXmlItem);
    procedure ConvertDialogComboBox(ComboBox: TfrxComboBoxControl; root: TfrXmlItem);
    procedure ConvertDialogPanel(Panel: TfrxPanelControl; root: TfrXmlItem);
    procedure ConvertDialogGroupBox(GroupBox: TfrxGroupBoxControl; root: TfrXmlItem);
    procedure ConvertDialogDateEdit(DateEdit: TfrxDateEditControl; root: TfrXmlItem);
    procedure ConvertDialogImage(Image: TfrxImageControl; root: TfrXmlItem);
    procedure ConvertDialogCheckListBox(CheckListBox: TfrxCheckListBoxControl; root: TfrXmlItem);

    procedure ConvertFrame(Frame: TfrxFrame; root: TfrXmlItem);
    procedure ConvertFrameLine(Line: TfrxFrameLine; Name: String; root: TfrXmlItem);
    procedure ConvertFont(Font: TFont; Name: String; root: TfrXmlItem);
  public
    constructor Create(AOwner: TComponent); override;
    function DoFilterProcessStream(aStream: TStream; ProcesssingObject: TObject): Boolean; override;
    class function GetDescription: String; override;
  end;


implementation
end.
