unit frxSearchDForm;

{$I frx.inc}

interface

uses
  {$IFNDEF FPC}
  Windows,
  {$ELSE}
  LCLIntf, LCLType, LMessages, LazHelper,
  {$ENDIF}
  {$IFDEF DELPHI16}
  System.UITypes, System.StrUtils,
  {$ENDIF}
  Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Types, Dialogs, ComCtrls, StdCtrls, ExtCtrls,
  frCoreClasses, frUnicodeUtils, frAppearance, frTreeView, frxClass, frxBaseForm, frxRes;

type

  { TfrxSearchDForm }

{$IFNDEF FPC}
  TTView = class(TfrTreeView)
    procedure WM_MouseWheel(var Msg: TWMMouseWheel); message WM_MouseWheel; //TWMMouseWheel
  end;
{$ENDIF}

  TfrxOnFindUpdate = procedure (Sender: TObject; FindNext: Boolean) of object;
  TfrxReplacedValues = (rvNames, rvStrings, rvContent, rvScript);

  { TfrxSearchDesignForm }

  TfrxSearchDesignForm = class(TfrxBaseForm)
    pnlSearch: TPanel;
    edtFind: TEdit;
    lblFind: TLabel;
    btnFind: TButton;
    gbSearch: TGroupBox;
    chkName: TCheckBox;
    chkStrings: TCheckBox;
    chkContent: TCheckBox;
    chkScript: TCheckBox;
    chkReplace: TCheckBox;
    ReplaceText: TEdit;
    chkCase: TCheckBox;
    GroupBox1: TGroupBox;
    FindAllCB: TCheckBox;
    procedure btnFindClick(Sender: TObject);
    procedure edtFindKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure GReplaceEv(Sender: TObject);
    procedure TreeViewCustomDrawItem(Sender: TfrCustomTreeView; ACanvas: TfrCustomCanvas;
      ANodeViewInfo: TfrTreeViewNodeViewInfo; var DefaultDraw: Boolean);
    procedure OnTrvFindDChange(Sender: TObject; Node: TfrTreeViewNode);
    procedure OnTrvFindDChanging(Sender: TObject; Node: TfrTreeViewNode; var AllowChange: Boolean);
    procedure ReplaceTextDblClick(Sender: TObject);
    procedure OnDeleteNode(Sender: TObject; Node: TfrTreeViewNode);
  private
    FDesigner: TfrxCustomDesigner;
    FOnFindUpdate: TfrxOnFindUpdate;
    FCodePos: Integer;
    FObjectsPos: Integer;
    FRepCount: array [rvNames .. rvScript] of Integer;
    FReplaceAll: Boolean;
    FBreakSearch: Boolean;
    { Private declarations }
  protected
    FFindTreeView: {$IFNDEF FPC}TTView{$ELSE}TfrTreeView{$ENDIF};
    procedure VisibleChanging; override;
    procedure DoUpdate(EnableNext: Boolean);
    function FindInCode: Boolean;
    function DoFind(AComponent: TfrxComponent): Boolean;
    procedure StartNewSearch;
    procedure FinishSearch;
    function AskReplace(const ReplaceIn: String = ''): Boolean;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure UpdateResouces; override;
    procedure LoadFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;
    procedure SaveFormPreferences(PreferencesStorage: TObject; DefPreferencesStorage: TObject); override;

    procedure ClearFindTree;
    procedure NormalizeForm;
    procedure Find;
    procedure FindNext;
    procedure Replace;
    property Designer: TfrxCustomDesigner read FDesigner write FDesigner;
    property OnFindUpdate: TfrxOnFindUpdate read FOnFindUpdate write FOnFindUpdate;
  end;

  TfrxBaseNodeData = class
  public
    Enabled: Boolean;
    constructor Create(vEnabled: Boolean); overload;
  end;

  TfrxBaseComponentNodeData = class(TfrxBaseNodeData)
  public
    Component :TfrxComponent;
    constructor Create(vEnabled: Boolean; vComponent: TfrxComponent); overload;
  end;

  TfrxComponentNodeData = class(TfrxBaseComponentNodeData)
  end;

  TfrxPropertyNodeData = class(TfrxBaseComponentNodeData)
  private
    FPropName: String;
  public
    property PropName: String read FPropName write FPropName;
  end;

  TfrxContentNodeData = class(TfrxBaseComponentNodeData)
  end;

  TfrxScriptNodeData = class(TfrxBaseNodeData)
  public
    Line, StartPos, Length: Integer;
    constructor Create(vEnabled: Boolean; vLine, vStartPos, vLength: Integer); overload;
  end;

const
  EventScrollFind = High(SmallInt);

implementation
end.
