
{******************************************}
{                                          }
{             FastReport VCL               }
{          Report Server misc utils        }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxServerUtils;

{$I frx.inc}

interface

uses
{$IFNDEF Linux}
  Windows, ActiveX,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  Classes, SysUtils, Messages,
  frCore, frxUtils;

function StrToHex(const s: AnsiString): AnsiString;
function HexToStr(const s : AnsiString) : AnsiString;
function Byte2Hex(const b: byte): AnsiString;
function GetHTTPErrorText(const ErrorCode: integer):AnsiString;
function GetUniqueFileName(const Path: String; const Prefix: String): String;
function Str2HTML(const Str: WideString): AnsiString; overload;
function Str2HTML(const Str: AnsiString): AnsiString; overload;
function Str2HTML(const Str: AnsiString; AIgnoredString: AnsiString): AnsiString; overload;

function HTML2Str(const Line: AnsiString): AnsiString;

function frURLEncode(const S: WideString): AnsiString; overload;
function frURLDecode(const S: AnsiString): String;

function UnQuoteStr(const s: AnsiString): AnsiString;
function GetEnvVar(const VarName: String): String;
function MakeSessionId: AnsiString;

function frxGetAbsPath(const Path: String): String;
function frxGetRelPath(const Path: String): String;
function frxGetAbsPathDir(const Path: String; const Dir: String): String;
function frxGetRelPathDir(const Path: String; const Dir: String): String;

procedure frxTouchDir(const Path: String);
procedure SetCommaText(const Text: String; sl: TStrings; Comma: Char = ';');
function NormalDir(const DirName: string): string;
procedure CopyFile(const fFrom, fTo: String);
procedure CopyFiles(const sFrom, sTo, sNames, sExcept: String; const Recursive: Boolean);
procedure CopyFilesF(const sFrom, sTo, sNames, sExcept: String);

type
  TfrxServerFormat = (sfHTM, sfXML, sfXLS, sfRTF, sfCSV, sfTXT, sfPDF, sfJPG, sfBMP, sfTIFF, sfGIF, sfFRP, sfODS, sfODT, sfHTMD);
  TfrxServerOutputFormats = set of TfrxServerFormat;
  TfrxHTTPQueryType = (qtGet, qtPost, qtHead);

implementation
end.
