
{******************************************}
{                                          }
{             FastReport VCL               }
{                Signature                 }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxSignature;

interface

{$I frx.inc}

uses
  frxHelpers, frxCertificateList, frxSignatureEngine;

type
  TfrxSignature = class
  private
    FStatus: TSignatureSatus;
    FDebugLog: TLogList;
    function GetFormat: TfrxSignatureFormat;
  protected
    FSignatureEngine: TfrxSignatureEngine;

    function IsError(ErrorCondition: Boolean; ErrorStatus: TSignatureSatus;
      IsUseLastError: Boolean = False): Boolean;
  public
    constructor Create(SD: TfrxSignatureData; Certificate: TfrxCertificate);
    destructor Destroy; override;

    property Status: TSignatureSatus read FStatus write FStatus;
    property DebugLog: TLogList read FDebugLog;
    property Format: TfrxSignatureFormat read GetFormat;
  end;

implementation
end.
