unit frxSignatureEditor;

interface

{$I frx.inc}

uses
{$IFDEF FPC}
  LCLType, LCLIntf, LCLProc, LazHelper, ColorBox,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, ComCtrls, Dialogs, StdCtrls,
  ExtCtrls,
  frxClass, frxDsgnIntf, frxBaseForm
{$IFDEF FPC}
  , EditBtn
{$ENDIF};

type
  TfrxSignatureEditorForm = class(TfrxBaseForm)
    SignatureGroupBox: TGroupBox;
    OkButton: TButton;
    CancelButton: TButton;
    FontDialog: TFontDialog;
    SamplePaintBox: TPaintBox;
    OptionsPageControl: TPageControl;
    GeneralTabSheet: TTabSheet;
    KeepAspectCheckBox: TCheckBox;
    FillButton: TButton;
    FrameButton: TButton;
    CustomizableTabSheet: TTabSheet;
    CustomizableCheckBox: TCheckBox;
    ConfigureGraphicGroupBox: TGroupBox;
    gtImportedRadioButton: TRadioButton;
    gtNameRadioButton: TRadioButton;
    ImpotrGraphicButton: TButton;
    gtNoRadioButton: TRadioButton;
    ConfigureTextGroupBox: TGroupBox;
    ImportLogoButton: TButton;
    NameCheckBox: TCheckBox;
    LocationCheckBox: TCheckBox;
    DistinguishedNameCheckBox: TCheckBox;
    LogoCheckBox: TCheckBox;
    DateCheckBox: TCheckBox;
    ReasonCheckBox: TCheckBox;
    ProgramVersionCheckBox: TCheckBox;
    LabelsCheckBox: TCheckBox;
    TextPropertyGroupBox: TGroupBox;
    RTLCheckBox: TCheckBox;
    FontButton: TButton;
    ImportPictureButton: TButton;

    procedure FormShow(Sender: TObject);
    procedure SamplePaintBoxPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure FontButtonClick(Sender: TObject);
    procedure ImpotrGraphicButtonClick(Sender: TObject);
    procedure FrameButtonClick(Sender: TObject);
    procedure ConfigureGraphicRadioButtonClick(Sender: TObject);
    procedure ImportLogoButtonClick(Sender: TObject);
    procedure ImportPictureButtonClick(Sender: TObject);
    procedure KeepAspectCheckBoxClick(Sender: TObject);
    procedure CustomizableCheckBoxClick(Sender: TObject);
    procedure FillButtonClick(Sender: TObject);
  private
    FSignature: TfrxDigitalSignatureView;
    FOriginalSignature: TfrxDigitalSignatureView;
    FReportDesigner: TfrxCustomDesigner;

    procedure Change;
    procedure FontToButton(Font: TFont; Button: TButton);
    procedure FontDialogToButton(Font: TFont; Button: TButton);
    procedure SetSignature(const Value: TfrxDigitalSignatureView);
    procedure ImportPicture(const SignaturePicture: TPicture);
  protected
  public
    constructor Create(AOwner: TComponent); override;
    procedure UpdateResouces; override;

    property Signature: TfrxDigitalSignatureView read FSignature write SetSignature;
    property ReportDesigner: TfrxCustomDesigner read FReportDesigner write FReportDesigner;
  end;

implementation
end.
