
{******************************************}
{                                          }
{             FastReport VCL               }
{         Signature Error Dialog           }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxSignatureErrorDialog;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
  Windows, Messages,
{$ELSE}
  LCLType, LCLIntf, LCLProc, LazHelper, ColorBox,
{$ENDIF}
  SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls,
  frxBaseForm, frxSignature, frxCertificateList, frxHelpers
{$IFDEF FPC}
  , EditBtn
{$ENDIF};

type
  TfrxSignatureErrorDialog = class(TfrxBaseForm)
    btnOk: TButton;
    btnCancel: TButton;
    cbSaveLog: TCheckBox;
    lblDescription: TLabel;
    btnIgnore: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FDebugLog: TLogList;

    function IsHaveLog: Boolean;
    function IsGetLogFileName(out FileName: TFileName): boolean;
  public
    procedure UpdateResouces; override;

    property DebugLog: TLogList write FDebugLog;
  end;

function SignatureErrorDialog(Status: TSignatureSatus; DebugLog: TLogList;
  Buttons: TMsgDlgButtons): TModalResult; overload;

function SignatureErrorDialog(Signature: TfrxSignature;
  Buttons: TMsgDlgButtons): TModalResult; overload;

implementation
end.
