
{******************************************}
{                                          }
{             FastReport VCL               }
{       Signature Properties Dialog        }
{                                          }
{         Copyright (c) 1998-2023          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxSignaturePropertiesDialog;

interface

{$I frx.inc}

uses
{$IFNDEF FPC}
{$ELSE}
  LCLType, LCLIntf, LCLProc, LazHelper, ColorBox, Forms,
{$ENDIF}
  Classes, Controls, StdCtrls, ExtCtrls,
  frxBaseForm, frxSignatureEngine
{$IFDEF FPC}
  , EditBtn
{$ENDIF};

type
  TfrxSignaturePropertiesDialog = class(TfrxBaseForm)
    FormatRadioGroup: TRadioGroup;
    MethodRadioGroup: TRadioGroup;
    TSAURLLabel: TLabel;
    TSAURLEdit: TEdit;
    OkB: TButton;
    CancelB: TButton;
    DetachedCheckBox: TCheckBox;
    ChainCheckBox: TCheckBox;

    procedure DataChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    function Format: TfrxSignatureFormat;
    function Signing: TfrxSigningMethod;
    function TSAURL: string;
    function Detached: Boolean;
    function Chain: Boolean;
    function GetSignatureData: TfrxSignatureData;
    procedure SetSignatureData(const Value: TfrxSignatureData);
  protected
    FUpdateEnabled: Boolean;

    procedure UpdateControls;
  public
    procedure UpdateResouces; override;
    procedure SetupForPDF;

    property SignatureData: TfrxSignatureData read GetSignatureData write SetSignatureData;
  end;

function SignaturePropertiesDialog(var SD: TfrxSignatureData): TModalResult;
function SignaturePropertiesPDFDialog(var SD: TfrxSignatureData): TModalResult;

implementation
end.
