
{******************************************}
{                                          }
{             FastReport VCL               }
{        HTTP conector Indy wrapper        }
{                                          }
{         Copyright (c) 1998-2021          }
{                                          }
{******************************************}

unit frxTransportIndyConnectorHTTP;

{$I frx.inc}
interface

uses
  SysUtils, Classes, frxBaseTransportConnection,
  frxTransportIndyConnector, IdTCPConnection, IdHTTP;

type
{$IFDEF DELPHI16}
[ComponentPlatformsAttribute(pidWin32 or pidWin64)]
{$ENDIF}
  TfrxTransportIndyConnectorHTTP = class(TfrxTransportIndyConnector)
  protected
    function GetProxyHost: String; override;
    function GetProxyLogin: String; override;
    function GetProxyPassword: String; override;
    function GetProxyPort: Integer; override;
    procedure SetProxyHost(const Value: String); override;
    procedure SetProxyLogin(const Value: String); override;
    procedure SetProxyPassword(const Value: String); override;
    procedure SetProxyPort(const Value: Integer); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetIdHTTP: TidHTTP;
    procedure SetDefaultParametersWithToken(AToken: String); override;
  end;

  procedure frxTestTokenIndy(const URL: String; var sToken: String;
    bUsePOST: Boolean; PrefixAut: String = 'Bearer ');
  procedure IndyLog(LogFileName: String; IdTCPConnection: TIdTCPConnection);

implementation
end.
