
{******************************************}
{                                          }
{             FastReport VCL               }
{        Value editor VCL Component        }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frxValEdit;

interface

{$I frx.inc}

uses
  Classes, ExtCtrls, Types, Controls, Messages,
  ValEdit, Grids;

type
  TfrxPropertyListEditor = class(TValueListEditor)
  private
    FInspectedObject: TPersistent;
    FHiddenProperties: TStringList;
    procedure SetInspectedObject(const Value: TPersistent);
    procedure FillProperties(AInstance: TPersistent);
    procedure DoSetProperty(AInstance: TPersistent; PropName: string);
    function IsPropHidden(const AClassName: String; const APropName: String): Boolean;
  protected
    procedure SetEditText(ACol, ARow: Integer; const Value: string); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property InspectedObject: TPersistent read FInspectedObject write SetInspectedObject;
    property HiddenProperties: TStringList read FHiddenProperties;
  end;


implementation
end.
