unit frxLazBWForm;

{$I frx.inc}

interface

uses
  SysUtils, Classes,  Graphics,  LCLType, FileUtil, Forms, Controls, Dialogs, ExtCtrls,
  ComCtrls, CheckLst, StdCtrls,
  fs_iinterpreter, frxSimpleMemo, Variants, Grids, frResources;

type

  { TfrxBWForm }

  TfrxBWForm = class(TForm, IfrStringResourcesChangedListener)
    BreakPGR: TStringGrid;
    DeleteB: TToolButton;
    EditB: TToolButton;
    EditBtn: TButton;
    pnlB: TPanel;
    tlbB: TToolBar;
    ToggleEnableB: TToolButton;
    WatchLB: TStringGrid;
    WatchLBCB: TCheckListBox;
    pnlW: TPanel;
    splBW: TSplitter;
    ListTB: TTabControl;
    tlbW: TToolBar;
    AddW: TToolButton;
    DeleteW: TToolButton;
    EditW: TToolButton;
    procedure AddBClick(Sender: TObject);
    procedure AddWClick(Sender: TObject);
    procedure BreakPGRDblClick(Sender: TObject);
    procedure BreakPGRDrawCell(Sender: TObject; aCol, aRow: Integer;
      Rect: TRect; aState: TGridDrawState);
    procedure DeleteBClick(Sender: TObject);
    procedure DeleteWClick(Sender: TObject);
    procedure EditBClick(Sender: TObject);
    procedure EditWClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListTBChange(Sender: TObject);
    procedure pnlBResize(Sender: TObject);
    procedure pnlWResize(Sender: TObject);
    procedure ToggleEnableBClick(Sender: TObject);
    procedure WatchLBCBClickCheck(Sender: TObject);
  private
    FScript: TfsScript;
    FScriptRunning: Boolean;
    FSynMemo: TfrxSyntaxMemo;
    FWatches: TStrings;
    procedure SetSynMemo(const Value: TfrxSyntaxMemo);
    procedure BPListUpdated(Sender: TObject);
    function CalcWatch(const s: String): String;
  protected
    // IfrStringResourcesChangedListener
    procedure ResourcesChanged(AResources: TfrStringResources); virtual;
  public
    destructor Destroy; override;
    procedure UpdateList;
    procedure UpdateWatches;
    procedure UpdateResouces;
    property Script: TfsScript read FScript write FScript;
    property ScriptRunning: Boolean read FScriptRunning write FScriptRunning;
    property Watches: TStrings read FWatches;
    property SynMemo: TfrxSyntaxMemo read FSynMemo write SetSynMemo;
  end;

var
  frxBWForm: TfrxBWForm;

implementation
end.

