unit frxChartEditorLaz;

{$I frx.inc}

interface

uses
  Classes, SysUtils, FileUtil, LCLIntf, LCLType,
  Forms, Controls, Graphics, Dialogs,
   frxClass, frxChartLaz, frxCustomEditors,
   frxInsp,  ComCtrls,
  ExtCtrls, Buttons, StdCtrls, Grids, Spin, Menus,
  TAGraph, TACustomSeries, TASources, TAStyles,
  TATransformations,
  frPlatformServices, frAppearance, frControls, frTreeView;

type

  { TfrxChartEditor }

  TfrxChartEditor = class(TfrxViewEditor)
  public
    function Edit: Boolean; override;
    function HasEditor: Boolean; override;
    procedure GetMenuItems; override;
    function Execute(Tag: Integer; Checked: Boolean): Boolean; override;
  end;

  { TLS }

  TLS = class
    FDSPoints: TStrings;
    FDataType: TfrxSeriesDataType;
    FDataSet: TfrxDataSet;
    constructor Create;
    destructor Destroy; override;
  end;

  { TfrxChartEditorForm }

  TfrxChartEditorForm = class(TForm)
    btnDel: TSpeedButton;
    btnOK: TButton;
    btnCancel: TButton;
    btnSData: TButton;
    btnCData: TButton;
    cbDataSet: TComboBox;
    chkSort: TCheckBox;
    dlgColor: TColorDialog;
    gbData: TGroupBox;
    Label1: TLabel;
    lblSource: TLabel;
    mmis1: TMenuItem;
    mmis2: TMenuItem;
    mmit3: TMenuItem;
    mmit4: TMenuItem;
    mmit2: TMenuItem;
    mmit1: TMenuItem;
    mmiDel: TMenuItem;
    mmiIns: TMenuItem;
    pnlSBottom: TPanel;
    pnlSTop: TPanel;
    pgcMain: TPageControl;
    pnlBottom: TPanel;
    pnlRight: TPanel;
    pnlLB: TPanel;
    pnlBtn: TPanel;
    pnlLT: TPanel;
    pnlLeft: TPanel;
    btnAdd: TSpeedButton;
    pmRows: TPopupMenu;
    pmTrans: TPopupMenu;
    pmAS: TPopupMenu;
    rbFixed: TRadioButton;
    rbDataSet: TRadioButton;
    spnY: TSpinEdit;
    sgData: TStringGrid;
    tbSeries: TTabSheet;
    trvChart: TfrTreeView;
    procedure btnAddClick(Sender: TObject);
    procedure btnCDataClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnSDataClick(Sender: TObject);
    procedure cbDataSetChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mmiDelClick(Sender: TObject);
    procedure mmiInsClick(Sender: TObject);
    procedure mmiTransClick(Sender: TObject);
    procedure mmiSClick(Sender: TObject);
    procedure pmRowsPopup(Sender: TObject);
    procedure rbDataSetChange(Sender: TObject);
    procedure rbFixedChange(Sender: TObject);
    procedure sgDataButtonClick(Sender: TObject; aCol, aRow: Integer);
    procedure sgDataDrawCell(Sender: TObject; aCol, aRow: Integer;
      aRect: TRect; aState: TGridDrawState);
    procedure sgDataEditingDone(Sender: TObject);
    procedure sgDataPrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
    procedure spnYChange(Sender: TObject);
    procedure spnYEnter(Sender: TObject);
    procedure spnYExit(Sender: TObject);
    procedure trvChartChange(Sender: TObject; Node: TfrTreeViewNode);
  private
    { private declarations }
    FChart:TfrxChartView;
    FReport: TfrxReport;
    FDesigner: TfrxCustomDesigner;
    FInspector: TfrxObjectInspector;

    FLS: TListChartSource;
    FDataPoints: TStrings;
    FDSPoints: TStrings;
    FTLS: TLS;
    FCurrentRow: Integer;

    FTrans: Integer;
    FMS: Integer;

    procedure SetCurNode(nd: TfrTreeViewNode);
    function GetCurNode: TfrTreeViewNode;

    function GetNextPrevCurNode: TfrTreeViewNode;
    procedure DelCurAndSetCur(SetNode: TfrTreeViewNode);
    procedure SetButtons(BAE, BDE: Boolean; BAS: String = ''; BDS: String = '');

    procedure ModifyInsp(Sender: TObject);
    procedure AddAxis;
    procedure DelAxis;
    procedure AddMinor;
    procedure DelMinor;
    procedure NewItem;
    procedure DelItem;
    procedure AddSers;
    procedure DelSers;
    procedure AddSty;
    procedure DelSty;
    procedure AddTrans;
    procedure DelTrans;
    procedure AddSource;
    procedure DelSource;
    procedure AddStripe;
    procedure DelStripe;
    procedure FillDropDownLists(ds: TfrxDataset);

    procedure InitGridData;
    function ExtractGridData: Boolean;
    procedure SaveStyles;
    procedure SaveTrans;
    procedure SaveLS;
    procedure ClearLS;
    procedure ClearTrans;
    procedure ClearStripe;
    procedure ClearSeries;

    property CurNode: TfrTreeViewNode read GetCurNode write SetCurNode;
  public
    { public declarations }
    chrtV:TChart;
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;

    property Chart: TfrxChartView read FChart write FChart;
  end;

var
  frxChartEditorForm: TfrxChartEditorForm;

implementation
end.

