unit frxlazdbfcomp;

{$I frx.inc}

interface

uses
  Classes, SysUtils,
  frxClass, frxCustomDB, DB, dbf,
  LResources;

type

  { TfrxLazDBFComponents }

  TfrxLazDBFComponents = class(TfrxDBComponents)
  private
    FOldComponents: TfrxLazDBFComponents;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetDescription: string; override;
  end;

  { TfrxDBFTable }

  TfrxDBFTable = class(TfrxCustomTable)
  private
    FDBF: TDbf;
    FDBFCharset: string;
    FTranslate: Boolean;
    function GetFilePath: string;
    procedure SetFilePath(AValue: string);
    procedure SetTranslate(AValue: Boolean);
  protected
    procedure SetMaster(const Value: TDataSource); override;
    procedure SetMasterFields(const Value: String); override;
    function GetIndexFieldNames: String; override;
    function GetIndexName: String; override;
    procedure SetIndexFieldNames(const Value: String);override;
    procedure SetIndexName(const Value: String); override;

    function GetTableName: String; override;
    procedure SetTableName(const Value: String); override;
    function DbfTranslate(Dbf: TDbf; Src, Dest: PChar; ToOem: Boolean): Integer;
    procedure DbfAfterOpen(DataSet: TDataSet);
  public
    constructor Create(AOwner: TComponent); override;
    procedure AddIndex(AIndexName, AFields: string);
    procedure AddIndexDescending(AIndexName, AFields: string);
    property DBF: TDBF read FDBF;
  published
    property DBFCharset: string read FDBFCharset write FDBFCharset;
    property Active;
    property FilePath: string read GetFilePath write SetFilePath;
    property Translate: Boolean read FTransLate write SetTranslate;
  end;




var
  LazDBFComponents: TfrxLazDBFComponents;

procedure Register;

implementation
end.

