unit frxlazsqlitecomp;

{$I frx.inc}


interface

uses
  Classes, SysUtils, frxClass, frxCustomDB, DB, sqldb, sqlite3conn,
  Variants, LResources;

type

  { TfrxLazSqLiteComponents }

  TfrxLazSqLiteComponents = class(TfrxDBComponents)
  private
    FDefaultDatabase: TSQLite3Connection;
    FOldComponents: TfrxLazSqLiteComponents;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetDefaultDatabase(Value: TSQLite3Connection);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetDescription: String; override;
  published
    property DefaultDatabase: TSQLite3Connection read FDefaultDatabase write SetDefaultDatabase;
  end;

  { TfrxLazSqliteDatabase }

  TfrxLazSqliteDatabase = class(TfrxCustomDatabase)
  private
    FDatabase: TSQLite3Connection;
    FTransaction: TSqlTransaction;
    function GetCharSet: string;
    function GetOptions: TSQLConnectionOptions;
    function GetPassword: string;
    function GetUserName: string;
    procedure SetCharSet(AValue: string);
    procedure SetOptions(AValue: TSQLConnectionOptions);
    procedure SetPassword(AValue: string);
    procedure SetUserName(AValue: string);
  protected
    procedure SetConnected(Value: Boolean); override;
    procedure SetDatabaseName(const Value: String); override;
    procedure SetLoginPrompt(Value: Boolean); override;
    procedure SetParams(Value: TStrings); override;
    function GetConnected: Boolean; override;
    function GetDatabaseName: String; override;
    function GetLoginPrompt: Boolean; override;
    function GetParams: TStrings; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    class function GetDescription: String; override;
    //procedure SetLogin(const Login, Password: String); override;
    property Database: TSQLite3Connection read FDatabase;
  published
    property CharSet: string read GetCharSet write SetCharSet;
    property DatabaseName;
    property LoginPrompt;
    property Params;
    property UserName:string read GetUserName  write SetUserName;
    property Password:string read GetPassword write SetPassword;
    property Options: TSQLConnectionOptions read GetOptions write SetOptions;
    property Connected;
  end;

  { TfrxLazSqliteQuery }

  TfrxLazSqliteQuery = class(TfrxCustomQuery)
  private
    FDatabase: TfrxLazSqliteDatabase;
    FQuery: TSqlQuery;
    procedure SetDatabase(const Value: TfrxLazSqliteDatabase);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetMaster(const Value: TDataSource); override;
    procedure SetSQL(Value: TStrings); override;
    function GetSQL: TStrings; override;
  public
    constructor Create(AOwner: TComponent); override;
    constructor DesignCreate(AOwner: TComponent; Flags: Word); override;
    class function GetDescription: String; override;
    procedure BeforeStartReport; override;
    procedure UpdateParams; override;
    property Query: TSqlQuery read FQuery;
  published
    property Database: TfrxLazSqliteDatabase read FDatabase write SetDatabase;
  end;



var
  LazSqliteComponents: TfrxLazSqliteComponents;

procedure Register;


implementation
end.

