
{******************************************}
{                                          }
{             FastScript v1.9              }
{    Classes.pas classes and functions     }
{                                          }
{  (c) 2003-2007 by Alexander Tzyganenko,  }
{             Fast Reports Inc             }
{                                          }
{******************************************}

//VCL uses section
{$IFNDEF FMX}
unit fs_iclassesrtti;

interface

{$i fs.inc}

uses SysUtils, Classes, fs_iinterpreter, fs_xml{$IFDEF DELPHI16}, Controls{$ENDIF}
{$IFDEF DELPHI16}
  , System.Types
{$ENDIF};
//FMX USES
{$ELSE}
interface

{$i fs.inc}

uses System.SysUtils, System.Classes, FMX.fs_iinterpreter, FMX.fs_xml, System.Types, FMX.Types, System.UITypes
{$IFDEF DELPHI20}
	,System.Math.Vectors
{$ENDIF};
{$ENDIF}

type
{$i frxPlatformsAttribute.inc}
  TfsClassesRTTI = class(TComponent); // fake component
{$IFDEF FMX}
{ wrappers for most using structures }
  TfsRectF = class(TPersistent)
  private
    FRectF: TRectF;
    function GetBottom: Single;
    function GetLeft: Single;
    function GetRight: Single;
    function GetTop: Single;
    procedure SetBottom(const Value: Single);
    procedure SetLeft(const Value: Single);
    procedure SetRight(const Value: Single);
    procedure SetTop(const Value: Single);
  public
    function GetRect: TRectF;
    function GetRectP: PRectF;
    constructor Create(aRectF: TRectF);
  published
    property Left: Single read GetLeft write SetLeft;
    property Top: Single read GetTop write SetTop;
    property Right: Single read GetRight write SetRight;
    property Bottom: Single read GetBottom write SetBottom;
  end;

  TfsMatrix = class(TPersistent)
  private
    FMatrix: TMatrix;
    function Getm11: Single;
    function Getm12: Single;
    function Getm13: Single;
    function Getm21: Single;
    function Getm22: Single;
    function Getm23: Single;
    function Getm31: Single;
    function Getm32: Single;
    function Getm33: Single;
    procedure Setm11(const Value: Single);
    procedure Setm12(const Value: Single);
    procedure Setm13(const Value: Single);
    procedure Setm21(const Value: Single);
    procedure Setm22(const Value: Single);
    procedure Setm23(const Value: Single);
    procedure Setm31(const Value: Single);
    procedure Setm32(const Value: Single);
    procedure Setm33(const Value: Single);
  public
    procedure AssignToRect(var Rect: TMatrix);
    procedure AssignFromRect(Rect: TMatrix);
    function GetRect: TMatrix;
    constructor Create(aMatrix: TMatrix);
  published
    property m11: Single read Getm11 write Setm11;
    property m12: Single read Getm12 write Setm12;
    property m13: Single read Getm13 write Setm13;
    property m21: Single read Getm21 write Setm21;
    property m22: Single read Getm22 write Setm22;
    property m23: Single read Getm23 write Setm23;
    property m31: Single read Getm31 write Setm31;
    property m32: Single read Getm32 write Setm32;
    property m33: Single read Getm33 write Setm33;
  end;

  TfsPointF = class(TPersistent)
  private
    FPointF: TPointF;
    function GetX: Single;
    function GetY: Single;
    procedure SetX(const Value: Single);
    procedure SetY(const Value: Single);
  public
    function GetRect: TPointF;
    function GetRectP: PPointF;
    constructor Create(aPointF: TPointF);
  published
    property pX: Single read GetX write SetX;
    property pY: Single read GetY write SetY;
  end;

  PVector = ^TVector;
  TfsVector = class(TPersistent)
  private
    FVector: TVector;
    function GetW: Single;
    function GetX: Single;
    function GetY: Single;
    procedure SetW(const Value: Single);
    procedure SetX(const Value: Single);
    procedure SetY(const Value: Single);
  public
    function GetRect: TVector;
    function GetRectP: PVector;
    constructor Create(aVector: TVector);
  published
    property pX: Single read GetX write SetX;
    property pY: Single read GetY write SetY;
    property pW: Single read GetW write SetW;
  end;
{$ENDIF}


implementation
end.
