{******************************************}
{                                          }
{             FastReport VCL               }
{         Win platform routines            }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frLazGraphicUtils;

interface

{$I frVer.inc}

uses
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, frLazGraphicClasses,
{$ENDIF}
{$IFDEF FPC}
  LazGraphicHelper,
{$ENDIF}
  Messages, Classes, Graphics, frCore, frBaseGraphicsTypes,
{$IFDEF DELPHI16}
  System.UITypes,
{$ENDIF}
  SysUtils;

procedure PlatformApplyMask(MaskBM: TBitmap; SourceBM: TBitmap; MaskColor: TColor; InvertMask: Boolean = True);
function PlatformIsBlendingCompatibleDevice(aHandle: TfrHandle): Boolean;
procedure PlatformDrawGraphic(Canvas: TCanvas; DestRect: TRect; aGraph: TGraphic;
  IsPrinting, Smooth, Transparent: Boolean; TransparentColor: TColor; Alpha: TBitmap);

procedure PlatformDrawGraphicBlend(Canvas: TCanvas; Area: TRect; PF32: TBitmap; Quality: TfrxGraphicQuality);
procedure PlatformGetDisplayScale(DevHandle: TfrHandle; IsPrinterHandle: Boolean; var aScaleX, aScaleY: Extended); overload;

implementation
end.
