
{******************************************}
{                                          }
{             FastReport VCL               }
{                CSS Style                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}
unit frCSSStyle;

interface

{$I frVer.inc}

uses
  Classes;

type
  TfrxCSSStyle = class(TPersistent)
  private
    FKeys: TStrings;
    FValues: TStrings;
    FName: string;

    function GetStyle(const Key: string): string;
    procedure SetStyle(const Key, Value: string);
    procedure SetPrefixStyle(Index: string; const Value: string);
  public
    constructor Create;
    destructor Destroy; override;
    function This: TfrxCSSStyle;
    procedure AssignTo(Dest: TPersistent); override;
    procedure Clear;

    procedure SetValuesFromText(const Text: string);
    function IsHasKey(Key: string): Boolean;
    function Count: Integer;
    function Text(Formatted: Boolean = False): string;

    property Style[const Key: string]: string read GetStyle write SetStyle; default;
    property PrefixStyle[Index: string]: string write SetPrefixStyle;
    property Name: string read FName write FName;
  end;

  TfrxCSSList = class(TObject)
  private
    FStyles: TList;
    function GetCount: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Clear;
    procedure Assign(SourceStyleList: TfrxCSSList);
    procedure Save(Stream: TStream; Formatted: Boolean);

    function AddStyle(Style: TfrxCSSStyle): string;
    function AddName(const Name: string; Values: string = ''): TfrxCSSStyle;
    function AddText(const AStyle: string): Integer;

    function GetStyle(const Index: Integer): TfrxCSSStyle;
    function GetStyleByName(const Name: string): TfrxCSSStyle;

    property Count: Integer read GetCount;
  end;

implementation
end.
