{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{             Graphics Library             }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

      {******************************************************************}
      { GDIPPathText                                                     }
      {                                                                  }
      { home page : http://www.mwcs.de                                   }
      { email     : martin.walter@mwcs.de                                }
      {                                                                  }
      { date      : 30-11-2007                                           }
      {                                                                  }
      { version   : 1.0                                                  }
      {                                                                  }
      { Use of this file is permitted for commercial and non-commercial  }
      { use, as long as the author is credited.                          }
      { This file (c) 2007 Martin Walter                                 }
      {                                                                  }
      { This Software is distributed on an "AS IS" basis, WITHOUT        }
      { WARRANTY OF ANY KIND, either express or implied.                 }
      {                                                                  }
      { *****************************************************************}
      {               Adapted for FR 7 by Oleg Adibekov                  }
      { *****************************************************************}

unit frGDIPPathText;

interface

{$I frVer.inc}

uses
{$IFDEF DELPHI16}
  Winapi.GDIPOBJ,
  Winapi.GDIPAPI,
{$ELSE}
  frGDIPOBJ,
  frGDIPAPI,
{$ENDIF}
  frGDIPKerning;

type
  TPathPosition = Single;
  
  TGPPathText = class(TObject)
  private
    FRotation: Single;
    FGuidePath: TGPGraphicsPath;

    FFamily: TGPFontFamily;
    FStyle: Integer;
    FSize: Single;
    FFormat: TGPStringFormat;
    FDistanceFactor: Single;
    FKerningFactor: Single;
    FAdditionalMatrix: TGPMatrix;

    function AddGlyphToPath(const Path: TGPGraphicsPath; const Char: WideChar;
      const Family: TGPFontFamily; const Style: Integer; const Size: Single;
      const Origin: TGPPointF; const Format: TGPStringFormat): TStatus;

    function AddCharacter(const Current, Next: WideChar;
      const Path: TGPGraphicsPath; const Position: TPathPosition): TPathPosition;

    function GetPathPoint(const Position: TPathPosition): TGPPointF;
    function GetPathPointLength(const Position: TPathPosition): Single;
    function GetPathPosition(Indent: Single): TPathPosition;
    function FindRightPosition(CenterPos: TPathPosition;
      const Radius: Single): TPathPosition;
  protected
  public
    constructor Create(const GuidePath: TGPGraphicsPath);

    destructor Destroy; override;

    function AddPathText(const Path: TGPGraphicsPath;
      const Text: WideString; const Indent: Single;
      const Family: TGPFontFamily; Style: Integer;
      const Size: Single; const Format: TGPStringFormat;
      const DistanceFactor: Single = 1; const KerningFactor: Single = 1): Single;

    class function GetPathLength(const Path: TGPGraphicsPath): Single;

    property Rotation: Single read FRotation write FRotation;
    property AdditionalMatrix: TGPMatrix read FAdditionalMatrix write FAdditionalMatrix;
  end;

implementation
end.
