
{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{             Graphics Library             }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frGraphicPlatformHelper;

{$I frVer.inc}

interface

uses
  SysUtils,
{$IFNDEF Linux}
  Windows,
{$ELSE}
  LCLType, LCLIntf, frLazGraphicClasses,
{$ENDIF}
  Classes, Graphics, frBaseGraphicsTypes, frCore
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF}
;
procedure frxApplyMask(MaskBM: TBitmap; SourceBM: TBitmap; MaskColor: TColor; InvertMask: Boolean = True);
function IsBlendingCompatibleDevice(aHandle: TfrHandle): Boolean;
procedure frxDrawGraphic(Canvas: TCanvas; DestRect: TRect; aGraph: TGraphic;
  IsPrinting, Smooth, Transparent: Boolean; TransparentColor: TColor; Alpha: TBitmap);

procedure frxDrawGraphicBlend(Canvas: TCanvas; Area: TRect; PF32: TBitmap; Quality: TfrxGraphicQuality);
procedure GetDisplayScale(DevHandle: TfrHandle; IsPrinterHandle: Boolean; var aScaleX, aScaleY: Extended); overload;
procedure GetDisplayScale(var aScaleX, aScaleY: Extended); overload;

implementation
end.
