
{******************************************}
{                                          }
{             FastReport VCL               }
{               PrinterLin                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frPrinterLin;

interface

{$I frVer.inc}

uses
  SysUtils, Classes, Graphics, Forms, Printers, OSPrinters,
  LCLType, LCLIntf, LCLProc, Variants, PrintersDlgs, frCore, frPrinter,
  frBaseGraphicsTypes
{$IFDEF LCLGTK2}
   , CairoCanvas
{$ENDIF}
  ;

  type
  TfrxCustomPrinterLin = class(TfrxCustomPrinter)
  private
    {$IFDEF LCLGTK2}
    FCUPSPrinter:TPrinter;
    {$ENDIF}
  public
    constructor Create(const AName, APort: String); override;
    destructor Destroy; override;

    {$IFDEF LCLGTK2}
    function LCLPaperName(Tp: Integer): string;virtual; abstract;
    {$ENDIF}
    function IsDefaultDuplexActive: Boolean; override;

    property YDPI: Integer read FDPI.Y;
    property XDPI: Integer read FDPI.X;
    {$IFDEF LCLGTK2}
    property CUPSPrinter:TPrinter read FCUPSPrinter;
    {$ENDIF}
  end;

  TfrxPrinter = class(TfrxCustomPrinterLin)
  private
    FDeviceMode: TfrHandle;
    FDC: PtrUInt; // BeginDoc,EndDoc pair
    FDriver: String;
    FMode: PDeviceMode;
    procedure CreateDevMode;
    procedure FreeDevMode;
  public
    destructor Destroy; override;
    procedure Init; override;
    procedure Abort; override;
    procedure BeginDoc; override;
    procedure BeginPage; override;
    procedure BeginRAWDoc; override;
    procedure EndDoc; override;
    procedure EndPage; override;
    procedure EndRAWDoc; override;
    procedure WriteRAWDoc(const buf: AnsiString); override;
    procedure SetViewParams(APaperSize: Integer;
      APaperWidth, APaperHeight: Extended;
      AOrientation: TPrinterOrientation); override;
    procedure SetPrintParams(APaperSize: Integer;
      APaperWidth, APaperHeight: Extended; AOrientation: TPrinterOrientation;
      ABin, ADuplex, ACopies: Integer); override;
    procedure PropertiesDlg; override;
    class function GetDefaultPrinter: String; override;
    class procedure FillPrinters(APrinterList: TList; APrinters: TStrings); override;
    function UpdateDeviceCaps: Boolean;
    {$IFDEF LCLGTK2}
    function LCLPaperName(Tp: Integer): string; override;
    {$ENDIF}

    property DeviceMode: PDeviceMode read FMode;
  end;

  TfrxVirtualPrinter = class(TfrxCustomVirtualPrinter)
  public
    procedure FillPapers; override;
    procedure SetViewParams(APaperSize: Integer;
      APaperWidth, APaperHeight: Extended;
      AOrientation: TPrinterOrientation); override;
  end;

function ActualfrxGetPaperDimensions(PaperSize: Integer; var Width, Height: Extended): Boolean;

implementation
end.
