
{******************************************}
{                                          }
{             FastReport VCL               }
{               PrinterWin                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frPrinterWin;

interface

{$I frVer.inc}

uses 
  Windows, SysUtils, Types, Classes, Graphics, Forms, Printers,
  frCore, frPrinter
{$IFDEF FPC}
  ,LCLType, LCLIntf
{$ENDIF}
  ,SyncObjs
{$IFDEF DELPHI6}
, Variants
{$ENDIF};


type
  TfrxCustomPrinterWin = class(TfrxCustomPrinter)
  public
    constructor Create(const AName, APort: String); override;
    destructor Destroy; override;
  end;

  TfrxPrinter = class(TfrxCustomPrinterWin)
  private
    FDeviceMode: TfrHandle;
    FDC: HDC;
    FDriver: String;
    FMode: {$IFNDEF FPC}PDeviceMode{$ELSE}PDeviceModeW{$ENDIF};
    procedure CreateDevMode;
    procedure FreeDevMode;
    procedure GetDC;
  public
    destructor Destroy; override;
    procedure Init; override;
    procedure RecreateDC;
    procedure Abort; override;
    procedure BeginDoc; override;
    procedure BeginPage; override;
    procedure BeginRAWDoc; override;
    procedure EndDoc; override;
    procedure EndPage; override;
    procedure EndRAWDoc; override;
    procedure WriteRAWDoc(const buf: AnsiString); override;
    procedure SetViewParams(APaperSize: Integer;
      APaperWidth, APaperHeight: Extended;
      AOrientation: TPrinterOrientation); override;
    procedure SetPrintParams(APaperSize: Integer;
      APaperWidth, APaperHeight: Extended; AOrientation: TPrinterOrientation;
      ABin, ADuplex, ACopies: Integer); override;
    procedure PropertiesDlg; override;
    class function GetDefaultPrinter: String; override;
    class procedure FillPrinters(APrinterList: TList; APrinters: TStrings); override;
    function UpdateDeviceCaps: Boolean;
    property DeviceMode: {$IFNDEF FPC}PDeviceMode{$ELSE}PDeviceModeW{$ENDIF} read FMode;
  end;

  TfrxVirtualPrinter = TfrxCustomVirtualPrinter;

function ActualfrxGetPaperDimensions(PaperSize: Integer; var Width, Height: Extended): Boolean;

implementation
end.

