
{******************************************}
{                                          }
{             FastReport VCL               }
{             SVG Attributes               }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}
unit frSVGAttribute;

interface

{$I frVer.inc}

uses
  Classes, Types, Math,
  frSVGParse, frSVGComponents, frSVGHelpers, frSVGColor,
  frCSSTransform, frCSSStyle;

const
  DefaultBase = -MaxSingle; 

type
  TSVGAttributeObj = class (TPersistent)
  private
  protected
    FDefault: Boolean;
    FTL: TCSSSVGTransformList;

    FLengthPercentageAuto: TSVGLength;
    FColorSWRootDefault: TSVGColorSW;
    FPaintRootDefault: TSVGPaint;

    FIsForceObjectBoundingBoxPercent: Boolean;

    procedure SetDefault; virtual;
  public
    destructor Destroy; override;

    function IsCSS: Boolean; virtual; abstract;
    function IsDefault: Boolean;
    function IsPercent: Boolean; virtual; abstract;
    function IsCanReadSVGValue(Style: TfrxCSSStyle): Boolean; virtual; abstract;

    procedure PartToPercent; virtual; abstract;
    procedure SetTransform(Matrix: TSVGTransform);

    function GetAlpha: Single; virtual; abstract;
    function GetBounds: TSingleBounds; virtual; abstract;

    function GetLength(Base: Single = DefaultBase): Single; virtual; abstract;
    function GetLengthAuto(Base: Single = DefaultBase): Single; virtual; abstract;
    procedure SetLengthAuto(Value: Single);
    procedure SetLengthSW(LengthSW: TSVGLengthSW); virtual; abstract;
    function GetLengthInherit: TSVGLengthSW; virtual; abstract;
    function GetLengthList: TSingleDynArray; virtual; abstract;
    function GetLengthListNoneInherit(out Value: TSingleDynArray): TSVGSpecificWord; virtual; abstract;

    function GetNumber: Single; virtual; abstract;
    function GetNumberSW: TNumberSW; virtual; abstract;
    function GetFontWeight: TNumberSW; virtual; abstract;

    function GetColorCurrent: TSVGColorSW; virtual; abstract;
    function GetColorInherit: TSVGColorSW; virtual; abstract;

    function GetPaint: TSVGPaint; virtual; abstract;

    function GetSinglePointDynSrray: TSinglePointDynArray; virtual; abstract;

    function GetSpecificWord: TSVGSpecificWord; virtual; abstract;
    function GetSpecificWordSet: TSVGSpecificWordSet; virtual; abstract;

    function GetString: string; virtual; abstract;
    function GetStringInherit: TSVGStringSW; virtual; abstract;
    function GetURI: string; virtual; abstract;

    function GetPreserveAspectRatio: TSVGPreserveAspectRatio; virtual; abstract;

    function GetTransform: TSVGTransform; virtual; abstract;
  end;

function CreateAttribute(ElementObj: pointer; Attribute: TSVGAttribute): TSVGAttributeObj;

implementation
end.

