
{******************************************}
{                                          }
{             FastReport VCL               }
{               SVG Colors                 }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frSVGColor;

interface

{$I frVer.inc}

uses
  Graphics,
  frSVGComponents;

type
  TSVGColor = record
    R, G, B: Byte; Alpha: Single;
  end;

  TSVGColorSW = record
    SW: TSVGSpecificWord;
    R, G, B: Byte; Alpha: Single;
  end;

  TSVGPaint = record
    SW: TSVGSpecificWord;
    case Byte of
      0: (R, G, B: Byte; Alpha: Single);
      1: (URI: string[255]);
  end;

procedure ParsePaint(const S: string; var Value: TSVGPaint);

procedure ParseColor(const S: string; var Value: TSVGColor);

procedure ParseColorSW(const S: string; SW: TSVGSpecificWord; var Value: TSVGColorSW);

const
  SVGColorBlack: TSVGColor = (R: 0; G: 0; B: 0; Alpha: 1.0);
  SVGColorTransparent: TSVGColor = (R: 0; G: 0; B: 0; Alpha: 0.0);
  SVGColorSWBlack: TSVGColorSW = (SW: frx_noMater; R: 0; G: 0; B: 0; Alpha: 1.0);
  SVGColorInherit: TSVGColorSW = (SW: svg_inherit);
  SVGPaintInherit: TSVGPaint = (SW: svg_inherit);

  DefaultStroke: TSVGPaint = (SW: svg_none);
  DefaultFill: TSVGPaint = (SW: frx_RGBA; R: 0; G: 0; B: 0; Alpha: 1.0);


function ToSVGColor(R, G, B: Byte; Alpha: Single): TSVGColor; overload;
function ToSVGColor(SVGPaint: TSVGPaint; Opacity: Single = 1.0): TSVGColor; overload;
function ToSVGColor(SVGColorSW: TSVGColorSW): TSVGColor; overload;

function ToSVGPaint(C: TSVGColor): TSVGPaint;

function HSL2Color(H, S, L: Single): TColor; // 0..360, 0..100, 0..100

implementation
end.
