
{******************************************}
{                                          }
{             FastReport VCL               }
{            SVG paint servers             }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frSVGPaint;

interface

{$I frVer.inc}

uses
  Windows, Graphics,
  frSVGCanvas, frSVGHelpers, frSVGBase, frSVGColor,
  frSVGElement, frSVGComponents;

type
  Tel_stop = class(TSVGElementObj)
  protected
    function New(Parent: TSVGElementObj): TSVGElementObj; override;
  public
    constructor Create; override;
    function GetStopData: TSVGGradientStopData;
  end;

  TSVGGradient = class(TSVGElementObj)
  private
    FHrefObj: TSVGGradient;
  protected
    FUser: TSVGElementObj;

    function GetGradientArray(Opacity: Single): TSVGGradientArray; virtual;
    procedure SurePercent(AA: array of TSVGAttribute);
  public
    procedure GetGradientData(Opacity: Single; const User: TSVGElementObj; out GData: TSVGGradientData); virtual;

    property User: TSVGElementObj read FUser;
  end;

  Tel_linearGradient = class(TSVGGradient)
  protected
    function New(Parent: TSVGElementObj): TSVGElementObj; override;
  public
    constructor Create; override;

    procedure GetGradientData(Opacity: Single; const User: TSVGElementObj; out GData: TSVGGradientData); override;
  end;

  Tel_radialGradient = class(TSVGGradient)
  protected
    function New(Parent: TSVGElementObj): TSVGElementObj; override;
  public
    constructor Create; override;

    procedure GetGradientData(Opacity: Single; const User: TSVGElementObj; out GData: TSVGGradientData); override;
  end;

  Tel_pattern = class(Tel_svg)
  protected
    FUser: TSVGElementObj;
    FPatternFactor: Single;

    function New(Parent: TSVGElementObj): TSVGElementObj; override;
    function CalcXYTranslation(X, Y: Single): TSVGTransform; override;
    function GetViewBox: TSingleBounds; override;

    function CreateBitmap32(W, H: Single; out StartIndex, Size: Integer): TBitmap;
    procedure SetOpacityBitmap32(Bitmap: TBitmap; StartIndex, Size: Integer; Opacity: Single);

    function GetPatternFactor: Single; override;
    procedure CalcPatternFactor;
  public
    constructor Create; override;
    function IsForceLengthToPercent: Boolean; override;

    function CalcFillOpacity: Single; override;
    function CalcStrokeOpacity: Single; override;

    procedure GetPatternData(Opacity: Single; const User: TSVGElementObj; out PData: TSVGPatternData);

    property User: TSVGElementObj read FUser;
  end;

implementation
end.
