
{******************************************}
{                                          }
{             FastReport VCL               }
{            EMF to SVG Export             }
{                                          }
{         Copyright (c) 1998-2021          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frVectorCanvas;
{$I frVer.inc}
interface

uses
  Contnrs,
{$IFNDEF FPC}
  Windows,
{$ELSE}
  LCLType, LCLIntf, LCLProc,
{$ENDIF}
  Classes, Types, Graphics;

type
  TVectorCanvas = class(TObjectList)
  public
    constructor Create;
    {$IFNDEF FPC}
    procedure ExtTextOutW(X, Y: Integer; Options: Longint; Rect: PRect;
      Str: Pointer {PWideStr}; aCount: Longint; Dx: PInteger);
    procedure ExtTextOutA(X, Y: Integer; Options: Longint; Rect: PRect;
      Str: Pointer {PAnsiStr}; aCount: Longint; Dx: PInteger);
    {$ELSE}
    procedure ExtTextOut(X, Y: Integer; Options: Longint; Rect: PRect;
      Str: PChar; aCount: Longint; Dx: PInteger; Font: TFont);
    {$ENDIF}
  end;

  TCharacterDistance = array of Integer;
  // https://docs.microsoft.com/ru-ru/windows/desktop/api/wingdi/nf-wingdi-exttextoutw
  // https://docs.microsoft.com/ru-ru/windows/desktop/api/wingdi/nf-wingdi-exttextouta

  TVector_ExtTextOut = class
  private
    FX: Integer;
    FY: Integer;
    FOptions: Longint;
    FRect: TRect;
    FDx: TCharacterDistance;
    FStr: {$IFDEF FPCUNICODE}String{$ELSE}WideString{$ENDIF};
  public
    constructor Create(AX, AY: Integer; AOptions: Longint; ARect: PRect;
      ACount: Longint; ADx: PInteger);
    destructor Destroy; override;
    function AsString: String;
    function TextLength: Integer;

    property X: Integer read FX;
    property Y: Integer read FY;
    property Options: Longint read FOptions;
    property Rect: TRect read FRect;
    property Dx: TCharacterDistance read FDx;
    property Str: {$IFDEF FPCUNICODE}String{$ELSE}WideString{$ENDIF} read FStr;
  end;
{$IFNDEF FPC}
  TVector_ExtTextOutW = class (TVector_ExtTextOut)
  public
    constructor Create(AX, AY: Integer; AOptions: Longint; ARect: PRect;
      AStr: Pointer {PWideStr}; ACount: Longint; ADx: PInteger);
  end;

  TVector_ExtTextOutA = class (TVector_ExtTextOut)
  public
    constructor Create(AX, AY: Integer; AOptions: Longint; ARect: PRect;
      AStr: Pointer {PAnsiStr}; ACount: Longint; ADx: PInteger);
  end;
{$ELSE}
  TLazVector_ExtTextOut = class (TVector_ExtTextOut)
  private
    FFont: TFont;
  public
    constructor Create(AX, AY: Integer; AOptions: Longint; ARect: PRect;
      AStr: PChar; ACount: Longint; ADx: PInteger; AFont: TFont);
    destructor Destroy; override;
    property Font: TFont read FFont;
  end;
{$ENDIF}

  function isFRExtTextOut(VCO: TObject): Boolean;

implementation
end.
