
{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{             Graphics Library             }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

unit frWinGraphicUtils;

{$I frVer.inc}

interface

uses
  SysUtils, Windows, Messages,
  Classes, Graphics, frBaseGraphicsTypes, frCore
{$IFDEF DELPHI16}
, System.UITypes
{$ENDIF}
;
procedure PlatformApplyMask(MaskBM: TBitmap; SourceBM: TBitmap; MaskColor: TColor; InvertMask: Boolean = True);
function PlatformIsBlendingCompatibleDevice(aHandle: TfrHandle): Boolean;
procedure PlatformDrawGraphic(Canvas: TCanvas; DestRect: TRect; aGraph: TGraphic;
  IsPrinting, Smooth, Transparent: Boolean; TransparentColor: TColor; Alpha: TBitmap);

procedure PlatformDrawGraphicBlend(Canvas: TCanvas; Area: TRect; PF32: TBitmap; Quality: TfrxGraphicQuality);
procedure PlatformGetDisplayScale(DevHandle: TfrHandle; IsPrinterHandle: Boolean; var aScaleX, aScaleY: Extended); overload;

implementation
end.
