{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{           Localization Library           }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

{$IFNDEF FMX}
unit frLocalization;
{$ENDIF}

interface

{$I frVer.inc}

uses
  SysUtils,
{$IFNDEF FMX}
  Types, Classes,
  frCoreClasses, frResources;
{$ELSE}
  System.Types, System.Classes,
  FMX.frCoreClasses, FMX.frResources;
{$ENDIF}

type
  TfrLanguage = type string;

  { TfrLocalizationController }

{$IFDEF DELPHI16}
  {$IFDEF FMX}
    {$IFDEF DELPHI26}
      [ComponentPlatformsAttribute(pidWin32 or pidWin64 or pidOSX32 or pidOSX64)]
    {$ELSE}
      [ComponentPlatformsAttribute(pidWin32 or pidWin64 or pidOSX32)]
    {$ENDIF}
  {$ELSE}
    [ComponentPlatformsAttribute(pidWin32 or pidWin64)]
  {$ENDIF}
{$ENDIF}
  TfrLocalizationController = class(TfrCustomComponent)
  strict private
    function GetLanguage: TfrLanguage;
    procedure SetLanguage(const Value: TfrLanguage);
  private
    function IsStored: Boolean;
{$IF NOT DEFINED(FMX) OR DEFINED(DELPHI25)}
  public
    procedure ShowLocalizationEditor;
{$IFEND}
  published
    property Language: TfrLanguage read GetLanguage write SetLanguage stored IsStored;
  end;

  { TfrAvailableLanguagesController }

  TfrAvailableLanguagesController = class
  private class var
    FValues: TfrStringDictionary;
    class function GetValues: TfrStringDictionary; static;
  protected
    class procedure Finalize; static;
    class property Values: TfrStringDictionary read GetValues;
  public
    class procedure RegisterLanguageUnit(const ALanguage, AUnit: string); static;
    class procedure UnregisterLanguageUnit(const ALanguage, AUnit: string); static;

    class function GetDefaultLanguageName: string;
    class function GetLanguages: TStringDynArray; static;

    class function FindUnit(const ALanguage: string; out AUnit: string): Boolean; static;
    class function Empty: Boolean; static;
  end;

implementation
end.
