{******************************************}
{                                          }
{          FastReport VCL/FMX/LCL          }
{           Localization Library           }
{                                          }
{         Copyright (c) 1998-2022          }
{            by Fast Reports Inc.          }
{                                          }
{******************************************}

{$IFNDEF FMX}
unit frLocalizationReg;
{$ENDIF}

interface

{$I frVer.inc}

uses
{$IFNDEF FPC}
  DesignMenus, DesignEditors, DesignIntf, ToolsAPI,
{$ELSE}
  PropEdits, ComponentEditors,
{$ENDIF}
{$IFNDEF FMX}
  Types, Classes,
  Menus,
  frCoreReg,
  frCoreClasses,
  frResources,
  frLocalization,
{$ELSE}
  System.Types, System.Classes,
  FMX.Types,
  FMX.frCoreReg,
  FMX.frCoreClasses,
  FMX.frResources,
  FMX.frLocalization,
{$ENDIF}
  SysUtils;

{$IF NOT DEFINED(FPC) AND NOT DEFINED(FMX)}
type

  { TfrLocalizationEditorMenu }

  TfrLocalizationEditorMenu = class(TObject)
  strict private const
    FMenuName: string = 'ToolsMenu';
    FMenuItemName: string = 'ToolsToolsItem';
  strict private
    FMenuItem: TMenuItem;
    function GetProjectMenuItem: TMenuItem;
    procedure DoMenuItemClick(Sender: TObject);
  protected
    procedure AddIcon(AParent, AItem: TMenuItem);
    function CalcMenuItemPosition(AParent: TMenuItem): Integer;
    function CreateMenuItem(AParent: TMenuItem): TMenuItem;
    function FindMenuItemByName(AParent: TMenuItem; const AName: string): TMenuItem;
  public
    constructor Create; virtual;
    destructor Destroy; override;

    property MenuItem: TMenuItem read FMenuItem;
    property ProjectMenuItem: TMenuItem read GetProjectMenuItem;
  end;
{$IFEND}


procedure Register;

implementation
end.
